/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XXXConsole.java,v 1.6 1999/08/25 18:04:14 graf Exp $
 */

// NOT YET USED

package at.dms.ikjc;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.util.Hashtable;
import at.dms.kjc.*;

/**
 * This class shows the progression of compilation
 */
public class Console extends at.dms.kjc.Console {

  /**
   * Create a new console
   */
  public Console(PrintWriter err) {
    super(err); // not used
    JFrame	frame = new JFrame("Console");

    status = new JLabel("Waiting...");
    lights = new JPanel();
    lights.setLayout(new BoxLayout(lights, BoxLayout.Y_AXIS));
    lights.add(a = new JLabel("PARSING"));
    lights.add(b = new JLabel("CHECKING INTERFACE"));
    lights.add(c = new JLabel("CHECKING BODY"));
    lights.add(d = new JLabel("OPTIMIZING"));
    a.setIcon(iconOff);
    b.setIcon(iconOff);
    c.setIcon(iconOff);
    d.setIcon(iconOff);
    loaded = new JLabel("Loaded class:");
    prog1 = new JProgressBar();
    prog1.setString("Compilation");
    frame.getContentPane().setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.Y_AXIS));
    frame.getContentPane().add(new JLabel("iKJC The incremental Java Compiler at works"));
    frame.getContentPane().add(status);
    frame.getContentPane().add(lights);
    frame.getContentPane().add(loaded);
    frame.getContentPane().add(prog1);
    frame.setVisible(true);
    frame.pack();
  }

  /**
   * Starts the compiling process
   */
  public void compilationStarted(int files) {
    this.files = files;
    parsed = 0;
    checked1 = 0;
    checked2 = 0;
    generated = 0;
    prog1.setMinimum(0);
    prog1.setMaximum(100);
    status.setText("Working since 0 secs");
    lastTime = System.currentTimeMillis();
  }

  /**
   * file parsed
   */
  public void parseFile(long lastTime, String name) {
    if (parsed == 0) {
      a.setIcon(iconOn);
      status.setText("Working since " + getTime() + " secs");
    }
    if (++parsed > files) {
      files = parsed;
    }
    prog1.setValue(30 * parsed / files);
  }

  /**
   * file checked (interface)
   */
  public void checkInterface(long lastTime, String name) {
    if (checked1 == 0) {
      a.setIcon(iconOff);
      b.setIcon(iconOn);
      status.setText("Working since " + getTime() + " secs");
    }
    prog1.setValue(15 * checked1++ / files + 30);
  }

  /**
   * file checked (code)
   */
  public void checkBody(long lastTime, String name) {
    if (checked2 == 0) {
      b.setIcon(iconOff);
      c.setIcon(iconOn);
      status.setText("Working since " + getTime() + " secs");
    }
    prog1.setValue(40 * checked2++ / files + 45);
  }

  /**
   * class file generated
   */
  public void generateClassFile(long lastTime, String name) {
    if (generated == 0) {
      c.setIcon(iconOff);
      d.setIcon(iconOn);
      status.setText("Working since " + getTime() + " secs");
    }
    prog1.setValue(15 * generated++ / files + 85);
  }

  /**
   * file generated
   */
  public void generateJavaCode(String name) {
    if (generated == 0) {
      c.setIcon(iconOff);
      d.setIcon(iconOn);
    }
    prog1.setValue(15 * generated++ / files + 85);
  }

  /**
   * Ends the compiling process (if successful)
   */
  public void loadClass(String name) {
    loadedClasses.put(name, name);
    loaded.setText("Loaded class: " + loadedClasses.size());
  }

  /**
   * Ends the compiling process (if successful)
   */
  public void compilationEnded() {
    a.setIcon(iconOff);
    b.setIcon(iconOff);
    c.setIcon(iconOff);
    d.setIcon(iconOff);
    prog1.setValue(prog1.getMaximum());
  }

  // ----------------------------------------------------------------------
  // PRIVATE UTILITIES
  // ----------------------------------------------------------------------

  private long getTime() {
    return System.currentTimeMillis() - lastTime;
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private	Hashtable	loadedClasses = new Hashtable();
  private	JLabel		status;
  private	JPanel		lights;
  private	JLabel		loaded;
  private	JProgressBar	prog1;
  private	JProgressBar	prog2;
  private	JLabel		work;

  private	JLabel		a;
  private	JLabel		b;
  private	JLabel		c;
  private	JLabel		d;

  private	long		lastTime;
  private	int		parsed;
  private	int		checked1;
  private	int		checked2;
  private	int		generated;
  private	int		files;

  private /* static */ Icon iconOff = UIManager.getIcon("Tree.expandedIcon");
  private /* static */ Icon iconOn = UIManager.getIcon("Tree.collapsedIcon");
  // no static, because we do not want to load swing if there is no -console
}

