/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CBreakable.java,v 1.8 1999/09/08 20:08:11 graf Exp $
 */

package at.dms.kjc;

/**
 * Interface for all breakable statement
 */
public interface CBreakable {

  /**
   * Return the end of this block (for break statement)
   */
  CodeLabel getEnd();

  /**
   * Return the beginning of this block (for continue statement)
   */
  CodeLabel getContinue();

  /**
   * Prevent statement that there is at least one break
   */
  void addBreak(CBodyContext context);
}

