/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: CConstructorContext.java,v 1.18 1999/10/08 11:18:58 vgp Exp $
 */

package at.dms.kjc;

import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;

/**
 * This class represents a method context during check
 * @see CCompilationUnitContext
 * @see CClassContext
 * @see CMethodContext
 * @see CContext
 */
public class CConstructorContext extends CMethodContext {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * CConstructorContext
   * @param	parent		the parent context
   * @param	self		the corresponding method interface
   */
  public CConstructorContext(CClassContext parent, CMethod self) {
    super(parent, self);

    isSuperConstructorCalled = true;
  }

  /**
   * Verify that all checked exceptions are defined in the throw list
   * @exception UnpositionedError	this error will be positioned soon
   */
  public void close(TokenReference ref) throws PositionedError {

    if (getClassContext().getCClass().isAnnonymousClass()) {
      getCMethod().setThrowables(getThrowables());
    }

    super.close(ref);
  }

  /**
   *
   */
  public void setSuperConstructorCalled(boolean b) {
    isSuperConstructorCalled = b;
  }

  /**
   *
   */
  public boolean isSuperConstructorCalled() {
    return isSuperConstructorCalled;
  }

  /**
   * @param	field		the definition of a field
   * @return	a field info from a field definition in current context
   * @exception UnpositionedError	this error will be positioned soon
   *
  public int getFieldInfo(CField field) throws UnpositionedError {
    // special case of blank final
    try {
      if (!field.isStatic() &&
	  (field.getOwner() == getCMethod().getOwner() &&
	  parent.getClassContext().getCClass().lookupField(field.getIdent()) != null)) {
	// $$$ optimize
	return 0;/// !!!!!!!!!
      }
    } catch (UnpositionedError cue) {
      fail();
    }
    return parent.getFieldInfo(field);
  }
*/
  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private	boolean	isSuperConstructorCalled;
}
