/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Parser.java,v 1.9 1999/10/12 15:39:47 vgp Exp $
 */

package at.dms.kjc;

import java.util.Vector;

import at.dms.compiler.Compiler;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.compiler.JavaStyleComment;

/**
 * This class describes the capabilities of parsers.
 */
public abstract class Parser extends at.dms.compiler.Parser {

  // --------------------------------------------------------------------
  // CONSTRUCTORS
  // --------------------------------------------------------------------

  /**
   * Constructs a new parser instance.
   * @param	compiler	the invoking compiler.
   * @param	lexer		the token stream generator
   * @param	file		the file name	!!! NOT USED: REMOVE
   */
  protected Parser(Compiler compiler, CHandLexer lexer, String file, int lookahead) {
    super(compiler, lexer, lookahead);
  }

  // --------------------------------------------------------------------
  // ACCESSORS
  // --------------------------------------------------------------------

  /**
   *
   */
  protected final JJavadocComment getJavadocComment() {
    return ((CHandLexer)lexer).getJavadocComment();
  }
}
