/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Main.java,v 1.1 1999/10/16 23:25:22 vgp Exp $
 */

package at.dms.kopi;

import java.lang.reflect.*;

/**
 * Wrapper class for all KOPI software.
 *
 * @author Edouard G. Parmelan <edouard.parmelan@quadratec.fr>
 */
public class Main {
  public static void main(String args[]) {
    try {
      Class commandClass = Class.forName("at.dms." + args[0] + ".Main");
      
      /* Build main(String[])V */
      Class[] params = new Class[1];
      params[0] = (new String[0]).getClass();
      
      /* Build the invoke arguments */
      String[] mainArgs = new String[args.length - 1];
      System.arraycopy(args, 1, mainArgs, 0, args.length - 1);
      Object[] iargs = new Object[1];
      iargs[0] = (Object)mainArgs;
      
      /* Get method and invoke */
      Method meth = commandClass.getDeclaredMethod("main", params);
      meth.invoke(null, iargs);
    } catch (Exception e) {
      at.dms.kjc.Main.main(args);
    }
  }
}
