/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MJavaScanner.java,v 1.16 1999/10/08 11:19:03 vgp Exp $
 */

package at.dms.mkjc;

import antlr.Token;
import at.dms.compiler.CToken;
import at.dms.compiler.Compiler;
import at.dms.compiler.InputBuffer;
import at.dms.compiler.PositionedError;

/**
 * This is an handwritten lexer available for speed reason
 */
public class MJavaScanner extends at.dms.kjc.JavaScanner {
  /**
   * Constructor for a file in a char[]
   */
  public MJavaScanner(Compiler compiler, InputBuffer buffer) {
    super(compiler, buffer);
  }

  // Tokens are: Identifiers, Keywords, Literals, Separators, Operators.
  protected Token getToken() throws PositionedError {
    switch (buffer.data[buffer.pos]) {
    case '@': // KOPI ESCAPE
      buffer.pos++;
      return AT;
    default:
      return super.getToken();
    }
  }

  // ----------------------------------------------------------------------
  // KEYS
  // ----------------------------------------------------------------------

  private static final CToken	AT = new CToken(MJavaTokenTypes.AT, "@");
}
