/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MParseManager.java,v 1.11 1999/10/08 11:19:03 vgp Exp $
 */

package at.dms.mkjc;

import java.io.File;
import java.io.IOException;
import java.util.Stack;
import at.dms.kjc.ParseManager;
import at.dms.kjc.CHandLexer;
import at.dms.compiler.Compiler;

/**
 * This class manage paser switching between Java and SQL
 */
public class MParseManager extends ParseManager {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * This class manage paser switching between Java and SQL
   */
  protected MParseManager(Compiler compiler, File file, String name)
    throws IOException
  {
    super(compiler, file, name);
  }

  /**
   * Factory
   */
  public static MParseManager getMParseManager(Compiler compiler,
					       File file,
					       String name)
    throws IOException
  {
    return new MParseManager(compiler, file, name);
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Returns the java lexer
   */
  public CHandLexer getMJavaLexer() {
    if (mJavaLexer == null) {
      mJavaLexer = new MJavaScanner(compiler, buffer);
    }

    return mJavaLexer;
  }

  /**
   * Returns the java parser
   */
  public MJavaParser getMJavaParser() {
    return new MJavaParser(compiler, getMJavaLexer(), buffer.file);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private CHandLexer		mJavaLexer;
}
