/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: MStatement.java,v 1.10 1999/10/08 11:19:03 vgp Exp $
 */

package at.dms.mkjc;

import at.dms.kjc.CBodyContext;
import at.dms.kjc.CJavaPrettyPrinter;
import at.dms.kjc.CodeSequence;
import at.dms.kjc.JStatement;
import at.dms.compiler.TokenReference;

/**
 * This statement is a root class for extension statements
 */
public class MStatement extends JStatement {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Construct a node in the parsing tree
   * @param	where		the line of this node in the source code
   */
  public MStatement(TokenReference where, int num) {
    super(where, null);
    this.num = num;
  }

  // ----------------------------------------------------------------------
  // CODE CHECKING
  // ----------------------------------------------------------------------

  /**
   * Check statement.
   *
   * @param	context		the actual context of analyse
   * @exception	PositionedError		if the check fails
   */
  public final void checkStatement(CBodyContext context) {
    //
  }

  // ----------------------------------------------------------------------
  // CODE GENERATION
  // ----------------------------------------------------------------------

  /**
   * Generate the code in pure java form
   * It is usefull to debug and tune compilation process
   * @param	p		the printwriter into the code is generated
   */
  public final void genJavaCode(CJavaPrettyPrinter p) {
    ((CMacroJavaPrettyPrinter)p).getPrintWriter().print("stmts[" + num + "]");
  }

  /**
   * Generates a sequence of bytescodes
   * @param	code		the code list
   */
  public final void genCode(CodeSequence code) {
    impl.genCode(code);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private JStatement		impl;
  private int			num;
}
