/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: mjava.g,v 1.22 1999/10/12 15:39:47 vgp Exp $
 */

// Import the necessary classes
header { package at.dms.mkjc; }
{
  import java.util.Vector;

  import at.dms.kjc.*;

  import at.dms.compiler.Compiler;
  import at.dms.compiler.PositionedError;
  import at.dms.compiler.TokenReference;
  import at.dms.compiler.JavaStyleComment;
  import at.dms.compiler.CWarning;
  import at.dms.util.VectorCache;
}

// ----------------------------------------------------------------------
// THE PARSER STARTS HERE
// ----------------------------------------------------------------------

class MJavaParser extends JavaParser;

options {
  k = 2;				// two token lookahead
  importVocab = MJava;			// Call its vocabulary "Java"
  exportVocab = MJava;			// Call its vocabulary "Java"
  codeGenMakeSwitchThreshold = 2;	// Some optimizations
  codeGenBitsetTestThreshold = 3;
  defaultErrorHandler = false;		// Don't generate parser error handlers
  superClass="at.dms.kjc.Parser";
}
{
  public MJavaParser(Compiler compiler, CHandLexer lexer, String file) {
    super(compiler, lexer, file, MAX_LOOKAHEAD);
  }
}

// //////////////////////////////////////////////////////////////////////
// MACRO EXPRESSION & STATEMENT
// //////////////////////////////////////////////////////////////////////

jExpression []
  returns [JExpression self = null]
{
  int			operator = -1;
  JExpression		right;
}
:
  self = jConditionalExpression[]
  (
    operator = jAssignmentOperator[] right = jExpression[]
      { self = JAssignmentExpression.create(self.getTokenReference(), operator, self, right); }
  )?
|
  self = mMacroExpression[]
;

jStatement []
  returns [JStatement self = null]
:
  self = jEmptyStatement[]
|
  self = jLabeledStatement[]
|
  self = jBlock[]
|
  self = jExpressionStatement[]
|
  self = jSwitchStatement[]
|
  self = jIfStatement[]
|
  self = jWhileStatement[]
|
  self = jDoStatement[]
|
  self = jForStatement[]
|
  self = jBreakStatement[]
|
  self = jContinueStatement[]
|
  self = jReturnStatement[]
|
  self = jThrowStatement[]
|
  self = jSynchronizedStatement[]
|
  self = jTryStatement[]
|
  self = mMacroStatement[]
;

mMacroStatement []
  returns [JStatement self = null]
{
  TokenReference	sourceRef = buildTokenReference();
}
:
  PERCENT LBRACK i:INTEGER_LITERAL RBRACK
    { self = new MStatement(sourceRef, Integer.parseInt(i.getText())); }
;

mMacroExpression []
  returns [JExpression self = null]
{
  CType			type = null;
  TokenReference	sourceRef = buildTokenReference();
}
:
   PERCENT LPAREN type = jType[] RPAREN LBRACK i:INTEGER_LITERAL RBRACK
    { self = new MExpression(sourceRef, type, Integer.parseInt(i.getText())); }
;

dummy []
:
  AT
;

