/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: SCompilationUnit.java,v 1.17 1999/10/12 15:39:49 vgp Exp $
 */

package at.dms.sqlc;

import java.util.Vector;

import at.dms.compiler.Compiler;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.compiler.UnpositionedError;
import at.dms.compiler.UnpositionedError;

/**
 * This class represents a virtual file and is the main entry point in kopi grammar
 */
public class SCompilationUnit {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   */
  public SCompilationUnit(TokenReference ref) {
    this.ref = ref;
  }

  // ----------------------------------------------------------------------
  // TREE COLLECTING
  // ----------------------------------------------------------------------

  /**
   *
   */
  public void addStmt(Statement stmt) {
    elems_V.addElement(stmt);
  }

  // ----------------------------------------------------------------------
  // CODE CHECKING
  // ----------------------------------------------------------------------

  /**
   * This method provide a semantics check after parsing
   * Some optimization may be done here
   * @param context the context of analysis of this node
   * @exception	PositionedError	an error with reference to the source file
   */
  public void check() {
    // NO SEMANTIC CHECK HERE
  }

  // ----------------------------------------------------------------------
  // CODE GENERATION
  // ----------------------------------------------------------------------

  /**
   * Generate the code in pure java form
   * This is the backend of our compiler, we expect to generate byte code here
   * @param p the buffered printwriter on which we write code
   */
  public void genSQL() throws PositionedError {
    SqlPrettyPrinter spp = new SqlPrettyPrinter(ref.getFile());
    spp.printCUnit(elems_V);
    spp.close();
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private Vector	elems_V = new Vector();
  private TokenReference ref;
}
