/*
 * ANTLR-generated file resulting from grammar sql.g
 * 
 * Terence Parr, MageLang Institute
 * with John Lilley, Empathy Software
 * ANTLR Version 2.6.1; 1996-1999
 */
 package at.dms.sqlc; 
import java.io.IOException;
import antlr.TokenBuffer;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.ParserException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

  import java.util.Vector;

  import at.dms.compiler.Compiler;
  import at.dms.compiler.TokenReference;
  import at.dms.compiler.HandLexer;
  import at.dms.compiler.CWarning;

public class SQLParser extends at.dms.compiler.Parser
       implements SQLTokenTypes
 {

  public SQLParser(Compiler compiler, HandLexer lexer, String file) {
    super(compiler, lexer, MAX_LOOKAHEAD);
  }
// Generated by ANTLR
private static final int MAX_LOOKAHEAD = 2;
{
  tokenNames = _tokenNames;
}
// Generated by ANTLR

/**
 * This is the main entry point for the grammar
 */
	public final SCompilationUnit  sCompilationUnit(
		
	) throws ParserException, IOException {
		SCompilationUnit self;
		
		
		self = new SCompilationUnit(buildTokenReference());
		
		Statement	stmt = null;
		
		
		{
		int _cnt3=0;
		_loop3:
		do {
			switch ( LA(1)) {
			case LITERAL_SELECT:
			{
				stmt=sSelectStatement();
				if ( inputState.guessing==0 ) {
					self.addStmt(stmt);
				}
				break;
			}
			case LITERAL_INSERT:
			{
				stmt=sInsertStatement();
				if ( inputState.guessing==0 ) {
					self.addStmt(stmt);
				}
				break;
			}
			case LITERAL_UPDATE:
			{
				stmt=sUpdateStatement();
				if ( inputState.guessing==0 ) {
					self.addStmt(stmt);
				}
				break;
			}
			case LITERAL_DELETE:
			{
				stmt=sDeleteStatement();
				if ( inputState.guessing==0 ) {
					self.addStmt(stmt);
				}
				break;
			}
			case SEMICOLON:
			{
				match(SEMICOLON);
				break;
			}
			default:
			{
				if ( _cnt3>=1 ) { break _loop3; } else {throw new NoViableAltException(LT(1));}
			}
			}
			_cnt3++;
		} while (true);
		}
		match(Token.EOF_TYPE);
		return self;
	}
	
	public final SelectStatement  sSelectStatement(
		
	) throws ParserException, IOException {
		SelectStatement self = null;
		
		
		String		type = null;
		Vector		selectList;
		FromClause		fromClause;
		WhereClause		whereClause = null;
		GroupByClause		groupByClause = null;
		HavingClause		havingClause = null;
		SortSpec		sortSpec = null;
		UpdSpec		updateSpec = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_SELECT);
		{
		switch ( LA(1)) {
		case LITERAL_ALL:
		{
			match(LITERAL_ALL);
			if ( inputState.guessing==0 ) {
				type = "ALL";
			}
			break;
		}
		case LITERAL_DISTINCT:
		{
			match(LITERAL_DISTINCT);
			if ( inputState.guessing==0 ) {
				type = "DISTINCT";
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case STAR:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		selectList=sSelectList();
		fromClause=sFromClause();
		{
		switch ( LA(1)) {
		case LITERAL_WHERE:
		{
			whereClause=sWhereClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_FOR:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_ORDER:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_GROUP:
		{
			groupByClause=sGroupByClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_FOR:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_ORDER:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_HAVING:
		{
			havingClause=sHavingClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_FOR:
		case LITERAL_INSERT:
		case LITERAL_ORDER:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_ORDER:
		{
			sortSpec=sSortSpec();
			break;
		}
		case LITERAL_FOR:
		{
			updateSpec=sUpdSpec();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_INSERT:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			self = new SelectStatement(sourceRef,
						       type,
						       selectList,
						       fromClause,
						       whereClause,
						       groupByClause,
						       havingClause,
						       sortSpec,
						       updateSpec);
			
		}
		return self;
	}
	
	public final InsertStatement  sInsertStatement(
		
	) throws ParserException, IOException {
		InsertStatement self = null;
		
		
		String	p1;
		FieldNameList	p2 = null;
		InsertSource	p3;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_INSERT);
		match(LITERAL_INTO);
		p1=sIdentifier();
		{
		boolean synPredMatched70 = false;
		if (((LA(1)==LPAREN) && (LA(2)==DELIMITER_ID||LA(2)==STANDARD_ID))) {
			int _m70 = mark();
			synPredMatched70 = true;
			inputState.guessing++;
			try {
				{
				match(LPAREN);
				sFieldNameList();
				}
			}
			catch (ParserException pe) {
				synPredMatched70 = false;
			}
			rewind(_m70);
			inputState.guessing--;
		}
		if ( synPredMatched70 ) {
			match(LPAREN);
			p2=sFieldNameList();
			match(RPAREN);
		}
		else if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2)))) {
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
		}
		p3=sInsertSource();
		if ( inputState.guessing==0 ) {
			self = new InsertStatement(sourceRef, p1, p2, p3);
		}
		return self;
	}
	
	public final UpdateStatement  sUpdateStatement(
		
	) throws ParserException, IOException {
		UpdateStatement self = null;
		
		
		String	p1;
		String	p2 = null;
		Vector	p3;
		SearchCondition	p4 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_UPDATE);
		p1=sIdentifier();
		{
		switch ( LA(1)) {
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			p2=sIdentifier();
			break;
		}
		case LITERAL_SET:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_SET);
		p3=sAssignList();
		{
		switch ( LA(1)) {
		case LITERAL_WHERE:
		{
			{
			match(LITERAL_WHERE);
			{
			switch ( LA(1)) {
			case LITERAL_AVG:
			case LITERAL_BITNOT:
			case LITERAL_CASE:
			case LITERAL_CAST:
			case LITERAL_COUNT:
			case LITERAL_EXISTS:
			case LITERAL_FALSE:
			case LITERAL_IF:
			case LITERAL_MAX:
			case LITERAL_MIN:
			case LITERAL_NOT:
			case LITERAL_NULL:
			case LITERAL_SUM:
			case LITERAL_TRUE:
			case JDBC_DATE:
			case JDBC_FUNCTION:
			case JDBC_TIME:
			case JDBC_TIMESTAMP:
			case LBRACKET:
			case LPAREN:
			case MINUS:
			case PLUS:
			case BINCHAR_LIT:
			case BIT_LIT:
			case DELIMITER_ID:
			case INTEGER_LIT:
			case NUMERIC_LIT:
			case STANDARD_ID:
			case STRING_LIT:
			{
				p4=sSearchCondition();
				break;
			}
			case LITERAL_CURRENT:
			{
				match(LITERAL_CURRENT);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				self = new UpdateStatement(sourceRef, p1, p2, p3,p4);
			}
			}
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_INSERT:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			if ( inputState.guessing==0 ) {
				self = new UpdateStatement(sourceRef, p1, p2, p3);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final DeleteStatement  sDeleteStatement(
		
	) throws ParserException, IOException {
		DeleteStatement self = null;
		
		
		String p1;
		String p2 = null;
		SearchCondition p3 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_DELETE);
		match(LITERAL_FROM);
		p1=sIdentifier();
		{
		switch ( LA(1)) {
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			p2=sIdentifier();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_INSERT:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case LITERAL_WHERE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_WHERE:
		{
			match(LITERAL_WHERE);
			p3=sSearchCondition();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_INSERT:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
				self = new DeleteStatement(sourceRef,
				                           p1,
							   p2,
							   p3);
			
		}
		return self;
	}
	
	public final Vector  sSelectList(
		
	) throws ParserException, IOException {
		Vector self = new Vector();
		
		
		SelectElem	p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p=sSelectElem();
		if ( inputState.guessing==0 ) {
			self.addElement(p);
		}
		{
		_loop115:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sSelectElem();
				if ( inputState.guessing==0 ) {
					self.addElement(p);
				}
			}
			else {
				break _loop115;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final FromClause  sFromClause(
		
	) throws ParserException, IOException {
		FromClause self = null;
		
		
		Vector	 v = new Vector();
		SimpleTableReference p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_FROM);
		p=sSimpleTableReference();
		if ( inputState.guessing==0 ) {
			v.addElement(p);
		}
		{
		_loop55:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sSimpleTableReference();
				if ( inputState.guessing==0 ) {
					v.addElement(p);
				}
			}
			else {
				break _loop55;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new FromClause(sourceRef, v);
		}
		return self;
	}
	
	public final WhereClause  sWhereClause(
		
	) throws ParserException, IOException {
		WhereClause self = null;
		
		
		SearchCondition	p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_WHERE);
		p=sSearchCondition();
		if ( inputState.guessing==0 ) {
			self = new WhereClause(sourceRef, p);
		}
		return self;
	}
	
	public final GroupByClause  sGroupByClause(
		
	) throws ParserException, IOException {
		GroupByClause self = null;
		
		
		Vector	 v = new Vector();
		FieldReference	p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_GROUP);
		match(LITERAL_BY);
		p=sFieldReference();
		if ( inputState.guessing==0 ) {
			v.addElement(p);
		}
		{
		_loop58:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sFieldReference();
				if ( inputState.guessing==0 ) {
					v.addElement(p);
				}
			}
			else {
				break _loop58;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new GroupByClause(sourceRef, v);
		}
		return self;
	}
	
	public final HavingClause  sHavingClause(
		
	) throws ParserException, IOException {
		HavingClause self = null;
		
		
		SearchCondition	p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_HAVING);
		p=sSearchCondition();
		if ( inputState.guessing==0 ) {
			self = new HavingClause(sourceRef, p);
		}
		return self;
	}
	
	public final SortSpec  sSortSpec(
		
	) throws ParserException, IOException {
		SortSpec self = null;
		
		
		SortElem	p;
		Vector        v = new Vector();
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_ORDER);
		match(LITERAL_BY);
		p=sSortElem();
		if ( inputState.guessing==0 ) {
			v.addElement(p);
		}
		{
		_loop131:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sSortElem();
				if ( inputState.guessing==0 ) {
					v.addElement(p);
				}
			}
			else {
				break _loop131;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new SortSpec(sourceRef, v);
		}
		return self;
	}
	
	public final UpdSpec  sUpdSpec(
		
	) throws ParserException, IOException {
		UpdSpec self = null;
		
		
		String	    oper;
		CorrespondingSpec spec;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_FOR);
		match(LITERAL_UPDATE);
		if ( inputState.guessing==0 ) {
			self = new UpdSpec(sourceRef);
		}
		return self;
	}
	
	public final ArrayPrecision  sArrayPrecision(
		
	) throws ParserException, IOException {
		ArrayPrecision self = null;
		
		
		IntegerLiteral	p = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LPAREN);
		{
		switch ( LA(1)) {
		case INTEGER_LIT:
		{
			p=sIntegerLiteral();
			break;
		}
		case STAR:
		{
			match(STAR);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		if ( inputState.guessing==0 ) {
			self = new ArrayPrecision(sourceRef, p);
		}
		return self;
	}
	
	public final IntegerLiteral  sIntegerLiteral(
		
	) throws ParserException, IOException {
		IntegerLiteral self = null;
		
		Token  t = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		
		t = LT(1);
		match(INTEGER_LIT);
		if ( inputState.guessing==0 ) {
			self = new IntegerLiteral(sourceRef, new Integer(t.getText()));
		}
		return self;
	}
	
	public final Vector   sAssignList(
		
	) throws ParserException, IOException {
		Vector  self = new Vector();
		
		
		Assignment	p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p=sAssignment();
		if ( inputState.guessing==0 ) {
			self.addElement(p);
		}
		{
		_loop14:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sAssignment();
				if ( inputState.guessing==0 ) {
					self.addElement(p);
				}
			}
			else {
				break _loop14;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final Assignment  sAssignment(
		
	) throws ParserException, IOException {
		Assignment self = null;
		
		
		String p1;
		Expression p2;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p1=sIdentifier();
		match(ASSIGN);
		p2=sExpression();
		if ( inputState.guessing==0 ) {
			self = new Assignment(sourceRef, new SimpleIdentExpression(sourceRef, p1), p2);
		}
		return self;
	}
	
	public final String  sIdentifier(
		
	) throws ParserException, IOException {
		String self = null;
		
		Token  t1 = null;
		Token  t2 = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case STANDARD_ID:
		{
			t1 = LT(1);
			match(STANDARD_ID);
			if ( inputState.guessing==0 ) {
				self = t1.getText();
			}
			break;
		}
		case DELIMITER_ID:
		{
			t2 = LT(1);
			match(DELIMITER_ID);
			if ( inputState.guessing==0 ) {
				self = t2.getText();
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final Expression  sExpression(
		
	) throws ParserException, IOException {
		Expression self = null;
		
		
		Expression		right = null;
		int			op = 0;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sFactor();
		{
		_loop43:
		do {
			switch ( LA(1)) {
			case PLUS:
			{
				match(PLUS);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new PlusExpression(sourceRef, self, right);
				}
				break;
			}
			case MINUS:
			{
				match(MINUS);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new MinusExpression(sourceRef, self, right);
				}
				break;
			}
			case STAR:
			{
				match(STAR);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new StarExpression(sourceRef, self, right);
				}
				break;
			}
			case SLASH:
			{
				match(SLASH);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new SlashExpression(sourceRef, self, right);
				}
				break;
			}
			case LITERAL_BITAND:
			{
				match(LITERAL_BITAND);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new BitandExpression(sourceRef, self, right);
				}
				break;
			}
			case LITERAL_BITOR:
			{
				match(LITERAL_BITOR);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new BitorExpression(sourceRef, self, right);
				}
				break;
			}
			case DBLPIPE:
			{
				match(DBLPIPE);
				right=sFactor();
				if ( inputState.guessing==0 ) {
					self = new DbpipeExpression(sourceRef, self, right);
				}
				break;
			}
			default:
			{
				break _loop43;
			}
			}
		} while (true);
		}
		return self;
	}
	
	public final BetweenPredicate  sBetweenPredicate(
		
	) throws ParserException, IOException {
		BetweenPredicate self = null;
		
		
		Expression p1;
		String p2 = null;
		Expression p3;
		String p4 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_BETWEEN);
		p1=sExpression();
		{
		switch ( LA(1)) {
		case LITERAL_EXCLUSIVE:
		case LITERAL_INCLUSIVE:
		{
			p2=sBetweenQualifier();
			break;
		}
		case LITERAL_AND:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_AND);
		p3=sExpression();
		{
		switch ( LA(1)) {
		case LITERAL_EXCLUSIVE:
		case LITERAL_INCLUSIVE:
		{
			p4=sBetweenQualifier();
			break;
		}
		case EOF:
		case LITERAL_AND:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FOR:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_OR:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_THEN:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new BetweenPredicate(sourceRef, p1, p2, p3, p4);
		}
		return self;
	}
	
	public final String  sBetweenQualifier(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_INCLUSIVE:
		{
			match(LITERAL_INCLUSIVE);
			if ( inputState.guessing==0 ) {
				self = "INCLUSIVE";
			}
			break;
		}
		case LITERAL_EXCLUSIVE:
		{
			match(LITERAL_EXCLUSIVE);
			if ( inputState.guessing==0 ) {
				self = "EXCLUSIVE";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final String  sBoolOp(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_AND:
		{
			match(LITERAL_AND);
			if ( inputState.guessing==0 ) {
				self = "AND";
			}
			break;
		}
		case LITERAL_OR:
		{
			match(LITERAL_OR);
			if ( inputState.guessing==0 ) {
				self = "OR";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final CaseExpression  sCaseExpression(
		
	) throws ParserException, IOException {
		CaseExpression self = null;
		
		
		AbstractCaseExpression     p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_CASE);
		{
		switch ( LA(1)) {
		case LITERAL_WHEN:
		{
			p1=sSearchedCaseExpression();
			break;
		}
		case LITERAL_CASE:
		{
			p1=sSimpleCaseExpression();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_END);
		if ( inputState.guessing==0 ) {
			self = new CaseExpression(sourceRef,  p1);
		}
		return self;
	}
	
	public final SearchedCaseExpression  sSearchedCaseExpression(
		
	) throws ParserException, IOException {
		SearchedCaseExpression self = null;
		
		
		Expression	        p = null;
		Vector                conditions = new Vector();
		SearchedWhenClause    condition = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		int _cnt101=0;
		_loop101:
		do {
			if ((LA(1)==LITERAL_WHEN)) {
				condition=sSearchedWhenClause();
				if ( inputState.guessing==0 ) {
					conditions.addElement(condition);
				}
			}
			else {
				if ( _cnt101>=1 ) { break _loop101; } else {throw new NoViableAltException(LT(1));}
			}
			
			_cnt101++;
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_ELSE:
		{
			match(LITERAL_ELSE);
			p=sExpression();
			break;
		}
		case LITERAL_END:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			self = new SearchedCaseExpression(sourceRef, conditions, p);
			
		}
		return self;
	}
	
	public final SimpleCaseExpression  sSimpleCaseExpression(
		
	) throws ParserException, IOException {
		SimpleCaseExpression self = null;
		
		
		Expression	     p;
		Vector             conditions = new Vector();
		SimpleWhenClause   condition = null;
		Expression	     elseExpr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_CASE);
		p=sExpression();
		{
		int _cnt119=0;
		_loop119:
		do {
			if ((LA(1)==LITERAL_WHEN)) {
				condition=sSimpleWhenClause();
				if ( inputState.guessing==0 ) {
					conditions.addElement(condition);
				}
			}
			else {
				if ( _cnt119>=1 ) { break _loop119; } else {throw new NoViableAltException(LT(1));}
			}
			
			_cnt119++;
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_ELSE:
		{
			match(LITERAL_ELSE);
			elseExpr=sExpression();
			break;
		}
		case LITERAL_END:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_END);
		if ( inputState.guessing==0 ) {
			
			self = new SimpleCaseExpression(sourceRef, p, conditions, elseExpr);
			
		}
		return self;
	}
	
	public final CorrespondingSpec  sCorrespondingSpec(
		
	) throws ParserException, IOException {
		CorrespondingSpec self = null;
		
		
		FieldNameList p1 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_CORRESPONDING);
		{
		switch ( LA(1)) {
		case LITERAL_BY:
		{
			match(LITERAL_BY);
			match(LPAREN);
			p1=sFieldNameList();
			match(RPAREN);
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_EXISTS:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NOT:
		case LITERAL_NULL:
		case LITERAL_SELECT:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LBRACKET:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new CorrespondingSpec(sourceRef, p1);
		}
		return self;
	}
	
	public final FieldNameList  sFieldNameList(
		
	) throws ParserException, IOException {
		FieldNameList self = null;
		
		
		Vector		fields = new Vector();
		String		p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p=sIdentifier();
		if ( inputState.guessing==0 ) {
			fields.addElement(p);
		}
		{
		_loop50:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sIdentifier();
				if ( inputState.guessing==0 ) {
					fields.addElement(p);
				}
			}
			else {
				break _loop50;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new FieldNameList(sourceRef, fields);
		}
		return self;
	}
	
	public final Type  sDataType(
		
	) throws ParserException, IOException {
		Type self = null;
		
		
		ArrayPrecision prec= null;
		IntegerLiteral	exp1 = null;
		IntegerLiteral	exp2 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_TINYINT:
		{
			match(LITERAL_TINYINT);
			if ( inputState.guessing==0 ) {
				self = new TinyIntType(sourceRef);
			}
			break;
		}
		case LITERAL_SMALLINT:
		{
			match(LITERAL_SMALLINT);
			if ( inputState.guessing==0 ) {
				self = new SmallIntType(sourceRef);
			}
			break;
		}
		case LITERAL_INTEGER:
		{
			match(LITERAL_INTEGER);
			if ( inputState.guessing==0 ) {
				self = new IntegerType(sourceRef);
			}
			break;
		}
		case LITERAL_NUMERIC:
		{
			match(LITERAL_NUMERIC);
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				match(LPAREN);
				exp1=sIntegerLiteral();
				{
				switch ( LA(1)) {
				case COMMA:
				{
					match(COMMA);
					exp2=sIntegerLiteral();
					break;
				}
				case RPAREN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					self = new NumericType(sourceRef, exp1, exp2);
				}
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_AS:
			case LITERAL_BETWEEN:
			case LITERAL_BITAND:
			case LITERAL_BITOR:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_ELSE:
			case LITERAL_END:
			case LITERAL_ESCAPE:
			case LITERAL_EXCEPT:
			case LITERAL_EXCLUSIVE:
			case LITERAL_FI:
			case LITERAL_FOR:
			case LITERAL_FROM:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_IN:
			case LITERAL_INCLUSIVE:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_IS:
			case LITERAL_LEFT:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_SUBSET:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case LITERAL_WHEN:
			case LITERAL_WHERE:
			case ASSIGN:
			case COMMA:
			case DBLPIPE:
			case GE:
			case GT:
			case JDBC_ESCAPE:
			case LE:
			case LT:
			case MINUS:
			case NE:
			case PLUS:
			case RBRACKET:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			case SLASH:
			case STAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		case LITERAL_FLOAT:
		{
			match(LITERAL_FLOAT);
			if ( inputState.guessing==0 ) {
				self = new FloatType(sourceRef);
			}
			break;
		}
		case LITERAL_DOUBLE:
		{
			match(LITERAL_DOUBLE);
			if ( inputState.guessing==0 ) {
				self = new DoubleType(sourceRef);
			}
			break;
		}
		case LITERAL_REAL:
		{
			match(LITERAL_REAL);
			if ( inputState.guessing==0 ) {
				self = new RealType(sourceRef);
			}
			break;
		}
		case LITERAL_CHAR:
		{
			match(LITERAL_CHAR);
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				prec=sArrayPrecision();
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_AS:
			case LITERAL_BETWEEN:
			case LITERAL_BITAND:
			case LITERAL_BITOR:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_ELSE:
			case LITERAL_END:
			case LITERAL_ESCAPE:
			case LITERAL_EXCEPT:
			case LITERAL_EXCLUSIVE:
			case LITERAL_FI:
			case LITERAL_FOR:
			case LITERAL_FROM:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_IN:
			case LITERAL_INCLUSIVE:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_IS:
			case LITERAL_LEFT:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_SUBSET:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case LITERAL_WHEN:
			case LITERAL_WHERE:
			case ASSIGN:
			case COMMA:
			case DBLPIPE:
			case GE:
			case GT:
			case JDBC_ESCAPE:
			case LE:
			case LT:
			case MINUS:
			case NE:
			case PLUS:
			case RBRACKET:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			case SLASH:
			case STAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				self = new CharType(sourceRef, prec);
			}
			break;
		}
		case LITERAL_STRING:
		{
			match(LITERAL_STRING);
			if ( inputState.guessing==0 ) {
				self = new StringType(sourceRef);
			}
			break;
		}
		case LITERAL_BINCHAR:
		{
			match(LITERAL_BINCHAR);
			{
			switch ( LA(1)) {
			case LPAREN:
			{
				prec=sArrayPrecision();
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_AS:
			case LITERAL_BETWEEN:
			case LITERAL_BITAND:
			case LITERAL_BITOR:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_ELSE:
			case LITERAL_END:
			case LITERAL_ESCAPE:
			case LITERAL_EXCEPT:
			case LITERAL_EXCLUSIVE:
			case LITERAL_FI:
			case LITERAL_FOR:
			case LITERAL_FROM:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_IN:
			case LITERAL_INCLUSIVE:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_IS:
			case LITERAL_LEFT:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_SUBSET:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case LITERAL_WHEN:
			case LITERAL_WHERE:
			case ASSIGN:
			case COMMA:
			case DBLPIPE:
			case GE:
			case GT:
			case JDBC_ESCAPE:
			case LE:
			case LT:
			case MINUS:
			case NE:
			case PLUS:
			case RBRACKET:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			case SLASH:
			case STAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				self = new BinCharType(sourceRef, prec);
			}
			break;
		}
		case LITERAL_BITS:
		{
			match(LITERAL_BITS);
			prec=sArrayPrecision();
			if ( inputState.guessing==0 ) {
				self = new BitsType(sourceRef, prec);
			}
			break;
		}
		case LITERAL_BOOL:
		{
			match(LITERAL_BOOL);
			if ( inputState.guessing==0 ) {
				self = new BoolType(sourceRef);
			}
			break;
		}
		case LITERAL_BLOB:
		{
			match(LITERAL_BLOB);
			if ( inputState.guessing==0 ) {
				self = new BlobType(sourceRef);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final Type  sDataTypeSpec(
		
	) throws ParserException, IOException {
		Type self = null;
		
		
		String p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_BINCHAR:
		case LITERAL_BITS:
		case LITERAL_BLOB:
		case LITERAL_BOOL:
		case LITERAL_CHAR:
		case LITERAL_DOUBLE:
		case LITERAL_FLOAT:
		case LITERAL_INTEGER:
		case LITERAL_NUMERIC:
		case LITERAL_REAL:
		case LITERAL_SMALLINT:
		case LITERAL_STRING:
		case LITERAL_TINYINT:
		{
			self=sDataType();
			break;
		}
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			p1=sIdentifier();
			if ( inputState.guessing==0 ) {
				self = new TypeName(sourceRef, p1);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final SearchCondition  sSearchCondition(
		
	) throws ParserException, IOException {
		SearchCondition self = null;
		
		
		SearchCondition	right = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sBooleanTerm();
		{
		_loop94:
		do {
			if ((LA(1)==LITERAL_OR)) {
				match(LITERAL_OR);
				right=sBooleanTerm();
				if ( inputState.guessing==0 ) {
					self = new OrCondition(sourceRef, self, right);
				}
			}
			else {
				break _loop94;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final ExistsPredicate  sExistsPredicate(
		
	) throws ParserException, IOException {
		ExistsPredicate self = null;
		
		
		SubTableExpression p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_EXISTS);
		p1=sSubTableExpression();
		if ( inputState.guessing==0 ) {
			self = new ExistsPredicate(sourceRef, p1);
		}
		return self;
	}
	
	public final SubTableExpression  sSubTableExpression(
		
	) throws ParserException, IOException {
		SubTableExpression self = null;
		
		
		SubTable       left;
		UnidiffSpec	 spec;
		SubTable       right;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LPAREN);
		left=sSubTableTerm();
		{
		_loop134:
		do {
			if ((_tokenSet_2.member(LA(1)))) {
				spec=sUnidiffSpec();
				right=sSubTableTerm();
				if ( inputState.guessing==0 ) {
					left = new UnidiffTableTerm(sourceRef, spec, left, right);
				}
			}
			else {
				break _loop134;
			}
			
		} while (true);
		}
		match(RPAREN);
		if ( inputState.guessing==0 ) {
			self = new SubTableExpression(sourceRef, left);
		}
		return self;
	}
	
	public final Expression  sFactor(
		
	) throws ParserException, IOException {
		Expression self = null;
		
		
		int			op;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case PLUS:
		{
			match(PLUS);
			self=sPrimary();
			if ( inputState.guessing==0 ) {
				self = new UnaryPlusExpression(sourceRef, self);
			}
			break;
		}
		case MINUS:
		{
			match(MINUS);
			self=sPrimary();
			if ( inputState.guessing==0 ) {
				self = new UnaryMinusExpression(sourceRef, self);
			}
			break;
		}
		case LITERAL_BITNOT:
		{
			match(LITERAL_BITNOT);
			self=sPrimary();
			if ( inputState.guessing==0 ) {
				self = new BitnotExpression(sourceRef, self);
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			self=sPrimary();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final Expression  sPrimary(
		
	) throws ParserException, IOException {
		Expression self = null;
		
		
		Type right = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_AVG:
		case LITERAL_CASE:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			self=sSimplePrimary();
			{
			switch ( LA(1)) {
			case LITERAL_CAST:
			{
				match(LITERAL_CAST);
				right=sDataTypeSpec();
				if ( inputState.guessing==0 ) {
					self = new CastPrimary(sourceRef, self, right, false);
				}
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_AS:
			case LITERAL_BETWEEN:
			case LITERAL_BITAND:
			case LITERAL_BITOR:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_ELSE:
			case LITERAL_END:
			case LITERAL_ESCAPE:
			case LITERAL_EXCEPT:
			case LITERAL_EXCLUSIVE:
			case LITERAL_FI:
			case LITERAL_FOR:
			case LITERAL_FROM:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_IN:
			case LITERAL_INCLUSIVE:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_IS:
			case LITERAL_LEFT:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_SUBSET:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case LITERAL_WHEN:
			case LITERAL_WHERE:
			case ASSIGN:
			case COMMA:
			case DBLPIPE:
			case GE:
			case GT:
			case JDBC_ESCAPE:
			case LE:
			case LT:
			case MINUS:
			case NE:
			case PLUS:
			case RBRACKET:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			case SLASH:
			case STAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		case LITERAL_CAST:
		{
			match(LITERAL_CAST);
			match(LPAREN);
			self=sSimplePrimary();
			match(LITERAL_AS);
			right=sDataTypeSpec();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = new CastPrimary(sourceRef, self, right, true);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final ExpressionList  sExpressionList(
		
	) throws ParserException, IOException {
		ExpressionList self = null;
		
		
		Vector		exprs = new Vector();
		Expression		p;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p=sExpression();
		if ( inputState.guessing==0 ) {
			exprs.addElement(p);
		}
		{
		_loop47:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				p=sExpression();
				if ( inputState.guessing==0 ) {
					exprs.addElement(p);
				}
			}
			else {
				break _loop47;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new ExpressionList(sourceRef, exprs);
		}
		return self;
	}
	
	public final FieldReference  sFieldReference(
		
	) throws ParserException, IOException {
		FieldReference self = null;
		
		
		String		p1;
		String		p2 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		p1=sIdentifier();
		{
		switch ( LA(1)) {
		case DOT:
		{
			match(DOT);
			p2=sIdentifier();
			break;
		}
		case EOF:
		case LITERAL_AND:
		case LITERAL_AS:
		case LITERAL_BETWEEN:
		case LITERAL_BITAND:
		case LITERAL_BITOR:
		case LITERAL_CAST:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_ELSE:
		case LITERAL_END:
		case LITERAL_ESCAPE:
		case LITERAL_EXCEPT:
		case LITERAL_EXCLUSIVE:
		case LITERAL_FI:
		case LITERAL_FOR:
		case LITERAL_FROM:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_IN:
		case LITERAL_INCLUSIVE:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_IS:
		case LITERAL_LEFT:
		case LITERAL_LIKE:
		case LITERAL_MATCHES:
		case LITERAL_NOT:
		case LITERAL_ON:
		case LITERAL_OR:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_SUBRANGE:
		case LITERAL_SUBSET:
		case LITERAL_THEN:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case LITERAL_WHEN:
		case LITERAL_WHERE:
		case ASSIGN:
		case COMMA:
		case DBLPIPE:
		case GE:
		case GT:
		case JDBC_ESCAPE:
		case LE:
		case LT:
		case MINUS:
		case NE:
		case PLUS:
		case RBRACKET:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		case SLASH:
		case STAR:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new FieldReference(sourceRef, p2 == null ? null : p1, p2 == null ? p1 : p2);
		}
		return self;
	}
	
	public final SimpleTableReference  sSimpleTableReference(
		
	) throws ParserException, IOException {
		SimpleTableReference self = null;
		
		
		TableReference	table;
		TableAlias		tableAlias;
		Expression		tableName;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			table=sTableExpression();
			match(RPAREN);
			tableAlias=sTableAlias();
			if ( inputState.guessing==0 ) {
				self = new SimpleSubTableReference(sourceRef, table, tableAlias);
			}
			break;
		}
		case LITERAL_TABLE:
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			{
			switch ( LA(1)) {
			case LITERAL_TABLE:
			{
				match(LITERAL_TABLE);
				break;
			}
			case DELIMITER_ID:
			case STANDARD_ID:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			tableName=sTableName();
			tableAlias=sTableAlias();
			if ( inputState.guessing==0 ) {
				self = new TableName(sourceRef, tableName, tableAlias);
			}
			break;
		}
		case JDBC_OUTERJOIN:
		{
			self=sOuterJoin();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final IfExpression  sIfExpression(
		
	) throws ParserException, IOException {
		IfExpression self = null;
		
		
		SearchCondition    p1;
		Expression            p2;
		Expression            p3;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_IF);
		p1=sSearchCondition();
		match(LITERAL_THEN);
		p2=sExpression();
		match(LITERAL_ELSE);
		p3=sExpression();
		match(LITERAL_FI);
		if ( inputState.guessing==0 ) {
			self = new IfExpression(sourceRef, p1, p2, p3);
		}
		return self;
	}
	
	public final InsertSource  sInsertSource(
		
	) throws ParserException, IOException {
		InsertSource self = null;
		
		
		ValueList		value;
		Vector		list = new Vector();
		TableReference	table;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_VALUES:
		{
			match(LITERAL_VALUES);
			value=sValueList();
			if ( inputState.guessing==0 ) {
				self = new ValueListInsertSource(sourceRef,  value);
			}
			break;
		}
		case LITERAL_TABLE:
		{
			match(LITERAL_TABLE);
			match(LPAREN);
			value=sValueList();
			if ( inputState.guessing==0 ) {
				list.addElement(value);
			}
			{
			_loop66:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					value=sValueList();
					if ( inputState.guessing==0 ) {
						list.addElement(value);
					}
				}
				else {
					break _loop66;
				}
				
			} while (true);
			}
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = new TableInsertSource(sourceRef,  list);
			}
			break;
		}
		case LITERAL_SELECT:
		case LPAREN:
		{
			table=sTableExpression();
			if ( inputState.guessing==0 ) {
				self = new TableExpressionInsertSource(sourceRef, table);
			}
			break;
		}
		case LITERAL_DEFAULT:
		{
			match(LITERAL_DEFAULT);
			match(LITERAL_VALUES);
			if ( inputState.guessing==0 ) {
				self = new DefaultValuesInsertSource(sourceRef);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final ValueList  sValueList(
		
	) throws ParserException, IOException {
		ValueList self = null;
		
		
		ExpressionList	p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LPAREN);
		p1=sExpressionList();
		match(RPAREN);
		if ( inputState.guessing==0 ) {
			self = new ValueList(sourceRef, p1);
		}
		return self;
	}
	
	public final TableReference  sTableExpression(
		
	) throws ParserException, IOException {
		TableReference self = null;
		
		
		UnidiffSpec	spec;
		TableReference      right;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sTableTerm();
		{
		_loop176:
		do {
			if ((_tokenSet_2.member(LA(1)))) {
				spec=sUnidiffSpec();
				right=sTableTerm();
				if ( inputState.guessing==0 ) {
					self = new UnidiffTableReference(sourceRef, spec, self, right);
				}
			}
			else {
				break _loop176;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final IntersectSpec  sIntersectSpec(
		
	) throws ParserException, IOException {
		IntersectSpec self = null;
		
		
		CorrespondingSpec	p1 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_INTERSECT);
		{
		switch ( LA(1)) {
		case LITERAL_CORRESPONDING:
		{
			p1=sCorrespondingSpec();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_EXISTS:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NOT:
		case LITERAL_NULL:
		case LITERAL_SELECT:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LBRACKET:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new IntersectSpec(sourceRef, p1);
		}
		return self;
	}
	
	public final JoinPred  sJoinPred(
		
	) throws ParserException, IOException {
		JoinPred self = null;
		
		
		SearchCondition condition;
		FieldNameList list;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_ON:
		{
			match(LITERAL_ON);
			condition=sSearchCondition();
			if ( inputState.guessing==0 ) {
				self = new OnJoinPred(sourceRef, condition);
			}
			break;
		}
		case LITERAL_USING:
		{
			match(LITERAL_USING);
			match(LPAREN);
			list=sFieldNameList();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = new UsingJoinPred(sourceRef, list);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final String  sJoinType(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		
		switch ( LA(1)) {
		case LITERAL_LEFT:
		{
			match(LITERAL_LEFT);
			if ( inputState.guessing==0 ) {
				self =  "LEFT";
			}
			break;
		}
		case LITERAL_RIGHT:
		{
			match(LITERAL_RIGHT);
			if ( inputState.guessing==0 ) {
				self = "RIGHT";
			}
			break;
		}
		case LITERAL_FULL:
		{
			match(LITERAL_FULL);
			if ( inputState.guessing==0 ) {
				self = "FULL";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final LikePredicate  sLikePredicate(
		
	) throws ParserException, IOException {
		LikePredicate self = null;
		
		
		String	 p1 = null;
		Expression	 p2;
		JdbcEscape	 p3 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_LIKE);
		{
		switch ( LA(1)) {
		case LITERAL_INSENSITIVE:
		case LITERAL_SENSITIVE:
		{
			p1=sSensSpec();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		p2=sExpression();
		{
		switch ( LA(1)) {
		case JDBC_ESCAPE:
		{
			p3=sEscapeExpression();
			break;
		}
		case EOF:
		case LITERAL_AND:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FOR:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_OR:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_THEN:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new LikePredicate(sourceRef, p1, p2, p3);
		}
		return self;
	}
	
	public final String  sSensSpec(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_SENSITIVE:
		{
			match(LITERAL_SENSITIVE);
			if ( inputState.guessing==0 ) {
				self = "SENSITIVE";
			}
			break;
		}
		case LITERAL_INSENSITIVE:
		{
			match(LITERAL_INSENSITIVE);
			if ( inputState.guessing==0 ) {
				self = "INSENSITIVE";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JdbcEscape  sEscapeExpression(
		
	) throws ParserException, IOException {
		JdbcEscape self = null;
		
		Token  t = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(JDBC_ESCAPE);
		t = LT(1);
		match(STRING_LIT);
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			self = new JdbcEscape(sourceRef, t.getText());
		}
		return self;
	}
	
	public final Literal  sLiteral(
		
	) throws ParserException, IOException {
		Literal self = null;
		
		Token  t1 = null;
		Token  t2 = null;
		Token  t4 = null;
		Token  t5 = null;
		Token  t6 = null;
		Token  t7 = null;
		Token  t8 = null;
		Token  t9 = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case INTEGER_LIT:
		{
			t1 = LT(1);
			match(INTEGER_LIT);
			if ( inputState.guessing==0 ) {
				self = new IntegerLiteral(sourceRef, new Integer(t1.getText()));
			}
			break;
		}
		case NUMERIC_LIT:
		{
			t2 = LT(1);
			match(NUMERIC_LIT);
			if ( inputState.guessing==0 ) {
				self = new NumericLiteral(sourceRef, new java.math.BigDecimal(t2.getText()));
			}
			break;
		}
		case STRING_LIT:
		{
			t4 = LT(1);
			match(STRING_LIT);
			if ( inputState.guessing==0 ) {
				self = new StringLiteral(sourceRef, t4.getText());
			}
			break;
		}
		case BINCHAR_LIT:
		{
			t5 = LT(1);
			match(BINCHAR_LIT);
			if ( inputState.guessing==0 ) {
				self = new BincharLiteral(sourceRef, t5.getText());
			}
			break;
		}
		case BIT_LIT:
		{
			t6 = LT(1);
			match(BIT_LIT);
			if ( inputState.guessing==0 ) {
				self = new BitLiteral(sourceRef, t6.getText());
			}
			break;
		}
		case LITERAL_FALSE:
		{
			match(LITERAL_FALSE);
			if ( inputState.guessing==0 ) {
				
				self = new BooleanLiteral(sourceRef, false);
				
			}
			break;
		}
		case LITERAL_TRUE:
		{
			match(LITERAL_TRUE);
			if ( inputState.guessing==0 ) {
				
				self = new BooleanLiteral(sourceRef, true);
				
			}
			break;
		}
		case LITERAL_NULL:
		{
			match(LITERAL_NULL);
			if ( inputState.guessing==0 ) {
				self = new NullLiteral(sourceRef);
			}
			break;
		}
		case JDBC_DATE:
		{
			match(JDBC_DATE);
			t7 = LT(1);
			match(STRING_LIT);
			match(RCURLY);
			if ( inputState.guessing==0 ) {
				self = new JdbcDateLiteral(sourceRef, t7.getText());
			}
			break;
		}
		case JDBC_TIME:
		{
			match(JDBC_TIME);
			t8 = LT(1);
			match(STRING_LIT);
			match(RCURLY);
			if ( inputState.guessing==0 ) {
				self = new JdbcTimeLiteral(sourceRef, t8.getText());
			}
			break;
		}
		case JDBC_TIMESTAMP:
		{
			match(JDBC_TIMESTAMP);
			t9 = LT(1);
			match(STRING_LIT);
			match(RCURLY);
			if ( inputState.guessing==0 ) {
				self = new JdbcTimeStampLiteral(sourceRef, t9.getText());
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final MatchesPredicate  sMatchesPredicate(
		
	) throws ParserException, IOException {
		MatchesPredicate self = null;
		
		
		String		p1 = null;
		Expression		p2;
		Expression		p3 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_MATCHES);
		{
		switch ( LA(1)) {
		case LITERAL_INSENSITIVE:
		case LITERAL_SENSITIVE:
		{
			p1=sSensSpec();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		p2=sExpression();
		{
		switch ( LA(1)) {
		case LITERAL_ESCAPE:
		{
			match(LITERAL_ESCAPE);
			p3=sExpression();
			break;
		}
		case EOF:
		case LITERAL_AND:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FOR:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_OR:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_THEN:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new MatchesPredicate(sourceRef, p1, p2, p3);
		}
		return self;
	}
	
	public final Predicate  sPredicate(
		
	) throws ParserException, IOException {
		Predicate self = null;
		
		
		Expression		expr;
		String		s = null;
		Predicate		right = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LBRACKET:
		{
			self=sTupleInPredicate();
			break;
		}
		case LITERAL_EXISTS:
		{
			self=sExistsPredicate();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			expr=sExpression();
			if ( inputState.guessing==0 ) {
				self = new ExpressionPredicate(sourceRef, expr);
			}
			{
			switch ( LA(1)) {
			case LITERAL_BETWEEN:
			case LITERAL_IN:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_SUBSET:
			{
				{
				switch ( LA(1)) {
				case LITERAL_NOT:
				{
					match(LITERAL_NOT);
					if ( inputState.guessing==0 ) {
						s = "NOT";
					}
					break;
				}
				case LITERAL_BETWEEN:
				case LITERAL_IN:
				case LITERAL_LIKE:
				case LITERAL_MATCHES:
				case LITERAL_SUBSET:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				{
				switch ( LA(1)) {
				case LITERAL_SUBSET:
				{
					match(LITERAL_SUBSET);
					if ( inputState.guessing==0 ) {
						s += "SUBSET";
					}
					{
					switch ( LA(1)) {
					case LITERAL_OF:
					{
						match(LITERAL_OF);
						if ( inputState.guessing==0 ) {
							s += "OF";
						}
						break;
					}
					case LITERAL_AVG:
					case LITERAL_BITNOT:
					case LITERAL_CASE:
					case LITERAL_CAST:
					case LITERAL_COUNT:
					case LITERAL_FALSE:
					case LITERAL_IF:
					case LITERAL_MAX:
					case LITERAL_MIN:
					case LITERAL_NULL:
					case LITERAL_SUM:
					case LITERAL_TRUE:
					case JDBC_DATE:
					case JDBC_FUNCTION:
					case JDBC_TIME:
					case JDBC_TIMESTAMP:
					case LPAREN:
					case MINUS:
					case PLUS:
					case BINCHAR_LIT:
					case BIT_LIT:
					case DELIMITER_ID:
					case INTEGER_LIT:
					case NUMERIC_LIT:
					case STANDARD_ID:
					case STRING_LIT:
					{
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1));
					}
					}
					}
					expr=sExpression();
					if ( inputState.guessing==0 ) {
						right = new ExpressionPredicate(sourceRef, expr);
					}
					break;
				}
				case LITERAL_BETWEEN:
				case LITERAL_IN:
				case LITERAL_LIKE:
				case LITERAL_MATCHES:
				{
					right=sWithNotPredicate();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				if ( inputState.guessing==0 ) {
					self = new ExtendedPredicate(sourceRef, self, s, right);
				}
				break;
			}
			case LITERAL_IS:
			case ASSIGN:
			case GE:
			case GT:
			case LE:
			case LT:
			case NE:
			{
				self=sWithCompPredicate(self);
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_EXCEPT:
			case LITERAL_FOR:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_LEFT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final TupleInPredicate  sTupleInPredicate(
		
	) throws ParserException, IOException {
		TupleInPredicate self = null;
		
		
		boolean		hasNot = false;
		ExpressionList	p1;
		SubTableExpression	p2;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LBRACKET);
		p1=sExpressionList();
		match(RBRACKET);
		{
		switch ( LA(1)) {
		case LITERAL_NOT:
		{
			match(LITERAL_NOT);
			if ( inputState.guessing==0 ) {
				hasNot = true;
			}
			break;
		}
		case LITERAL_IN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LITERAL_IN);
		p2=sSubTableExpression();
		if ( inputState.guessing==0 ) {
			self = new TupleInPredicate(sourceRef, p1, hasNot, p2);
		}
		return self;
	}
	
	public final Predicate  sWithNotPredicate(
		
	) throws ParserException, IOException {
		Predicate self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_BETWEEN:
		{
			self=sBetweenPredicate();
			break;
		}
		case LITERAL_LIKE:
		{
			self=sLikePredicate();
			break;
		}
		case LITERAL_IN:
		{
			self=sValueInPredicate();
			break;
		}
		case LITERAL_MATCHES:
		{
			self=sMatchesPredicate();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final Predicate  sWithCompPredicate(
		Predicate predicate
	) throws ParserException, IOException {
		Predicate self = null;
		
		
		String		s = null;
		Expression		p = null;
		boolean		hasNot = false;
		Predicate		right = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_IS:
		{
			match(LITERAL_IS);
			{
			switch ( LA(1)) {
			case LITERAL_NOT:
			{
				match(LITERAL_NOT);
				if ( inputState.guessing==0 ) {
					hasNot = true;
				}
				break;
			}
			case LITERAL_NULL:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			match(LITERAL_NULL);
			if ( inputState.guessing==0 ) {
				self = new IsPredicate(sourceRef, predicate, hasNot);
			}
			break;
		}
		case ASSIGN:
		case GE:
		case GT:
		case LE:
		case LT:
		case NE:
		{
			{
			switch ( LA(1)) {
			case LT:
			{
				match(LT);
				if ( inputState.guessing==0 ) {
					s = "<";
				}
				break;
			}
			case LE:
			{
				match(LE);
				if ( inputState.guessing==0 ) {
					s = "<=";
				}
				break;
			}
			case GT:
			{
				match(GT);
				if ( inputState.guessing==0 ) {
					s = ">";
				}
				break;
			}
			case GE:
			{
				match(GE);
				if ( inputState.guessing==0 ) {
					s = ">=";
				}
				break;
			}
			case ASSIGN:
			{
				match(ASSIGN);
				if ( inputState.guessing==0 ) {
					s = "=";
				}
				break;
			}
			case NE:
			{
				match(NE);
				if ( inputState.guessing==0 ) {
					s = "<>";
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			{
			switch ( LA(1)) {
			case LITERAL_ALL:
			case LITERAL_ANY:
			case LITERAL_SOME:
			{
				right=sQuantifiedPredicate();
				break;
			}
			case LITERAL_AVG:
			case LITERAL_BITNOT:
			case LITERAL_CASE:
			case LITERAL_CAST:
			case LITERAL_COUNT:
			case LITERAL_FALSE:
			case LITERAL_IF:
			case LITERAL_MAX:
			case LITERAL_MIN:
			case LITERAL_NULL:
			case LITERAL_SUM:
			case LITERAL_TRUE:
			case JDBC_DATE:
			case JDBC_FUNCTION:
			case JDBC_TIME:
			case JDBC_TIMESTAMP:
			case LPAREN:
			case MINUS:
			case PLUS:
			case BINCHAR_LIT:
			case BIT_LIT:
			case DELIMITER_ID:
			case INTEGER_LIT:
			case NUMERIC_LIT:
			case STANDARD_ID:
			case STRING_LIT:
			{
				p=sExpression();
				if ( inputState.guessing==0 ) {
					right = new ExpressionPredicate(sourceRef, p);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				self = new ComparaisonPredicate(sourceRef, predicate, right, s);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final Expression  sSimplePrimary(
		
	) throws ParserException, IOException {
		Expression self = null;
		
		
		Expression   p1;
		Expression   p2 = null;
		Expression   p3 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_FALSE:
		case LITERAL_NULL:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case BINCHAR_LIT:
		case BIT_LIT:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STRING_LIT:
		{
			self=sLiteral();
			break;
		}
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			p1=sFieldReference();
			{
			switch ( LA(1)) {
			case LITERAL_SUBRANGE:
			{
				match(LITERAL_SUBRANGE);
				match(LPAREN);
				p2=sExpression();
				match(COMMA);
				p3=sExpression();
				match(RPAREN);
				break;
			}
			case EOF:
			case LITERAL_AND:
			case LITERAL_AS:
			case LITERAL_BETWEEN:
			case LITERAL_BITAND:
			case LITERAL_BITOR:
			case LITERAL_CAST:
			case LITERAL_DELETE:
			case LITERAL_DIFF:
			case LITERAL_ELSE:
			case LITERAL_END:
			case LITERAL_ESCAPE:
			case LITERAL_EXCEPT:
			case LITERAL_EXCLUSIVE:
			case LITERAL_FI:
			case LITERAL_FOR:
			case LITERAL_FROM:
			case LITERAL_FULL:
			case LITERAL_GROUP:
			case LITERAL_HAVING:
			case LITERAL_IN:
			case LITERAL_INCLUSIVE:
			case LITERAL_INSERT:
			case LITERAL_INTERSECT:
			case LITERAL_IS:
			case LITERAL_LEFT:
			case LITERAL_LIKE:
			case LITERAL_MATCHES:
			case LITERAL_NOT:
			case LITERAL_ON:
			case LITERAL_OR:
			case LITERAL_ORDER:
			case LITERAL_RIGHT:
			case LITERAL_SELECT:
			case LITERAL_SUBSET:
			case LITERAL_THEN:
			case LITERAL_UNION:
			case LITERAL_UPDATE:
			case LITERAL_USING:
			case LITERAL_WHEN:
			case LITERAL_WHERE:
			case ASSIGN:
			case COMMA:
			case DBLPIPE:
			case GE:
			case GT:
			case JDBC_ESCAPE:
			case LE:
			case LT:
			case MINUS:
			case NE:
			case PLUS:
			case RBRACKET:
			case RCURLY:
			case RPAREN:
			case SEMICOLON:
			case SLASH:
			case STAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				self = new FieldReferencePrimary(sourceRef, p1,  p2, p3);
			}
			break;
		}
		case LPAREN:
		{
			self=sSubTableExpression();
			break;
		}
		case LITERAL_IF:
		{
			self=sIfExpression();
			break;
		}
		case LITERAL_CASE:
		{
			self=sCaseExpression();
			break;
		}
		case LITERAL_COUNT:
		{
			self=sCountExpression();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_SUM:
		{
			self=sSetFunction();
			break;
		}
		case JDBC_FUNCTION:
		{
			self=sJdbcFunction();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final QuantifiedPredicate  sQuantifiedPredicate(
		
	) throws ParserException, IOException {
		QuantifiedPredicate self = null;
		
		
		SubTableExpression    p1;
		String  s = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_ALL:
		{
			match(LITERAL_ALL);
			if ( inputState.guessing==0 ) {
				s = "ALL";
			}
			break;
		}
		case LITERAL_ANY:
		{
			match(LITERAL_ANY);
			if ( inputState.guessing==0 ) {
				s = "ANY";
			}
			break;
		}
		case LITERAL_SOME:
		{
			match(LITERAL_SOME);
			if ( inputState.guessing==0 ) {
				s = "SOME";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		p1=sSubTableExpression();
		if ( inputState.guessing==0 ) {
			self = new QuantifiedPredicate(sourceRef, s, p1);
		}
		return self;
	}
	
	public final SearchCondition  sBooleanTerm(
		
	) throws ParserException, IOException {
		SearchCondition self = null;
		
		
		SearchCondition	right = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sBooleanFactor();
		{
		_loop97:
		do {
			if ((LA(1)==LITERAL_AND)) {
				match(LITERAL_AND);
				right=sBooleanFactor();
				if ( inputState.guessing==0 ) {
					self = new AndCondition(sourceRef, self, right);
				}
			}
			else {
				break _loop97;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final SearchCondition  sBooleanFactor(
		
	) throws ParserException, IOException {
		SearchCondition self = null;
		
		
		Predicate		pred;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_NOT:
		{
			match(LITERAL_NOT);
			pred=sPredicate();
			if ( inputState.guessing==0 ) {
				self = new NotCondition(sourceRef, new SimpleSearchCondition(sourceRef, pred));
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_EXISTS:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LBRACKET:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			pred=sPredicate();
			if ( inputState.guessing==0 ) {
				self = new SimpleSearchCondition(sourceRef, pred);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final SearchedWhenClause  sSearchedWhenClause(
		
	) throws ParserException, IOException {
		SearchedWhenClause self = null;
		
		
		SearchCondition p1;
		Expression p2;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_WHEN);
		p1=sSearchCondition();
		match(LITERAL_THEN);
		p2=sExpression();
		if ( inputState.guessing==0 ) {
			self = new SearchedWhenClause(sourceRef, p1, p2);
		}
		return self;
	}
	
	public final SelectElem  sSelectElem(
		
	) throws ParserException, IOException {
		SelectElem self = null;
		
		
		String s = null;
		Expression p1;
		String s2;
		TokenReference	sourceRef = buildTokenReference();
		
		
		if ((LA(1)==STAR)) {
			match(STAR);
			if ( inputState.guessing==0 ) {
				self = new SelectElemStar(sourceRef);
			}
		}
		else {
			boolean synPredMatched106 = false;
			if (((LA(1)==DELIMITER_ID||LA(1)==STANDARD_ID) && (LA(2)==DOT))) {
				int _m106 = mark();
				synPredMatched106 = true;
				inputState.guessing++;
				try {
					{
					sIdentifier();
					match(DOT);
					match(STAR);
					}
				}
				catch (ParserException pe) {
					synPredMatched106 = false;
				}
				rewind(_m106);
				inputState.guessing--;
			}
			if ( synPredMatched106 ) {
				s=sIdentifier();
				match(DOT);
				match(STAR);
				if ( inputState.guessing==0 ) {
					self = new SelectElemStar(sourceRef, s);
				}
			}
			else if ((_tokenSet_3.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
				p1=sExpression();
				{
				switch ( LA(1)) {
				case LITERAL_AS:
				{
					match(LITERAL_AS);
					s2=sIdentifier();
					if ( inputState.guessing==0 ) {
						self = new SelectElemExpression(sourceRef, p1, s2);
					}
					break;
				}
				case LITERAL_FROM:
				case COMMA:
				{
					if ( inputState.guessing==0 ) {
						self = new SelectElemExpression(sourceRef, p1);
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			}
			return self;
		}
		
	public final SelectExpression  sSelectExpression(
		
	) throws ParserException, IOException {
		SelectExpression self = null;
		
		
		String	type =	null;
		FromClause	fromClause;
		WhereClause   whereClause = null;
		GroupByClause groupByClause = null;
		HavingClause  havingClause = null;
		Vector	selectList;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_SELECT);
		{
		switch ( LA(1)) {
		case LITERAL_ALL:
		{
			match(LITERAL_ALL);
			if ( inputState.guessing==0 ) {
				type =  "ALL";
			}
			break;
		}
		case LITERAL_DISTINCT:
		{
			match(LITERAL_DISTINCT);
			if ( inputState.guessing==0 ) {
				type = "DISTINCT";
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case STAR:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		selectList=sSelectList();
		fromClause=sFromClause();
		{
		switch ( LA(1)) {
		case LITERAL_WHERE:
		{
			whereClause=sWhereClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_GROUP:
		{
			groupByClause=sGroupByClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FULL:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_HAVING:
		{
			havingClause=sHavingClause();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FULL:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			self = new SelectExpression(sourceRef, type, selectList, fromClause, whereClause, groupByClause, havingClause);
			
		}
		return self;
	}
	
	public final SimpleWhenClause  sSimpleWhenClause(
		
	) throws ParserException, IOException {
		SimpleWhenClause self = null;
		
		
		Expression   p1;
		Expression   p2;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_WHEN);
		p1=sExpression();
		match(LITERAL_THEN);
		p2=sExpression();
		if ( inputState.guessing==0 ) {
			self = new SimpleWhenClause(sourceRef, p1, p2);
		}
		return self;
	}
	
	public final CountExpression  sCountExpression(
		
	) throws ParserException, IOException {
		CountExpression self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		Expression		expr = null;
		boolean		hasDistinct = false;
		
		
		match(LITERAL_COUNT);
		match(LPAREN);
		{
		switch ( LA(1)) {
		case STAR:
		{
			match(STAR);
			break;
		}
		case LITERAL_DISTINCT:
		{
			match(LITERAL_DISTINCT);
			expr=sExpression();
			if ( inputState.guessing==0 ) {
				hasDistinct = true;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		if ( inputState.guessing==0 ) {
			self = new CountExpression(sourceRef, hasDistinct, expr);
		}
		return self;
	}
	
	public final SetFunction  sSetFunction(
		
	) throws ParserException, IOException {
		SetFunction self = null;
		
		
		String		oper = null;
		Expression		expr = null;
		int			type = SetFunction.TYP_NONE;
		TokenReference	sourceRef = buildTokenReference();
		
		
		oper=sSetFunctionName();
		match(LPAREN);
		{
		{
		switch ( LA(1)) {
		case LITERAL_ALL:
		{
			match(LITERAL_ALL);
			if ( inputState.guessing==0 ) {
				type = SetFunction.TYP_ALL;
			}
			break;
		}
		case LITERAL_DISTINCT:
		{
			match(LITERAL_DISTINCT);
			if ( inputState.guessing==0 ) {
				type = SetFunction.TYP_DISTINCT;
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		expr=sExpression();
		if ( inputState.guessing==0 ) {
			self = new SetFunction(sourceRef, oper, type, expr);
		}
		}
		match(RPAREN);
		return self;
	}
	
	public final JdbcFunction  sJdbcFunction(
		
	) throws ParserException, IOException {
		JdbcFunction self = null;
		
		Token  t = null;
		
		String		name = null;
		ExpressionList	params = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(JDBC_FUNCTION);
		{
		switch ( LA(1)) {
		case STANDARD_ID:
		{
			t = LT(1);
			match(STANDARD_ID);
			if ( inputState.guessing==0 ) {
				name = t.getText();
			}
			break;
		}
		case LITERAL_AVG:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_SUM:
		{
			name=sSetFunctionName();
			if ( inputState.guessing==0 ) {
				reportTrouble(new CWarning(sourceRef, "x-set-function-is-sql", name));
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			params=sExpressionList();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			self = new JdbcFunction(sourceRef, name, params);
		}
		return self;
	}
	
	public final TableAlias  sTableAlias(
		
	) throws ParserException, IOException {
		TableAlias self = null;
		
		
		String		ident = null;
		FieldNameList		list = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			ident=sIdentifier();
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FOR:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case LITERAL_WHERE:
		case COMMA:
		case LPAREN:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			list=sFieldNameList();
			match(RPAREN);
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_DIFF:
		case LITERAL_EXCEPT:
		case LITERAL_FOR:
		case LITERAL_FULL:
		case LITERAL_GROUP:
		case LITERAL_HAVING:
		case LITERAL_INSERT:
		case LITERAL_INTERSECT:
		case LITERAL_LEFT:
		case LITERAL_ON:
		case LITERAL_ORDER:
		case LITERAL_RIGHT:
		case LITERAL_SELECT:
		case LITERAL_UNION:
		case LITERAL_UPDATE:
		case LITERAL_USING:
		case LITERAL_WHERE:
		case COMMA:
		case RCURLY:
		case RPAREN:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new TableAlias(sourceRef, ident, list);
		}
		return self;
	}
	
	public final Expression  sTableName(
		
	) throws ParserException, IOException {
		Expression self = null;
		
		
		String		ident = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		ident=sIdentifier();
		if ( inputState.guessing==0 ) {
			self = new SimpleIdentExpression(sourceRef, ident);
		}
		return self;
	}
	
	public final OuterJoin  sOuterJoin(
		
	) throws ParserException, IOException {
		OuterJoin self = null;
		
		
		TableReference p1;
		String	 p2;
		TableReference p3;
		JoinPred	 p4 = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(JDBC_OUTERJOIN);
		p1=sTableReference();
		p2=sJoinType();
		match(LITERAL_OUTER);
		match(LITERAL_JOIN);
		p3=sTableReference();
		{
		switch ( LA(1)) {
		case LITERAL_ON:
		case LITERAL_USING:
		{
			p4=sJoinPred();
			break;
		}
		case RCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			self = new OuterJoin(sourceRef, p1, p2, p3, p4);
		}
		return self;
	}
	
	public final SortElem  sSortElem(
		
	) throws ParserException, IOException {
		SortElem self = null;
		
		
		Expression		p1 = null;
		String		ident = null;
		boolean		isDesc = false;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case DELIMITER_ID:
		case STANDARD_ID:
		{
			ident=sIdentifier();
			if ( inputState.guessing==0 ) {
				p1 = new SimpleIdentExpression(sourceRef, ident);
			}
			break;
		}
		case INTEGER_LIT:
		{
			p1=sIntegerLiteral();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_ASC:
		{
			match(LITERAL_ASC);
			break;
		}
		case LITERAL_DESC:
		{
			match(LITERAL_DESC);
			if ( inputState.guessing==0 ) {
				isDesc = true;
			}
			break;
		}
		case EOF:
		case LITERAL_DELETE:
		case LITERAL_INSERT:
		case LITERAL_SELECT:
		case LITERAL_UPDATE:
		case COMMA:
		case SEMICOLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			new SortElem(sourceRef, p1, isDesc);
		}
		return self;
	}
	
	public final SubTable  sSubTableTerm(
		
	) throws ParserException, IOException {
		SubTable self = null;
		
		
		IntersectSpec   spec;
		SubTable        right;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sSubTableReference();
		{
		_loop138:
		do {
			if ((LA(1)==LITERAL_INTERSECT)) {
				spec=sIntersectSpec();
				right=sSubTableReference();
				if ( inputState.guessing==0 ) {
					self = new IntersectTableTerm(sourceRef, spec, self, right);
				}
			}
			else {
				break _loop138;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final UnidiffSpec  sUnidiffSpec(
		
	) throws ParserException, IOException {
		UnidiffSpec self = null;
		
		
		String		oper;
		CorrespondingSpec     corr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		oper=sUnidiffOp();
		{
		switch ( LA(1)) {
		case LITERAL_CORRESPONDING:
		{
			corr=sCorrespondingSpec();
			break;
		}
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_EXISTS:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NOT:
		case LITERAL_NULL:
		case LITERAL_SELECT:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LBRACKET:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			self = new UnidiffSpec(sourceRef, oper, corr);
		}
		return self;
	}
	
	public final SubTable  sSubTableReference(
		
	) throws ParserException, IOException {
		SubTable self = null;
		
		
		SearchCondition   p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_AVG:
		case LITERAL_BITNOT:
		case LITERAL_CASE:
		case LITERAL_CAST:
		case LITERAL_COUNT:
		case LITERAL_EXISTS:
		case LITERAL_FALSE:
		case LITERAL_IF:
		case LITERAL_MAX:
		case LITERAL_MIN:
		case LITERAL_NOT:
		case LITERAL_NULL:
		case LITERAL_SUM:
		case LITERAL_TRUE:
		case JDBC_DATE:
		case JDBC_FUNCTION:
		case JDBC_TIME:
		case JDBC_TIMESTAMP:
		case LBRACKET:
		case LPAREN:
		case MINUS:
		case PLUS:
		case BINCHAR_LIT:
		case BIT_LIT:
		case DELIMITER_ID:
		case INTEGER_LIT:
		case NUMERIC_LIT:
		case STANDARD_ID:
		case STRING_LIT:
		{
			p1=sSearchCondition();
			if ( inputState.guessing==0 ) {
				self = new SubTableReference(sourceRef, p1);
			}
			break;
		}
		case LITERAL_SELECT:
		{
			self=sSelectExpression();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final String  sUnidiffOp(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_UNION:
		{
			match(LITERAL_UNION);
			if ( inputState.guessing==0 ) {
				self = "UNION";
			}
			{
			switch ( LA(1)) {
			case LITERAL_ALL:
			{
				match(LITERAL_ALL);
				if ( inputState.guessing==0 ) {
					self += " ALL";
				}
				break;
			}
			case LITERAL_AVG:
			case LITERAL_BITNOT:
			case LITERAL_CASE:
			case LITERAL_CAST:
			case LITERAL_CORRESPONDING:
			case LITERAL_COUNT:
			case LITERAL_EXISTS:
			case LITERAL_FALSE:
			case LITERAL_IF:
			case LITERAL_MAX:
			case LITERAL_MIN:
			case LITERAL_NOT:
			case LITERAL_NULL:
			case LITERAL_SELECT:
			case LITERAL_SUM:
			case LITERAL_TRUE:
			case JDBC_DATE:
			case JDBC_FUNCTION:
			case JDBC_TIME:
			case JDBC_TIMESTAMP:
			case LBRACKET:
			case LPAREN:
			case MINUS:
			case PLUS:
			case BINCHAR_LIT:
			case BIT_LIT:
			case DELIMITER_ID:
			case INTEGER_LIT:
			case NUMERIC_LIT:
			case STANDARD_ID:
			case STRING_LIT:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		case LITERAL_DIFF:
		{
			match(LITERAL_DIFF);
			if ( inputState.guessing==0 ) {
				self = "DIFF";
			}
			break;
		}
		case LITERAL_EXCEPT:
		{
			match(LITERAL_EXCEPT);
			if ( inputState.guessing==0 ) {
				self = "EXCEPT";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final ValueInPredicate  sValueInPredicate(
		
	) throws ParserException, IOException {
		ValueInPredicate self = null;
		
		
		ExpressionList	p1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_IN);
		match(LPAREN);
		p1=sExpressionList();
		match(RPAREN);
		if ( inputState.guessing==0 ) {
			self = new ValueInPredicate(sourceRef, p1);
		}
		return self;
	}
	
	public final TableReference  sTableReference(
		
	) throws ParserException, IOException {
		TableReference self = null;
		
		
		SelectExpression   p1;
		TableReference sub;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			sub=sTableExpression();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = new ParenthesedTableReference(sourceRef, sub);
			}
			break;
		}
		case LITERAL_SELECT:
		{
			p1=sSelectExpression();
			if ( inputState.guessing==0 ) {
				self = new SelectTableReference(sourceRef, p1);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final String  sSetFunctionName(
		
	) throws ParserException, IOException {
		String self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_MAX:
		{
			match(LITERAL_MAX);
			if ( inputState.guessing==0 ) {
				self = "MAX";
			}
			break;
		}
		case LITERAL_MIN:
		{
			match(LITERAL_MIN);
			if ( inputState.guessing==0 ) {
				self = "MIN";
			}
			break;
		}
		case LITERAL_AVG:
		{
			match(LITERAL_AVG);
			if ( inputState.guessing==0 ) {
				self = "AVG";
			}
			break;
		}
		case LITERAL_SUM:
		{
			match(LITERAL_SUM);
			if ( inputState.guessing==0 ) {
				self = "SUM";
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final TableReference  sTableTerm(
		
	) throws ParserException, IOException {
		TableReference self;
		
		
		IntersectSpec    spec;
		TableReference   right;
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=sTableReference();
		{
		_loop179:
		do {
			if ((LA(1)==LITERAL_INTERSECT)) {
				spec=sIntersectSpec();
				right=sTableReference();
				if ( inputState.guessing==0 ) {
					self = new IntersectTableReference(sourceRef, spec, self, right);
				}
			}
			else {
				break _loop179;
			}
			
		} while (true);
		}
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"ALL\"",
		"\"AND\"",
		"\"ANY\"",
		"\"AS\"",
		"\"ASC\"",
		"\"AVG\"",
		"\"BETWEEN\"",
		"\"BINCHAR\"",
		"\"BITAND\"",
		"\"BITNOT\"",
		"\"BITOR\"",
		"\"BITS\"",
		"\"BLOB\"",
		"\"BOOL\"",
		"\"BOTH\"",
		"\"BY\"",
		"\"CASE\"",
		"\"CAST\"",
		"\"CHAR\"",
		"\"CHARS\"",
		"\"CORRESPONDING\"",
		"\"COUNT\"",
		"\"CURRENT\"",
		"\"DEFAULT\"",
		"\"DELETE\"",
		"\"DESC\"",
		"\"DIFF\"",
		"\"DISTINCT\"",
		"\"DOUBLE\"",
		"\"ELSE\"",
		"\"END\"",
		"\"ESCAPE\"",
		"\"EXCEPT\"",
		"\"EXCLUSIVE\"",
		"\"EXISTS\"",
		"\"FALSE\"",
		"\"FI\"",
		"\"FLOAT\"",
		"\"FOR\"",
		"\"FROM\"",
		"\"FULL\"",
		"\"GROUP\"",
		"\"HAVING\"",
		"\"IF\"",
		"\"IN\"",
		"\"INCLUSIVE\"",
		"\"INSENSITIVE\"",
		"\"INSERT\"",
		"\"INTEGER\"",
		"\"INTERSECT\"",
		"\"INTO\"",
		"\"IS\"",
		"\"JOIN\"",
		"\"LEADING\"",
		"\"LEFT\"",
		"\"LIKE\"",
		"\"MATCHES\"",
		"\"MAX\"",
		"\"MIN\"",
		"\"NOT\"",
		"\"NULL\"",
		"\"NUMERIC\"",
		"\"OF\"",
		"\"ON\"",
		"\"OR\"",
		"\"ORDER\"",
		"\"OUTER\"",
		"\"POSITION\"",
		"\"REAL\"",
		"\"RIGHT\"",
		"\"SELECT\"",
		"\"SENSITIVE\"",
		"\"SET\"",
		"\"SMALLINT\"",
		"\"SOME\"",
		"\"STRING\"",
		"\"SUBRANGE\"",
		"\"SUBSET\"",
		"\"SUM\"",
		"\"TABLE\"",
		"\"THEN\"",
		"\"TINYINT\"",
		"\"TRAILING\"",
		"\"TRIM\"",
		"\"TRUE\"",
		"\"UNION\"",
		"\"UPDATE\"",
		"\"USING\"",
		"\"VALUES\"",
		"\"WHEN\"",
		"\"WHERE\"",
		"\"WORDS\"",
		"ASSIGN",
		"COLON",
		"COMMA",
		"DBLPIPE",
		"DOT",
		"GE",
		"GT",
		"JDBC_DATE",
		"JDBC_ESCAPE",
		"JDBC_FUNCTION",
		"JDBC_OUTERJOIN",
		"JDBC_TIME",
		"JDBC_TIMESTAMP",
		"LBRACKET",
		"LCURLY",
		"LE",
		"LPAREN",
		"LT",
		"MINUS",
		"NE",
		"PLUS",
		"RBRACKET",
		"RCURLY",
		"RPAREN",
		"SEMICOLON",
		"SLASH",
		"STAR",
		"BINCHAR_LIT",
		"BIT_LIT",
		"DATE_LIT",
		"DELIMITER_ID",
		"INTEGER_LIT",
		"NUMERIC_LIT",
		"STANDARD_ID",
		"STRING_LIT",
		"TIMESTAMP_LIT",
		"TIME_LIT"
	};
	
	private static final long[] _tokenSet_0_data_ = { 134217728L, 281475245671424L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long[] _tokenSet_1_data_ = { 6917670317069443600L, -2588133273510870015L, 7L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long[] _tokenSet_2_data_ = { 69793218560L, 33554432L, 0L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long[] _tokenSet_3_data_ = { 6917670314921959936L, -2876363649931018239L, 7L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long[] _tokenSet_4_data_ = { -2305692650961866112L, -2443982780535340031L, 7L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	
	}
