/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: SqlPhylum.java,v 1.18 1999/10/13 09:36:08 vgp Exp $
 */

package at.dms.sqlc;

import java.util.Vector;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.compiler.UnpositionedError;
import at.dms.compiler.JavaStyleComment;

/**
 * This class represents an SqlPhylumession
 */
public abstract class SqlPhylum extends at.dms.compiler.Phylum {

  // ----------------------------------------------------------------------
  // CONSTRUCTOR
  // ----------------------------------------------------------------------

  public SqlPhylum(TokenReference ref) {
    super(ref);
  }


  // ----------------------------------------------------------------------
  // ACCESSOR
  // ----------------------------------------------------------------------

  public void setComment(Vector comments) {
    if (comments != null && comments.size() > 0) {
      this.comments = new JavaStyleComment[comments.size()];
      comments.copyInto(this.comments);
    }
  }

  public JavaStyleComment[] getComment() {
    return comments;
  }

  // ----------------------------------------------------------------------
  // CODE GENERATION
  // ----------------------------------------------------------------------

  /**
   * Accepts a visitor.
   *
   * @param	visitor			the visitor
   */
  public abstract void accept(SqlVisitor visitor) throws PositionedError;

  // ----------------------------------------------------------------------
  // STRING CONVERSION
  // ----------------------------------------------------------------------

  /**
   * Generates code.
   */
  public String toString() {
    StringBuffer	buffer = new StringBuffer();
    try {
      //!!!checkSQL(null, null, buffer);
      throw new RuntimeException();
    } catch (Throwable e) {
      buffer.append("...");
    }
    return buffer.toString();
  }

  // ---------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ---------------------------------------------------------------------

  private JavaStyleComment[]		comments;
}
