/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: TableAlias.java,v 1.10 1999/10/12 15:39:50 vgp Exp $
 */

package at.dms.sqlc;

import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.compiler.UnpositionedError;

public class TableAlias extends SqlPhylum {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   * @param	ref		           the token reference for this statement
   */
  public TableAlias(TokenReference ref, String name, FieldNameList list) {
    super(ref);
    this.name = name;
    this.list = list;
   }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Returns the FieldNameList
   */
  public FieldNameList getFieldNameList() {
    return list;
  }

  /**
   * Returns true if the table reference has an alias
   */
  public String getIdent() {
    return name;
  }

  // --------------------------------------------------------------------
  // ACCEPT VISITORS
  // --------------------------------------------------------------------

  /**
   * Accepts a visitor.
   *
   * @param	visitor			the visitor
   */
  public void accept(SqlVisitor visitor) throws PositionedError {
    try {
      visitor.visitTableAlias(name, list);
    } catch (UnpositionedError e) {
      throw e.getError(getTokenReference());
    }
  }

/*
!!!
  public JExpression checkSQL(SqlContext context, JExpression left, StringBuffer current, TableReference table) {
    if (name != null) {
      current.append(" ");
      current.append(name);
    }
    if (list != null) {
      current.append("(");
      left = list.checkSQL(context, left, current, table);
      current.append(")");
    }
    return left;
  }
*/

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private String         name;
  private FieldNameList  list;
}
