/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Tester.java,v 1.1 1999/07/24 16:17:40 vgp Exp $
 */

package at.dms.sqlc;

import java.io.FileReader;
import java.io.LineNumberReader;

/**
 * This class implements a Java pretty printer
 */
public class Tester {
  public static void main(String[] argv) throws Exception {
    System.err.println("Begin");

    if (argv.length != 2) {
      System.err.println("USAGE: Tester fileA fileB");
      System.exit(0);
    }

    LineNumberReader	readA = new LineNumberReader(new FileReader(argv[0]));
    LineNumberReader	readB = new LineNumberReader(new FileReader(argv[1]));

    int	charA = 0;
    while (charA != -1) {
      charA = readA.read();
      switch (charA) {
      case ' ':
      case '\n':
      case '\t':
	continue;
      }
      int	charB = 0;
      while (charB != -1) {
      charB = readB.read();
	switch (charB) {
	case ' ':
	case '\\':
	case '\"':
	case ';':
	case '\n':
	case '\t':
	  continue;
	}
	if (charA != charB) {
	  System.err.println("ERROR AT " + argv[0] + " " + readA.getLineNumber() +
			     " AT " + argv[1] + " " + readB.getLineNumber() + " " +
			     (char)charA + " <> " + (char)charB);
	  System.exit(0);
	}
	break;
      }
      if (charB == -1) {
	System.err.println("EOF AT " + readA.getLineNumber());
	System.exit(0);
      }
      if (line + 10 < readA.getLineNumber()) {
	System.err.println("Line: " + (line = readA.getLineNumber()));
      }
    }

    System.err.println("Success,,,");
  }

  static int line;
}
