/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: JavaSqlContext.java,v 1.9 1999/10/08 11:19:11 vgp Exp $
 */

package at.dms.xkjc;

import java.util.Vector;
import at.dms.kjc.CBodyContext;
import at.dms.kjc.JExpression;
import at.dms.sqlc.SqlContext;
import at.dms.sqlc.TableReference;
import at.dms.compiler.PositionedError;
/**
 * This class represents a java expression within a SQL context
 */
public class JavaSqlContext implements SqlContext {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   */
  public JavaSqlContext(CBodyContext context) {
    this.context = context;
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Returns the java body context
   */
  public CBodyContext getBodyContext() {
    return context;
  }

  /**
   * Adds a blob to the current request
   */
  public void addBlob(Object o) {
    if (blobs == null) {
      blobs = new Vector();
    }
    blobs.addElement(o);
  }

  /**
   * Returns the blobs of the statement
   */
  public JExpression[] getBlobs() {
    return (JExpression[])at.dms.compiler.Utils.vectorToArray(blobs, JExpression.class);
  }

  // ----------------------------------------------------------------------
  // IMPLEMENTATION OF SQL CONTEXT
  // ----------------------------------------------------------------------

  /**
   * Returns the table reference with alias "alias"
   */
  public TableReference getTableFromAlias(String alias) {
    //throw new RuntimeException();
    return null;
  }

  /**
   * Returns all tables defined in current context
   */
  public Vector getTables() {
    throw new RuntimeException();
    //return null;
  }

  /**
   * Returns the parent context
   */
  public SqlContext getParentContext() {
    return null;
  }

  /**
   * Add an error into the list and eat it
   * This method should be called after a try catch block after catching exception
   * or directly without exception thrown
   * @param	error		the error
   */
  public void reportTrouble(PositionedError trouble) {
    context.reportTrouble(trouble);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private CBodyContext		context;
  private Vector		blobs;
}
