/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: SqlVisitor.java,v 1.1 1999/10/28 14:03:46 vgp Exp $
 */

package at.dms.xkjc;

import java.util.Vector;
import java.sql.Date;
import java.sql.Time;
import java.sql.Timestamp;

import at.dms.compiler.CWarning;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;
import at.dms.compiler.UnpositionedError;

import at.dms.sqlc.SqlContext;
import at.dms.sqlc.SqlPhylum;
import at.dms.sqlc.SearchCondition;
import at.dms.kjc.*;

/**
 * This class implements a Java pretty printer
 */
public interface SqlVisitor extends at.dms.sqlc.SqlVisitor {

  /**
   * Generates code.
   * @param	context		the sql context that holds the kjc Context
   * @param	left		the SQL expression to be built
   * @param	current		the current string literal to be added to left
   */
  void visitTypedSelectElem(String ident, JLocalVariable var, SqlPhylum sqlExpr, boolean hasAs) throws PositionedError;
  
  /**
   * Generates java code.
   *
   * @exception	PositionedError		if the check fails
   */
  void visitIfCondition(String oper, SearchCondition left, JExpression cond, XSqlExpr thenClause, XSqlExpr elseClause) throws PositionedError;

  /**
   * Generates java code.
   *
   * @exception	PositionedError		if the check fails
   */
  void visitSqlExprJava(JExpression expr, boolean asText) throws PositionedError;
}
