/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XConstants.java,v 1.13 1999/08/25 18:04:32 graf Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.Constants;

/**
 * Defines all constants shared by compiler
 */
public interface XConstants extends Constants {

  // ----------------------------------------------------------------------
  // ACCESS FLAGS
  // ----------------------------------------------------------------------

  int ACC_CURSOR		= 0x00010000;

  // ----------------------------------------------------------------------
  // PRIMITIVE SQL TYPES
  // ----------------------------------------------------------------------

  String JAV_BOOLEAN		= "java/lang/Boolean";
  String JAV_BYTE		= "java/lang/Byte";
  String JAV_SHORT		= "java/lang/Short";
  String JAV_INT		= "java/lang/Integer";
  String JAV_LONG		= "java/lang/Long";
  String JAV_FLOAT		= "java/lang/Float";
  String JAV_DOUBLE		= "java/lang/Double";
  String JAV_CHAR		= "java/lang/Character";
  String XKJ_FIXED		= "at/dms/xtype/Fixed";
  String XKJ_DATE		= "at/dms/xtype/Date";
  String XKJ_MONTH		= "at/dms/xtype/Month";
  String XKJ_TIME		= "at/dms/xtype/Time";

  // ----------------------------------------------------------------------
  // TYPES
  // ----------------------------------------------------------------------

  String JAV_SQLException	= "java/sql/SQLException";

  String XKJ_CURSOR		= "at/dms/xlib/Cursor";
  String XKJ_CONNECTION		= "at/dms/xlib/Connection";
  String XKJ_DBCONTEXTHANDLER	= "at/dms/xlib/DBContextHandler";
  String XKJ_KOPISERIALIZABLE	= "at/dms/xlib/KopiSerializable";

  // ----------------------------------------------------------------------
  // UNARY OPERATORS
  // ----------------------------------------------------------------------

  int OPE_CAST			= 26;

  // ----------------------------------------------------------------------
  // OPERATOR NAMES
  // ----------------------------------------------------------------------

  String[] OPERATOR_NAMES	= {
    "=", "+", "-", "*", "/", "%", ">>", ">>>",
    "<<", "&", "^", "|", "!", "!", "<", "<=",
    ">", ">=", "==", "!=", "++", "--", "++", "--",
    "()"
  };
}

