/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XCursor.java,v 1.9 1999/10/05 15:52:07 vgp Exp $
 */

package at.dms.xkjc;

import java.util.*;

import at.dms.classfile.FieldInfo;
import at.dms.kjc.*;

/**
 * This class represents the exported members of a class (inner classes, methods and fields)
 */
public class XCursor extends CClass {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructs a class export from file
   */
  public XCursor(CClass owner,
		 int version,
		 String sourceFile,
		 int modifiers,
		 String ident,
		 String qualifiedName,
		 CClassType superClass,
		 boolean deprecated) {
    super(owner, version, sourceFile, modifiers, ident, qualifiedName, superClass, deprecated);
  }

  /**
   * Returns the field infos
   */
  protected FieldInfo[] getFieldInfo(Hashtable fields_H, CField[] fields) {
    Enumeration	enum = fields_H.elements();
    FieldInfo[]	pfields = new FieldInfo[fields_H.size()];

    while (enum.hasMoreElements()) {
      CSourceField	field = (CSourceField)enum.nextElement();

      pfields[field.getPosition()] = field.genFieldInfo();
    }

    return pfields;
  }

  /**
   * Constructs a class export from file
   *
  public XCursor(ClassInfo classInfo) {
    super(classInfo);
  }

  /**
   *
   *
  protected void loadFields(FieldInfo[] fields) {
    this.fields_H = new Hashtable(fields.length + 1, 1.0f);

    if (fields != null) {
      for (int i = 0; i < fields.length; i++) {
	CField		field;

	if ((fields[i].getModifiers() & XConstants.ACC_CURSOR) == 0) {
	  field = new CField(this, fields[i]);
	} else { 
	  field = new XCursorField(this, fields[i]);
	  ((XCursorField)field).setPosition(i);
	}

	fields_H.put(field.getIdent(), field);
      }
    }
  }
*/
}
