/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XCursorFieldExpression.java,v 1.15 1999/10/08 11:19:12 vgp Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.JClassFieldExpression;
import at.dms.kjc.JExpression;
import at.dms.kjc.CExpressionContext;
import at.dms.kjc.CClass;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;

/**
 * a field access ('getExpression().t' or 't')
 */
public class XCursorFieldExpression extends JClassFieldExpression {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Construct a node in the parsing tree
   * @param where the line of this node in the source code
   */
  public XCursorFieldExpression(TokenReference where,
				JExpression left,
				String ident,
				boolean hasSuffix) {
    super(where, left, ident);
    if (left instanceof XCursorFieldExpression) {
      this.left = ((XCursorFieldExpression)left).left;
      this.ident = ((XCursorFieldExpression)left).ident + "$" + ident;
    }
    this.hasSuffix = hasSuffix;
  }

  // ----------------------------------------------------------------------
  // CODE CHECKING
  // ----------------------------------------------------------------------

  /**
   * Check expression and evaluate and alter context
   * @param	context			the actual context of analyse
   * @return	a pure java expression including promote node
   * @exception	PositionedError	an error with reference to the source file
   */
  public JExpression checkExpression(CExpressionContext context) throws PositionedError {
    if (hasSuffix) {
      return this; // collect name
    } else {
      CClass	local = context.getClassContext().getCClass();

      findPrefix(local, context);
      checkAccess(local, context);

      return ((XCursorField)field).createAccessExpression(getTokenReference(), left, context).checkExpression(context);
    }
  }

  // ----------------------------------------------------------------------
  // CODE CHECKING
  // ----------------------------------------------------------------------

  private boolean	hasSuffix;
}
