/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XIfCondition.java,v 1.20 1999/10/28 14:03:13 vgp Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.*;
import at.dms.sqlc.SearchCondition;
import at.dms.sqlc.SqlContext;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;

/**
 * This class represents a java expression within a SQL context
 */
public class XIfCondition extends SearchCondition {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   */
  public XIfCondition(TokenReference ref,
		      String oper,
		      SearchCondition left,
		      JExpression cond,
		      XSqlExpr thenClause,
		      XSqlExpr elseClause) {
    super(ref);

    this.left = left;
    this.oper = oper;
    this.cond = cond;
    this.thenClause = thenClause;
    this.elseClause = elseClause;
  }

  // --------------------------------------------------------------------
  // ACCEPT VISITORS
  // --------------------------------------------------------------------

  /**
   * Accepts a visitor.
   *
   * @param	visitor			the visitor
   */
  public void accept(at.dms.sqlc.SqlVisitor visitor) throws PositionedError {
    ((SqlVisitor)visitor).visitIfCondition(oper, left, cond, thenClause, elseClause);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private String		oper;
  private SearchCondition	left;
  private JExpression		cond;
  private XSqlExpr		thenClause;
  private XSqlExpr		elseClause;
}
