/*
 * ANTLR-generated file resulting from grammar ./expandedxjava.g
 * 
 * Terence Parr, MageLang Institute
 * with John Lilley, Empathy Software
 * ANTLR Version 2.6.1; 1996-1999
 */
 package at.dms.xkjc; 
import java.io.IOException;
import antlr.TokenBuffer;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.ParserException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;

  import java.util.Vector;

  import at.dms.kjc.*;
  import at.dms.compiler.Compiler;
  import at.dms.compiler.CWarning;
  import at.dms.compiler.PositionedError;
  import at.dms.compiler.TokenReference;
  import at.dms.compiler.JavaStyleComment;
  import at.dms.util.VectorCache;

public class XJavaParser extends at.dms.kjc.Parser
       implements XJavaTokenTypes
 {

  public XJavaParser(Compiler compiler, XParseManager mgr, CHandLexer lexer, String file) {
    super(compiler, lexer, file, MAX_LOOKAHEAD);
    this.mgr = mgr;
    this.isKopiFile = file.endsWith(".k");
  }

  private XParseManager		mgr;
  private boolean		isKopiFile;
// Generated by ANTLR
private static final int MAX_LOOKAHEAD = 2;
{
  tokenNames = _tokenNames;
}
// Generated by ANTLR

	public final void jDefaultImport(
		CParseCompilationUnitContext context
	) throws ParserException, IOException {
		
		
		if ( inputState.guessing==0 ) {
			
			context.addPackageImport(CParseCompilationUnitContext.JAVA_LANG);
			context.addPackageImport(new JPackageImport(TokenReference.NO_REF, "at/dms/xlib", null));
			context.addPackageImport(new JPackageImport(TokenReference.NO_REF, "at/dms/xtype", null));
			
		}
	}
	
	public final void jMethodDeclaration(
		CParseClassContext context, int mods, CType type
	) throws ParserException, IOException {
		
		Token  ident = null;
		
		JFormalParameter[]	parameters;
		CClassType[]		throwsList = CClassType.EMPTY;
		int			bounds = 0;
		JBlock		block = null;
		int			oper = -1;
		TokenReference	sourceRef = buildTokenReference();
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		ident = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case COLON:
		{
			match(COLON);
			oper=xOverloadableOperator();
			break;
		}
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		parameters=jFormalParameters(JLocalVariable.DES_PARAMETER);
		{
		_loop5:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop5;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_throws:
		{
			match(LITERAL_throws);
			throwsList=jNameList();
			break;
		}
		case LCURLY:
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LCURLY:
		{
			block=jBlock();
			break;
		}
		case SEMI:
		{
			match(SEMI);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
				reportTrouble(new CWarning(sourceRef, "old-style-array-bounds", null));
				type = new CArrayType(type, bounds);
			}
			
			if (oper == -1) {
			context.addMethodDeclaration(new JMethodDeclaration(sourceRef,
										    mods,
										    type,
										    ident.getText(),
										    parameters,
										    throwsList,
										    block,
										    javadoc,
										    comments));
			} else {
			context.addMethodDeclaration(new XOperatorDeclaration(sourceRef,
										      mods,
										      type,
										      ident.getText(),
										      oper,
										      parameters,
										      throwsList,
										      block,
										      false));
			}
			
		}
	}
	
	public final int  xOverloadableOperator(
		
	) throws ParserException, IOException {
		int self = -1;
		
		
		switch ( LA(1)) {
		case EQUAL:
		{
			match(EQUAL);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_EQ;
			}
			break;
		}
		case LNOT:
		{
			match(LNOT);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_LNOT;
			}
			break;
		}
		case BNOT:
		{
			match(BNOT);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_BNOT;
			}
			break;
		}
		case NOT_EQUAL:
		{
			match(NOT_EQUAL);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_NE;
			}
			break;
		}
		case SLASH:
		{
			match(SLASH);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_SLASH;
			}
			break;
		}
		case PLUS:
		{
			match(PLUS);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_PLUS;
			}
			break;
		}
		case MINUS:
		{
			match(MINUS);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_MINUS;
			}
			break;
		}
		case PERCENT:
		{
			match(PERCENT);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_PERCENT;
			}
			break;
		}
		case SR:
		{
			match(SR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_SR;
			}
			break;
		}
		case BSR:
		{
			match(BSR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_BSR;
			}
			break;
		}
		case GE:
		{
			match(GE);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_GE;
			}
			break;
		}
		case GT:
		{
			match(GT);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_GT;
			}
			break;
		}
		case SL:
		{
			match(SL);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_SL;
			}
			break;
		}
		case LE:
		{
			match(LE);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_LE;
			}
			break;
		}
		case LT:
		{
			match(LT);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_LT;
			}
			break;
		}
		case BXOR:
		{
			match(BXOR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_BXOR;
			}
			break;
		}
		case BOR:
		{
			match(BOR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_BOR;
			}
			break;
		}
		case BAND:
		{
			match(BAND);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_BAND;
			}
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = at.dms.xkjc.XConstants.OPE_CAST;
			}
			break;
		}
		case ASSIGN:
		{
			match(ASSIGN);
			if ( inputState.guessing==0 ) {
				self = at.dms.xkjc.XConstants.OPE_SIMPLE;
			}
			break;
		}
		case INC:
		{
			match(INC);
			match(STAR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_PREINC;
			}
			break;
		}
		case DEC:
		{
			match(DEC);
			match(STAR);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.OPE_PREDEC;
			}
			break;
		}
		default:
			if ((LA(1)==STAR) && (LA(2)==LPAREN)) {
				match(STAR);
				if ( inputState.guessing==0 ) {
					self = at.dms.kjc.Constants.OPE_STAR;
				}
			}
			else if ((LA(1)==STAR) && (LA(2)==DEC||LA(2)==INC)) {
				match(STAR);
				{
				switch ( LA(1)) {
				case INC:
				{
					match(INC);
					if ( inputState.guessing==0 ) {
						self = at.dms.kjc.Constants.OPE_POSTINC;
					}
					break;
				}
				case DEC:
				{
					match(DEC);
					if ( inputState.guessing==0 ) {
						self = at.dms.kjc.Constants.OPE_POSTDEC;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
			}
		else {
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JFormalParameter[]  jFormalParameters(
		int desc
	) throws ParserException, IOException {
		JFormalParameter[] self = JFormalParameter.EMPTY;
		
		
		JFormalParameter		elem = null;
		Vector			vect = VectorCache.request(VectorCache.SMALL);
		
		
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_final:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case IDENT:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			elem=jFormalParameter(desc);
			if ( inputState.guessing==0 ) {
				vect.addElement(elem);
			}
			{
			_loop182:
			do {
				if ((LA(1)==COMMA)) {
					match(COMMA);
					elem=jFormalParameter(desc);
					if ( inputState.guessing==0 ) {
						vect.addElement(elem);
					}
				}
				else {
					break _loop182;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				
				self = (JFormalParameter[])at.dms.compiler.Utils.vectorToArray(vect, JFormalParameter.class); 
				VectorCache.release(vect);
				
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		return self;
	}
	
	public final CClassType[]  jNameList(
		
	) throws ParserException, IOException {
		CClassType[] self = null;
		
		
		String	name;
		Vector			vect = VectorCache.request(VectorCache.SMALL);
		
		
		name=jName();
		if ( inputState.guessing==0 ) {
			vect = new Vector(); vect.addElement(CClassType.lookup(name));
		}
		{
		_loop188:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				name=jName();
				if ( inputState.guessing==0 ) {
					vect.addElement(CClassType.lookup(name));
				}
			}
			else {
				break _loop188;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (CClassType[])at.dms.compiler.Utils.vectorToArray(vect, CClassType.class);
			VectorCache.release(vect);
			
		}
		return self;
	}
	
	public final JBlock  jBlock(
		
	) throws ParserException, IOException {
		JBlock self = null;
		
		
		Vector		body = VectorCache.request(VectorCache.BIG);
		JStatement		stmt;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LCURLY);
		{
		_loop223:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				stmt=jBlockStatement();
				if ( inputState.guessing==0 ) {
					body.addElement(stmt);
				}
			}
			else {
				break _loop223;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = new JBlock(sourceRef, (JStatement[])at.dms.compiler.Utils.vectorToArray(body, JStatement.class), getStatementComment());
			VectorCache.release(body);
			
		}
		return self;
	}
	
	public final void jInnerTypeDeclaration(
		CParseClassContext context, int mods
	) throws ParserException, IOException {
		
		
		JTypeDeclaration	inner = null;
		
		
		{
		switch ( LA(1)) {
		case LITERAL_class:
		{
			inner=jClassDeclaration(mods);
			break;
		}
		case LITERAL_interface:
		{
			inner=jInterfaceDeclaration(mods);
			break;
		}
		case CURSOR_SQL:
		{
			inner=xCursorDeclaration(mods);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			context.addInnerDeclaration(inner);
		}
	}
	
	public final JClassDeclaration  jClassDeclaration(
		int mods
	) throws ParserException, IOException {
		JClassDeclaration self = null;
		
		Token  ident = null;
		
		String		superClass = null;
		CClassType[]		interfaces = CClassType.EMPTY;
		CParseClassContext	context = CParseClassContext.getInstance();
		TokenReference	sourceRef = buildTokenReference();
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(LITERAL_class);
		ident = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			match(LITERAL_extends);
			superClass=jName();
			break;
		}
		case LITERAL_implements:
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LITERAL_implements:
		{
			match(LITERAL_implements);
			interfaces=jNameList();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		jClassBody(context);
		if ( inputState.guessing==0 ) {
			
			self = new JClassDeclaration(sourceRef,
							   mods,
							   ident.getText(),
							   superClass,
							   interfaces,
							   context.getFields(),
							   context.getMethods(),
							   context.getInnerClasses(),
							   context.getBody(),
							   javadoc,
							   comments);
			context.release();
			
		}
		return self;
	}
	
	public final JInterfaceDeclaration  jInterfaceDeclaration(
		int mods
	) throws ParserException, IOException {
		JInterfaceDeclaration self = null;
		
		Token  ident = null;
		
		CClassType[]		interfaces =  CClassType.EMPTY;
		CParseClassContext	context = CParseClassContext.getInstance();
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_interface);
		ident = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			match(LITERAL_extends);
			interfaces=jNameList();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		jInterfaceBody(context);
		if ( inputState.guessing==0 ) {
			
			self = new JInterfaceDeclaration(sourceRef,
							       mods,
							       ident.getText(),
							       interfaces,
							       context.getFields(),
							       context.getMethods(),
							       context.getInnerClasses(),			       
							       context.getBody(),
							       getJavadocComment(),
							       getStatementComment());
			context.release();
			
		}
		return self;
	}
	
	public final XCursorDeclaration  xCursorDeclaration(
		int mods
	) throws ParserException, IOException {
		XCursorDeclaration self = null;
		
		Token  ident = null;
		
		CParseClassContext	context = CParseClassContext.getInstance();
		TokenReference	sourceRef = buildTokenReference();
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		XSelectStatement	sel = null;
		JFormalParameter[]	parameters = null;
		
		
		match(CURSOR_SQL);
		ident = LT(1);
		match(IDENT);
		{
		switch ( LA(1)) {
		case LCURLY:
		{
			xExplicitCursorBody(context);
			break;
		}
		case LPAREN:
		{
			parameters=jFormalParameters(JLocalVariable.DES_PARAMETER);
			sel=xImplicitCursorBody(context);
			if ( inputState.guessing==0 ) {
				
				XCursorDeclaration.addImplicitSelect(context, sel, parameters);
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			self = new XCursorDeclaration(sourceRef,
							   mods,
							   ident.getText(),
							   context.getFields(),
							   context.getMethods(),
							   context.getInnerClasses(),
							   context.getBody(),
				                           sel,
				                           parameters,
							   javadoc,
							   comments);
			context.release();
			
		}
		return self;
	}
	
	public final JExpression  jAdditiveExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			oper = Constants.OPE_PLUS;
		JExpression		right;
		
		
		self=jMultiplicativeExpression();
		{
		_loop13:
		do {
			if ((LA(1)==MINUS||LA(1)==PLUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					match(PLUS);
					if ( inputState.guessing==0 ) {
						oper = Constants.OPE_PLUS;
					}
					break;
				}
				case MINUS:
				{
					match(MINUS);
					if ( inputState.guessing==0 ) {
						oper = Constants.OPE_MINUS;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				right=jMultiplicativeExpression();
				if ( inputState.guessing==0 ) {
					
						if (oper == Constants.OPE_PLUS) {
						  self = new XAddExpression(self.getTokenReference(), self, right);
						} else {
						  //if (oper == Constants.OPE_MINUS)
						  self = new XMinusExpression(self.getTokenReference(), self, right);
						}
					
				}
			}
			else {
				break _loop13;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jMultiplicativeExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		
		
		self=jUnaryExpression();
		{
		_loop25:
		do {
			if ((_tokenSet_1.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case STAR:
				{
					match(STAR);
					if ( inputState.guessing==0 ) {
						operator = 1;
					}
					break;
				}
				case SLASH:
				{
					match(SLASH);
					if ( inputState.guessing==0 ) {
						operator = 2;
					}
					break;
				}
				case PERCENT:
				{
					match(PERCENT);
					if ( inputState.guessing==0 ) {
						operator = 3;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				right=jUnaryExpression();
				if ( inputState.guessing==0 ) {
					
						if (operator == 1) {
					self = new XMultExpression(self.getTokenReference(), self, right);
						} else if (operator == 2) {
					self = new XDivideExpression(self.getTokenReference(), self, right);
						} else {
					self = new XModuloExpression(self.getTokenReference(), self, right);
						}
					
				}
			}
			else {
				break _loop25;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jEqualityExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		
		
		self=jInstanceOfExpression();
		{
		_loop17:
		do {
			if ((LA(1)==EQUAL||LA(1)==NOT_EQUAL)) {
				{
				switch ( LA(1)) {
				case EQUAL:
				{
					match(EQUAL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_EQ;
					}
					break;
				}
				case NOT_EQUAL:
				{
					match(NOT_EQUAL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_NE;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				right=jInstanceOfExpression();
				if ( inputState.guessing==0 ) {
					self = new XEqualityExpression(self.getTokenReference(), operator, self, right);
				}
			}
			else {
				break _loop17;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jInstanceOfExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		CType			type;
		
		
		self=jRelationalExpression();
		{
		switch ( LA(1)) {
		case LITERAL_instanceof:
		{
			match(LITERAL_instanceof);
			type=jType();
			if ( inputState.guessing==0 ) {
				self = new JInstanceofExpression(self.getTokenReference(), self, type);
			}
			break;
		}
		case ASSIGN:
		case BAND:
		case BAND_ASSIGN:
		case BOR:
		case BOR_ASSIGN:
		case BSR_ASSIGN:
		case BXOR:
		case BXOR_ASSIGN:
		case COLON:
		case COMMA:
		case EQUAL:
		case LAND:
		case LOR:
		case MINUS_ASSIGN:
		case NOT_EQUAL:
		case PERCENT_ASSIGN:
		case PLUS_ASSIGN:
		case QUESTION:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case SEMI:
		case SLASH_ASSIGN:
		case SL_ASSIGN:
		case SR_ASSIGN:
		case STAR_ASSIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final JExpression  jUnaryExpressionNotPlusMinus(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		if ((LA(1)==BNOT||LA(1)==LNOT)) {
			{
			switch ( LA(1)) {
			case BNOT:
			{
				match(BNOT);
				if ( inputState.guessing==0 ) {
					operator = Constants.OPE_BNOT;
				}
				break;
			}
			case LNOT:
			{
				match(LNOT);
				if ( inputState.guessing==0 ) {
					operator = Constants.OPE_LNOT;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new XUnaryExpression(sourceRef, operator, self);
			}
		}
		else {
			boolean synPredMatched21 = false;
			if (((LA(1)==LPAREN) && (_tokenSet_2.member(LA(2))))) {
				int _m21 = mark();
				synPredMatched21 = true;
				inputState.guessing++;
				try {
					{
					jCastLookahead();
					}
				}
				catch (ParserException pe) {
					synPredMatched21 = false;
				}
				rewind(_m21);
				inputState.guessing--;
			}
			if ( synPredMatched21 ) {
				self=jCastExpression();
			}
			else if ((_tokenSet_3.member(LA(1))) && (_tokenSet_4.member(LA(2)))) {
				self=jPostfixExpression();
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			}
			return self;
		}
		
	public final JExpression  jUnaryExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case MINUS:
		case PLUS:
		{
			{
			switch ( LA(1)) {
			case PLUS:
			{
				match(PLUS);
				if ( inputState.guessing==0 ) {
					operator = Constants.OPE_PLUS;
				}
				break;
			}
			case MINUS:
			{
				match(MINUS);
				if ( inputState.guessing==0 ) {
					operator = Constants.OPE_MINUS;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			self=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new XUnaryExpression(sourceRef, operator, self);
			}
			break;
		}
		case INC:
		{
			self=jPreIncrementExpression();
			break;
		}
		case DEC:
		{
			self=jPreDecrementExpression();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case LNOT:
		case LPAREN:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			self=jUnaryExpressionNotPlusMinus();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final void jCastLookahead(
		
	) throws ParserException, IOException {
		
		
		Object	warn = null;
		
		
		
		if ((LA(1)==LPAREN) && (_tokenSet_5.member(LA(2)))) {
			match(LPAREN);
			warn=jPrimitiveType();
		}
		else if ((LA(1)==LPAREN) && (LA(2)==IDENT)) {
			match(LPAREN);
			warn=jName();
			{
			switch ( LA(1)) {
			case LBRACK:
			{
				match(LBRACK);
				match(RBRACK);
				break;
			}
			case RPAREN:
			{
				match(RPAREN);
				{
				switch ( LA(1)) {
				case BNOT:
				{
					match(BNOT);
					break;
				}
				case LNOT:
				{
					match(LNOT);
					break;
				}
				case LPAREN:
				{
					match(LPAREN);
					break;
				}
				case IDENT:
				{
					match(IDENT);
					break;
				}
				case LITERAL_this:
				{
					match(LITERAL_this);
					break;
				}
				case LITERAL_super:
				{
					match(LITERAL_super);
					break;
				}
				case LITERAL_new:
				{
					match(LITERAL_new);
					break;
				}
				case LITERAL_false:
				case LITERAL_null:
				case LITERAL_true:
				case CHARACTER_LITERAL:
				case INTEGER_LITERAL:
				case REAL_LITERAL:
				case STRING_LITERAL:
				{
					warn=jLiteral();
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
	}
	
	public final JCastExpression  jCastExpression(
		
	) throws ParserException, IOException {
		JCastExpression self = null;
		
		
		JExpression		expr;
		CType			dest;
		TokenReference	sourceRef = buildTokenReference();
		
		
		boolean synPredMatched74 = false;
		if (((LA(1)==LPAREN) && (_tokenSet_2.member(LA(2))))) {
			int _m74 = mark();
			synPredMatched74 = true;
			inputState.guessing++;
			try {
				{
				match(LPAREN);
				jPrimitiveType();
				}
			}
			catch (ParserException pe) {
				synPredMatched74 = false;
			}
			rewind(_m74);
			inputState.guessing--;
		}
		if ( synPredMatched74 ) {
			match(LPAREN);
			dest=jType();
			match(RPAREN);
			expr=jUnaryExpression();
			if ( inputState.guessing==0 ) {
				self = new XCastExpression(sourceRef, expr, dest);
			}
		}
		else if ((LA(1)==LPAREN) && (_tokenSet_2.member(LA(2)))) {
			match(LPAREN);
			dest=jType();
			match(RPAREN);
			expr=jUnaryExpressionNotPlusMinus();
			if ( inputState.guessing==0 ) {
				self = new XCastExpression(sourceRef, expr, dest);
			}
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
		return self;
	}
	
	public final JExpression  jPostfixExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		self=jPrimaryExpression();
		{
		switch ( LA(1)) {
		case INC:
		{
			match(INC);
			if ( inputState.guessing==0 ) {
				self = new XPostfixExpression(sourceRef, Constants.OPE_POSTINC, self);
			}
			break;
		}
		case DEC:
		{
			match(DEC);
			if ( inputState.guessing==0 ) {
				self = new XPostfixExpression(sourceRef, Constants.OPE_POSTDEC, self);
			}
			break;
		}
		case LITERAL_instanceof:
		case ASSIGN:
		case BAND:
		case BAND_ASSIGN:
		case BOR:
		case BOR_ASSIGN:
		case BSR:
		case BSR_ASSIGN:
		case BXOR:
		case BXOR_ASSIGN:
		case COLON:
		case COMMA:
		case EQUAL:
		case GE:
		case GT:
		case LAND:
		case LE:
		case LOR:
		case LT:
		case MINUS:
		case MINUS_ASSIGN:
		case NOT_EQUAL:
		case PERCENT:
		case PERCENT_ASSIGN:
		case PLUS:
		case PLUS_ASSIGN:
		case QUESTION:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case SEMI:
		case SL:
		case SLASH:
		case SLASH_ASSIGN:
		case SL_ASSIGN:
		case SR:
		case SR_ASSIGN:
		case STAR:
		case STAR_ASSIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final JExpression  jPrimaryExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case LPAREN:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			{
			self=jPrimaryPrefix();
			{
			_loop101:
			do {
				if ((_tokenSet_6.member(LA(1)))) {
					self=jPrimarySuffix(self);
				}
				else {
					break _loop101;
				}
				
			} while (true);
			}
			}
			break;
		}
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			self=xExecSqlExpression();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression  jPreIncrementExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(INC);
		self=jPrimaryExpression();
		if ( inputState.guessing==0 ) {
			self = new XPrefixExpression(sourceRef, Constants.OPE_PREINC, self);
		}
		return self;
	}
	
	public final JExpression  jPreDecrementExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(DEC);
		self=jPrimaryExpression();
		if ( inputState.guessing==0 ) {
			self = new XPrefixExpression(sourceRef, Constants.OPE_PREDEC, self);
		}
		return self;
	}
	
	public final JExpression  jStatementExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case INC:
		{
			self=jPreIncrementExpression();
			break;
		}
		case DEC:
		{
			self=jPreDecrementExpression();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case LPAREN:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			self=jPrimaryExpression();
			{
			switch ( LA(1)) {
			case INC:
			{
				match(INC);
				if ( inputState.guessing==0 ) {
					self = new XPostfixExpression(sourceRef, Constants.OPE_POSTINC, self);
				}
				break;
			}
			case DEC:
			{
				match(DEC);
				if ( inputState.guessing==0 ) {
					self = new XPostfixExpression(sourceRef, Constants.OPE_POSTDEC, self);
				}
				break;
			}
			case ASSIGN:
			case BAND_ASSIGN:
			case BOR_ASSIGN:
			case BSR_ASSIGN:
			case BXOR_ASSIGN:
			case MINUS_ASSIGN:
			case PERCENT_ASSIGN:
			case PLUS_ASSIGN:
			case SLASH_ASSIGN:
			case SL_ASSIGN:
			case SR_ASSIGN:
			case STAR_ASSIGN:
			{
				operator=jAssignmentOperator();
				right=jExpression();
				if ( inputState.guessing==0 ) {
					self = XAssignmentExpression.create(self.getTokenReference(), operator, self, right);
				}
				break;
			}
			case COMMA:
			case RCURLY:
			case RPAREN:
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final int  jAssignmentOperator(
		
	) throws ParserException, IOException {
		int self = -1;
		
		
		switch ( LA(1)) {
		case ASSIGN:
		{
			match(ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_SIMPLE;
			}
			break;
		}
		case PLUS_ASSIGN:
		{
			match(PLUS_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_PLUS;
			}
			break;
		}
		case MINUS_ASSIGN:
		{
			match(MINUS_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_MINUS;
			}
			break;
		}
		case STAR_ASSIGN:
		{
			match(STAR_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_STAR;
			}
			break;
		}
		case SLASH_ASSIGN:
		{
			match(SLASH_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_SLASH;
			}
			break;
		}
		case PERCENT_ASSIGN:
		{
			match(PERCENT_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_PERCENT;
			}
			break;
		}
		case SR_ASSIGN:
		{
			match(SR_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_SR;
			}
			break;
		}
		case BSR_ASSIGN:
		{
			match(BSR_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_BSR;
			}
			break;
		}
		case SL_ASSIGN:
		{
			match(SL_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_SL;
			}
			break;
		}
		case BAND_ASSIGN:
		{
			match(BAND_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_BAND;
			}
			break;
		}
		case BXOR_ASSIGN:
		{
			match(BXOR_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_BXOR;
			}
			break;
		}
		case BOR_ASSIGN:
		{
			match(BOR_ASSIGN);
			if ( inputState.guessing==0 ) {
				self = Constants.OPE_BOR;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression  jExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		
		
		self=jConditionalExpression();
		{
		switch ( LA(1)) {
		case ASSIGN:
		case BAND_ASSIGN:
		case BOR_ASSIGN:
		case BSR_ASSIGN:
		case BXOR_ASSIGN:
		case MINUS_ASSIGN:
		case PERCENT_ASSIGN:
		case PLUS_ASSIGN:
		case SLASH_ASSIGN:
		case SL_ASSIGN:
		case SR_ASSIGN:
		case STAR_ASSIGN:
		{
			operator=jAssignmentOperator();
			right=jExpression();
			if ( inputState.guessing==0 ) {
				self = XAssignmentExpression.create(self.getTokenReference(), operator, self, right);
			}
			break;
		}
		case COLON:
		case COMMA:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final JExpression  jShiftExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		
		
		self=jAdditiveExpression();
		{
		_loop35:
		do {
			if ((_tokenSet_7.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case SL:
				{
					match(SL);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_SL;
					}
					break;
				}
				case SR:
				{
					match(SR);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_SR;
					}
					break;
				}
				case BSR:
				{
					match(BSR);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_BSR;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				right=jAdditiveExpression();
				if ( inputState.guessing==0 ) {
					self = new XShiftExpression(self.getTokenReference(), operator, self, right);
				}
			}
			else {
				break _loop35;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jRelationalExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		int			operator = -1;
		JExpression		right;
		
		
		self=jShiftExpression();
		{
		_loop39:
		do {
			if ((_tokenSet_8.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case LT:
				{
					match(LT);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_LT;
					}
					break;
				}
				case GT:
				{
					match(GT);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_GT;
					}
					break;
				}
				case LE:
				{
					match(LE);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_LE;
					}
					break;
				}
				case GE:
				{
					match(GE);
					if ( inputState.guessing==0 ) {
						operator = Constants.OPE_GE;
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				right=jShiftExpression();
				if ( inputState.guessing==0 ) {
					self = new XRelationalExpression(self.getTokenReference(), operator, self, right);
				}
			}
			else {
				break _loop39;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jPrimaryPrefix(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		Token  id = null;
		Token  id2 = null;
		
		JExpression		expr = null;
		CType			type = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_true:
		case CHARACTER_LITERAL:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		{
			self=jLiteral();
			break;
		}
		case LITERAL_this:
		{
			match(LITERAL_this);
			if ( inputState.guessing==0 ) {
				self = new JThisExpression(sourceRef );
			}
			break;
		}
		case LITERAL_super:
		{
			match(LITERAL_super);
			match(DOT);
			id = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				self = new XNameExpression(sourceRef,
								 new JSuperExpression(sourceRef ),
								 id.getText());
			}
			break;
		}
		case LPAREN:
		{
			match(LPAREN);
			expr=jExpression();
			match(RPAREN);
			if ( inputState.guessing==0 ) {
				self = new JParenthesedExpression(sourceRef, expr);
			}
			break;
		}
		case LITERAL_new:
		{
			self=jAllocationExpression(null);
			break;
		}
		default:
			boolean synPredMatched42 = false;
			if (((_tokenSet_2.member(LA(1))) && (LA(2)==DOT||LA(2)==LBRACK))) {
				int _m42 = mark();
				synPredMatched42 = true;
				inputState.guessing++;
				try {
					{
					jType();
					match(DOT);
					match(LITERAL_class);
					}
				}
				catch (ParserException pe) {
					synPredMatched42 = false;
				}
				rewind(_m42);
				inputState.guessing--;
			}
			if ( synPredMatched42 ) {
				type=jType();
				match(DOT);
				match(LITERAL_class);
				if ( inputState.guessing==0 ) {
					self = new JClassExpression(sourceRef, type);
				}
			}
			else if ((LA(1)==IDENT) && (_tokenSet_9.member(LA(2)))) {
				id2 = LT(1);
				match(IDENT);
				{
				if ((LA(1)==DOT) && (LA(2)==LITERAL_class)) {
					match(DOT);
					match(LITERAL_class);
					if ( inputState.guessing==0 ) {
						self = new JClassExpression(buildTokenReference(), CClassType.lookup(id2.getText()));
					}
				}
				else if ((_tokenSet_9.member(LA(1))) && (_tokenSet_10.member(LA(2)))) {
				}
				else {
					throw new NoViableAltException(LT(1));
				}
				
				}
				if ( inputState.guessing==0 ) {
					self = self == null ? new XNameExpression(buildTokenReference(), id2.getText()) : self;
				}
			}
			else if (((LA(1) >= LITERAL_date && LA(1) <= LITERAL_time)) && (_tokenSet_9.member(LA(2)))) {
				type=xPrimitiveType();
				{
				if ((LA(1)==DOT) && (LA(2)==LITERAL_class)) {
					match(DOT);
					match(LITERAL_class);
					if ( inputState.guessing==0 ) {
						self = new JClassExpression(buildTokenReference(), type);
					}
				}
				else if ((_tokenSet_9.member(LA(1))) && (_tokenSet_10.member(LA(2)))) {
				}
				else {
					throw new NoViableAltException(LT(1));
				}
				
				}
				if ( inputState.guessing==0 ) {
					self = self == null ? new XNameExpression(buildTokenReference(), ((CClassType)type).getQualifiedName().replace('/', '.'), true) : self;
				}
			}
			else if ((_tokenSet_5.member(LA(1))) && (LA(2)==DOT)) {
				type=jPrimitiveType();
				match(DOT);
				match(LITERAL_class);
				if ( inputState.guessing==0 ) {
					self = new JClassExpression(buildTokenReference(), type);
				}
			}
		else {
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression  jLiteral(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		Token  i = null;
		Token  r = null;
		Token  c = null;
		Token  s = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case INTEGER_LITERAL:
		{
			i = LT(1);
			match(INTEGER_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JOrdinalLiteral(sourceRef, i.getText());
			}
			break;
		}
		case REAL_LITERAL:
		{
			r = LT(1);
			match(REAL_LITERAL);
			if ( inputState.guessing==0 ) {
				
				if (isKopiFile) {
				self = new XFixedLiteral(sourceRef, r.getText());
				} else {
				self = new JRealLiteral(sourceRef, r.getText());
				}
				
			}
			break;
		}
		case CHARACTER_LITERAL:
		{
			c = LT(1);
			match(CHARACTER_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JCharLiteral(sourceRef, c.getText());
			}
			break;
		}
		case STRING_LITERAL:
		{
			s = LT(1);
			match(STRING_LITERAL);
			if ( inputState.guessing==0 ) {
				self = new JStringLiteral(sourceRef, s.getText());
			}
			break;
		}
		case LITERAL_true:
		{
			match(LITERAL_true);
			if ( inputState.guessing==0 ) {
				self = new JBooleanLiteral(sourceRef, true);
			}
			break;
		}
		case LITERAL_false:
		{
			match(LITERAL_false);
			if ( inputState.guessing==0 ) {
				self = new JBooleanLiteral(sourceRef, false);
			}
			break;
		}
		case LITERAL_null:
		{
			match(LITERAL_null);
			if ( inputState.guessing==0 ) {
				self = new JNullLiteral(sourceRef );
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression  jAllocationExpression(
		JExpression expr
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		CType			type = null;
		JClassDeclaration	decl = null;
		JArrayDimsAndInits	arr = null;
		String		name = null;
		JExpression[]		args = JExpression.EMPTY;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_new);
		{
		boolean synPredMatched54 = false;
		if (((_tokenSet_5.member(LA(1))) && (LA(2)==LBRACK))) {
			int _m54 = mark();
			synPredMatched54 = true;
			inputState.guessing++;
			try {
				{
				javaPrimitiveType();
				}
			}
			catch (ParserException pe) {
				synPredMatched54 = false;
			}
			rewind(_m54);
			inputState.guessing--;
		}
		if ( synPredMatched54 ) {
			type=jPrimitiveType();
			arr=jArrayDimsAndInits();
			if ( inputState.guessing==0 ) {
				self = new JNewArrayExpression(sourceRef, type, arr);
			}
		}
		else {
			boolean synPredMatched56 = false;
			if ((((LA(1) >= LITERAL_date && LA(1) <= LITERAL_time)) && (LA(2)==LBRACK||LA(2)==LPAREN))) {
				int _m56 = mark();
				synPredMatched56 = true;
				inputState.guessing++;
				try {
					{
					xPrimitiveType();
					}
				}
				catch (ParserException pe) {
					synPredMatched56 = false;
				}
				rewind(_m56);
				inputState.guessing--;
			}
			if ( synPredMatched56 ) {
				type=xPrimitiveType();
				{
				switch ( LA(1)) {
				case LBRACK:
				{
					arr=jArrayDimsAndInits();
					if ( inputState.guessing==0 ) {
						self = new JNewArrayExpression(sourceRef, (CClassType)type, arr);
					}
					break;
				}
				case LPAREN:
				{
					args=jArguments();
					{
					switch ( LA(1)) {
					case LCURLY:
					{
						decl=jInnerClassBody(name);
						if ( inputState.guessing==0 ) {
							self = new JNewAnonymousClassExpression(sourceRef, (CClassType)type, expr, args, decl);
						}
						break;
					}
					case LITERAL_instanceof:
					case ASSIGN:
					case BAND:
					case BAND_ASSIGN:
					case BOR:
					case BOR_ASSIGN:
					case BSR:
					case BSR_ASSIGN:
					case BXOR:
					case BXOR_ASSIGN:
					case COLON:
					case COMMA:
					case DEC:
					case DOT:
					case EQUAL:
					case GE:
					case GT:
					case INC:
					case LAND:
					case LBRACK:
					case LE:
					case LOR:
					case LPAREN:
					case LT:
					case MINUS:
					case MINUS_ASSIGN:
					case NOT_EQUAL:
					case PERCENT:
					case PERCENT_ASSIGN:
					case PLUS:
					case PLUS_ASSIGN:
					case QUESTION:
					case RBRACK:
					case RCURLY:
					case RPAREN:
					case SEMI:
					case SL:
					case SLASH:
					case SLASH_ASSIGN:
					case SL_ASSIGN:
					case SR:
					case SR_ASSIGN:
					case STAR:
					case STAR_ASSIGN:
					{
						if ( inputState.guessing==0 ) {
							self = new JNewObjectExpression(sourceRef, (CClassType)type, expr, args);
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1));
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
			}
			else if ((LA(1)==IDENT)) {
				name=jName();
				{
				switch ( LA(1)) {
				case LBRACK:
				{
					arr=jArrayDimsAndInits();
					if ( inputState.guessing==0 ) {
						self = new JNewArrayExpression(sourceRef, CClassType.lookup(name), arr);
					}
					break;
				}
				case LPAREN:
				{
					args=jArguments();
					{
					switch ( LA(1)) {
					case LCURLY:
					{
						decl=jInnerClassBody(name);
						if ( inputState.guessing==0 ) {
							self = new JNewAnonymousClassExpression(sourceRef, CClassType.lookup(name), expr, args, decl);
						}
						break;
					}
					case LITERAL_instanceof:
					case ASSIGN:
					case BAND:
					case BAND_ASSIGN:
					case BOR:
					case BOR_ASSIGN:
					case BSR:
					case BSR_ASSIGN:
					case BXOR:
					case BXOR_ASSIGN:
					case COLON:
					case COMMA:
					case DEC:
					case DOT:
					case EQUAL:
					case GE:
					case GT:
					case INC:
					case LAND:
					case LBRACK:
					case LE:
					case LOR:
					case LPAREN:
					case LT:
					case MINUS:
					case MINUS_ASSIGN:
					case NOT_EQUAL:
					case PERCENT:
					case PERCENT_ASSIGN:
					case PLUS:
					case PLUS_ASSIGN:
					case QUESTION:
					case RBRACK:
					case RCURLY:
					case RPAREN:
					case SEMI:
					case SL:
					case SLASH:
					case SLASH_ASSIGN:
					case SL_ASSIGN:
					case SR:
					case SR_ASSIGN:
					case STAR:
					case STAR_ASSIGN:
					{
						if ( inputState.guessing==0 ) {
							self = new JNewObjectExpression(sourceRef, CClassType.lookup(name), expr, args);
						}
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1));
					}
					}
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			}
			}
			return self;
		}
		
	public final CType  jType(
		
	) throws ParserException, IOException {
		CType self = null;
		
		
		String		name = null;
		int			bounds = 0;
		
		
		{
		switch ( LA(1)) {
		case IDENT:
		{
			name=jName();
			if ( inputState.guessing==0 ) {
				self = CClassType.lookup(name);
			}
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			self=jPrimitiveType();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		_loop168:
		do {
			if ((LA(1)==LBRACK) && (LA(2)==RBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop168;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
				self = new CArrayType(self, bounds);
			}
			
		}
		return self;
	}
	
	public final CType  xPrimitiveType(
		
	) throws ParserException, IOException {
		CType self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_fixed:
		{
			match(LITERAL_fixed);
			if ( inputState.guessing==0 ) {
				self = XStdType.PFixed;
			}
			break;
		}
		case LITERAL_month:
		{
			match(LITERAL_month);
			if ( inputState.guessing==0 ) {
				self = XStdType.PMonth;
			}
			break;
		}
		case LITERAL_date:
		{
			match(LITERAL_date);
			if ( inputState.guessing==0 ) {
				self = XStdType.PDate;
			}
			break;
		}
		case LITERAL_time:
		{
			match(LITERAL_time);
			if ( inputState.guessing==0 ) {
				self = XStdType.PTime;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final CType  jPrimitiveType(
		
	) throws ParserException, IOException {
		CType self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			self=xPrimitiveType();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		{
			self=javaPrimitiveType();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression  jPrimarySuffix(
		JExpression prefix
	) throws ParserException, IOException {
		JExpression self = null;
		
		Token  id1 = null;
		
		JExpression		expr = null;
		JExpression[]	args;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LBRACK:
		{
			match(LBRACK);
			expr=jExpression();
			match(RBRACK);
			if ( inputState.guessing==0 ) {
				self = new JArrayAccessExpression(sourceRef, prefix, expr);
			}
			break;
		}
		case LPAREN:
		{
			args=jArguments();
			if ( inputState.guessing==0 ) {
				self = new XMethodCallExpression(sourceRef, prefix, args);
			}
			break;
		}
		default:
			boolean synPredMatched47 = false;
			if (((LA(1)==DOT) && (LA(2)==LITERAL_this))) {
				int _m47 = mark();
				synPredMatched47 = true;
				inputState.guessing++;
				try {
					{
					match(DOT);
					match(LITERAL_this);
					}
				}
				catch (ParserException pe) {
					synPredMatched47 = false;
				}
				rewind(_m47);
				inputState.guessing--;
			}
			if ( synPredMatched47 ) {
				match(DOT);
				match(LITERAL_this);
				if ( inputState.guessing==0 ) {
					self = new JThisExpression(sourceRef, prefix);
				}
			}
			else if ((LA(1)==DOT) && (LA(2)==LITERAL_new)) {
				match(DOT);
				self=jAllocationExpression(prefix);
			}
			else if ((LA(1)==DOT) && (LA(2)==IDENT)) {
				match(DOT);
				id1 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					self = new XNameExpression(sourceRef, prefix, id1.getText());
				}
			}
		else {
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JExpression[]  jArguments(
		
	) throws ParserException, IOException {
		JExpression[] self = JExpression.EMPTY;
		
		
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			self=jArgumentList();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		return self;
	}
	
	public final CType  javaPrimitiveType(
		
	) throws ParserException, IOException {
		CType self = null;
		
		
		switch ( LA(1)) {
		case LITERAL_boolean:
		{
			match(LITERAL_boolean);
			if ( inputState.guessing==0 ) {
				self = CStdType.Boolean;
			}
			break;
		}
		case LITERAL_byte:
		{
			match(LITERAL_byte);
			if ( inputState.guessing==0 ) {
				self = CStdType.Byte;
			}
			break;
		}
		case LITERAL_char:
		{
			match(LITERAL_char);
			if ( inputState.guessing==0 ) {
				self = CStdType.Char;
			}
			break;
		}
		case LITERAL_double:
		{
			match(LITERAL_double);
			if ( inputState.guessing==0 ) {
				self = CStdType.Double;
			}
			break;
		}
		case LITERAL_float:
		{
			match(LITERAL_float);
			if ( inputState.guessing==0 ) {
				self = CStdType.Float;
			}
			break;
		}
		case LITERAL_int:
		{
			match(LITERAL_int);
			if ( inputState.guessing==0 ) {
				self = CStdType.Integer;
			}
			break;
		}
		case LITERAL_long:
		{
			match(LITERAL_long);
			if ( inputState.guessing==0 ) {
				self = CStdType.Long;
			}
			break;
		}
		case LITERAL_short:
		{
			match(LITERAL_short);
			if ( inputState.guessing==0 ) {
				self = CStdType.Short;
			}
			break;
		}
		case LITERAL_void:
		{
			match(LITERAL_void);
			if ( inputState.guessing==0 ) {
				self = CStdType.Void;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JArrayDimsAndInits  jArrayDimsAndInits(
		
	) throws ParserException, IOException {
		JArrayDimsAndInits self = null;
		
		
		boolean		expr = false;
		boolean		unspec = false;
		Vector		vect = VectorCache.request(VectorCache.SMALL);
		JExpression		exp  = null;
		JArrayInitializer	init = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		int _cnt218=0;
		_loop218:
		do {
			if ((LA(1)==LBRACK) && (_tokenSet_11.member(LA(2)))) {
				match(LBRACK);
				{
				if (((_tokenSet_12.member(LA(1))))&&( !unspec )) {
					exp=jExpression();
					if ( inputState.guessing==0 ) {
						expr = true;
					}
				}
				else if ((LA(1)==RBRACK)) {
					if ( inputState.guessing==0 ) {
						unspec = true;
					}
				}
				else {
					throw new NoViableAltException(LT(1));
				}
				
				}
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					vect.addElement(exp); exp = null;
				}
			}
			else {
				if ( _cnt218>=1 ) { break _loop218; } else {throw new NoViableAltException(LT(1));}
			}
			
			_cnt218++;
		} while (true);
		}
		{
		if (((LA(1)==LCURLY))&&( expr == false )) {
			init=jArrayInitializer();
		}
		else if ((_tokenSet_9.member(LA(1)))) {
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
		}
		if ( inputState.guessing==0 ) {
			
			self =  new JArrayDimsAndInits(sourceRef, 
							    (JExpression[])at.dms.compiler.Utils.vectorToArray(vect, JExpression.class), 
							    init); 
			VectorCache.release(vect);     
			
		}
		return self;
	}
	
	public final JClassDeclaration  jInnerClassBody(
		String name
	) throws ParserException, IOException {
		JClassDeclaration self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		CParseClassContext	context = CParseClassContext.getInstance();
		
		
		match(LCURLY);
		{
		_loop153:
		do {
			switch ( LA(1)) {
			case LITERAL_abstract:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_class:
			case LITERAL_double:
			case LITERAL_final:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_interface:
			case LITERAL_long:
			case LITERAL_native:
			case LITERAL_private:
			case LITERAL_protected:
			case LITERAL_public:
			case LITERAL_short:
			case LITERAL_static:
			case LITERAL_synchronized:
			case LITERAL_transient:
			case LITERAL_void:
			case LITERAL_volatile:
			case LCURLY:
			case IDENT:
			case LITERAL_date:
			case LITERAL_fixed:
			case LITERAL_month:
			case LITERAL_time:
			case CURSOR_SQL:
			{
				jClassBodyDeclaration(context);
				break;
			}
			case SEMI:
			{
				match(SEMI);
				if ( inputState.guessing==0 ) {
					reportTrouble(new CWarning(sourceRef, "stray-semicolon", null));
				}
				break;
			}
			default:
			{
				break _loop153;
			}
			}
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = new JClassDeclaration(sourceRef,
						       0,
						       name,
						       null,
						       new CClassType[]{},
						       context.getFields(),
						       context.getMethods(),
						       context.getInnerClasses(),			       
						       context.getBody(),
						       getJavadocComment(),
						       getStatementComment());
			context.release();
			
		}
		return self;
	}
	
	public final String  jName(
		
	) throws ParserException, IOException {
		String self = null;
		
		Token  i = null;
		Token  j = null;
		
		StringBuffer buffer = null;
		
		
		i = LT(1);
		match(IDENT);
		{
		_loop185:
		do {
			if ((LA(1)==DOT) && (LA(2)==IDENT)) {
				match(DOT);
				j = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					(buffer == null ? (buffer = new StringBuffer(i.getText())) : buffer).append('/').append(j.getText());
				}
			}
			else {
				break _loop185;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = buffer == null ? i.getText() : buffer.toString();
		}
		return self;
	}
	
	public final JExpression  jInclusiveOrExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		right;
		
		
		self=jExclusiveOrExpression();
		{
		_loop65:
		do {
			if ((LA(1)==BOR)) {
				match(BOR);
				right=jExclusiveOrExpression();
				if ( inputState.guessing==0 ) {
					self = new XBitwiseExpression(self.getTokenReference(), Constants.OPE_BOR, self, right);
				}
			}
			else {
				break _loop65;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jExclusiveOrExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		right;
		
		
		self=jAndExpression();
		{
		_loop68:
		do {
			if ((LA(1)==BXOR)) {
				match(BXOR);
				right=jAndExpression();
				if ( inputState.guessing==0 ) {
					self = new XBitwiseExpression(self.getTokenReference(), Constants.OPE_BXOR, self, right);
				}
			}
			else {
				break _loop68;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jAndExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		right;
		
		
		self=jEqualityExpression();
		{
		_loop71:
		do {
			if ((LA(1)==BAND)) {
				match(BAND);
				right=jEqualityExpression();
				if ( inputState.guessing==0 ) {
					self = new XBitwiseExpression(self.getTokenReference(), Constants.OPE_BAND, self, right);
				}
			}
			else {
				break _loop71;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jConditionalExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		middle;
		JExpression		right;
		
		
		self=jConditionalOrExpression();
		{
		switch ( LA(1)) {
		case QUESTION:
		{
			match(QUESTION);
			middle=jExpression();
			match(COLON);
			right=jConditionalExpression();
			if ( inputState.guessing==0 ) {
				self = new JConditionalExpression(self.getTokenReference(), self, middle, right);
			}
			break;
		}
		case ASSIGN:
		case BAND_ASSIGN:
		case BOR_ASSIGN:
		case BSR_ASSIGN:
		case BXOR_ASSIGN:
		case COLON:
		case COMMA:
		case MINUS_ASSIGN:
		case PERCENT_ASSIGN:
		case PLUS_ASSIGN:
		case RBRACK:
		case RCURLY:
		case RPAREN:
		case SEMI:
		case SLASH_ASSIGN:
		case SL_ASSIGN:
		case SR_ASSIGN:
		case STAR_ASSIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		return self;
	}
	
	public final JVariableDefinition  jVariableDeclarator(
		int mods, CType type
	) throws ParserException, IOException {
		JVariableDefinition self = null;
		
		Token  ident = null;
		
		int			bounds = 0;
		JExpression		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		ident = LT(1);
		match(IDENT);
		{
		_loop81:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop81;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case ASSIGN:
		{
			match(ASSIGN);
			expr=jVariableInitializer();
			break;
		}
		case COMMA:
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
				reportTrouble(new CWarning(sourceRef, "old-style-array-bounds", null));
				type = new CArrayType(type, bounds);
			}
			
			self = new XVariableDefinition(sourceRef, mods, type, ident.getText(), expr);
			
		}
		return self;
	}
	
	public final JExpression  jVariableInitializer(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		switch ( LA(1)) {
		case LCURLY:
		{
			self=jArrayInitializer();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			self=jExpression();
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JStatement  jBlockStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JTypeDeclaration type;
		
		
		if ((LA(1)==LITERAL_final)) {
			match(LITERAL_final);
			self=jLocalVariableDeclaration(at.dms.kjc.Constants.ACC_FINAL);
			match(SEMI);
		}
		else {
			boolean synPredMatched85 = false;
			if (((_tokenSet_2.member(LA(1))) && (_tokenSet_13.member(LA(2))))) {
				int _m85 = mark();
				synPredMatched85 = true;
				inputState.guessing++;
				try {
					{
					jType();
					match(IDENT);
					}
				}
				catch (ParserException pe) {
					synPredMatched85 = false;
				}
				rewind(_m85);
				inputState.guessing--;
			}
			if ( synPredMatched85 ) {
				self=jLocalVariableDeclaration(0);
				match(SEMI);
			}
			else if ((_tokenSet_14.member(LA(1))) && (_tokenSet_15.member(LA(2)))) {
				self=jStatement();
				if ( inputState.guessing==0 ) {
					
					if (self instanceof JEmptyStatement) {
						reportTrouble(new CWarning(self.getTokenReference(), "stray-semicolon", null));
					}
					
				}
			}
			else if ((_tokenSet_16.member(LA(1))) && (LA(2)==IDENT)) {
				{
				switch ( LA(1)) {
				case LITERAL_class:
				{
					type=jClassDeclaration(0);
					break;
				}
				case LITERAL_interface:
				{
					type=jInterfaceDeclaration(0);
					break;
				}
				case CURSOR_SQL:
				{
					type=xCursorDeclaration(0);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1));
				}
				}
				}
				if ( inputState.guessing==0 ) {
					self = new JTypeDeclarationStatement(type.getTokenReference(), type);
				}
			}
			else if ((LA(1)==CURSOR_SQL) && (_tokenSet_17.member(LA(2)))) {
				self=xAnonymousCursorDeclaration();
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			}
			return self;
		}
		
	public final JVariableDeclarationStatement  jLocalVariableDeclaration(
		int mods
	) throws ParserException, IOException {
		JVariableDeclarationStatement self = null;
		
		
		CType			type;
		Vector		vars = VectorCache.request(VectorCache.SMALL);
		JVariableDefinition	decl;
		TokenReference	sourceRef = buildTokenReference();
		
		
		type=jType();
		decl=jVariableDeclarator(mods, type);
		if ( inputState.guessing==0 ) {
			vars.addElement(decl);
		}
		{
		_loop229:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				decl=jVariableDeclarator(mods, type);
				if ( inputState.guessing==0 ) {
					vars.addElement(decl);
				}
			}
			else {
				break _loop229;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = new JVariableDeclarationStatement(sourceRef, 
								       (JVariableDefinition[])at.dms.compiler.Utils.vectorToArray(vars, JVariableDefinition.class),
								       getStatementComment());
			VectorCache.release(vars);
			
		}
		return self;
	}
	
	public final JStatement  jStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		switch ( LA(1)) {
		case SEMI:
		{
			self=jEmptyStatement();
			break;
		}
		case LCURLY:
		{
			self=jBlock();
			break;
		}
		case LITERAL_switch:
		{
			self=jSwitchStatement();
			break;
		}
		case LITERAL_if:
		{
			self=jIfStatement();
			break;
		}
		case LITERAL_while:
		{
			self=jWhileStatement();
			break;
		}
		case LITERAL_do:
		{
			self=jDoStatement();
			break;
		}
		case LITERAL_for:
		{
			self=jForStatement();
			break;
		}
		case LITERAL_break:
		{
			self=jBreakStatement();
			break;
		}
		case LITERAL_continue:
		{
			self=jContinueStatement();
			break;
		}
		case LITERAL_return:
		{
			self=jReturnStatement();
			break;
		}
		case LITERAL_throw:
		{
			self=jThrowStatement();
			break;
		}
		case LITERAL_synchronized:
		{
			self=jSynchronizedStatement();
			break;
		}
		case LITERAL_try:
		{
			self=jTryStatement();
			break;
		}
		case ASSERT:
		{
			self=xAssertStatement();
			break;
		}
		case FAIL:
		{
			self=xFailStatement();
			break;
		}
		case EXECUTE_SQL:
		{
			self=xExecSqlStatement();
			break;
		}
		case PROTECTED_SQL:
		{
			self=xProtectedStatement();
			break;
		}
		case UNPROTECTED_SQL:
		{
			self=xUnprotectedStatement();
			break;
		}
		default:
			if ((LA(1)==IDENT) && (LA(2)==COLON)) {
				self=jLabeledStatement();
			}
			else if ((_tokenSet_18.member(LA(1))) && (_tokenSet_19.member(LA(2)))) {
				self=jExpressionStatement();
			}
		else {
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final XLocalCursorDeclaration  xAnonymousCursorDeclaration(
		
	) throws ParserException, IOException {
		XLocalCursorDeclaration self = null;
		
		Token  ident = null;
		Token  ident2 = null;
		
		CParseClassContext	context = CParseClassContext.getInstance();
		XCursorDeclaration	curs = null;
		JExpression		ctxt = null;
		CClassType		type = null;
		TokenReference	sourceRef = buildTokenReference();
		XSelectStatement	sel = null;
		JFormalParameter[]	parameters = null;
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(CURSOR_SQL);
		{
		switch ( LA(1)) {
		case LBRACK:
		{
			ctxt=xOptionalContext();
			break;
		}
		case LCURLY:
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LCURLY:
		{
			xExplicitCursorBody(context);
			break;
		}
		case LPAREN:
		{
			parameters=jFormalParameters(JLocalVariable.DES_PARAMETER);
			sel=xImplicitCursorBody(context);
			if ( inputState.guessing==0 ) {
				
				XCursorDeclaration.addImplicitSelect(context, sel, parameters);
				
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			curs = new XCursorDeclaration(sourceRef,
							     XConstants.ACC_FINAL,
							     null,
							     context.getFields(),
							     context.getMethods(),
							     context.getInnerClasses(),
							     context.getBody(),
							     sel,
						             parameters,	
							     javadoc,
							     comments);
			context.release();
			
			self = new XLocalCursorDeclaration(sourceRef,
								  curs,
								  comments);
			{ self.setConnection(ctxt); } // !!!
			
		}
		if ( inputState.guessing==0 ) {
			type = CClassType.lookup(curs.getIdent());
		}
		ident = LT(1);
		match(IDENT);
		if ( inputState.guessing==0 ) {
			self.addDeclaration(ident.getText());
		}
		{
		_loop108:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				ident2 = LT(1);
				match(IDENT);
				if ( inputState.guessing==0 ) {
					self.addDeclaration(ident2.getText());
				}
			}
			else {
				break _loop108;
			}
			
		} while (true);
		}
		match(SEMI);
		return self;
	}
	
	public final JEmptyStatement  jEmptyStatement(
		
	) throws ParserException, IOException {
		JEmptyStatement self = null;
		
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JEmptyStatement(sourceRef, getStatementComment());
		}
		return self;
	}
	
	public final JStatement  jLabeledStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		Token  label = null;
		
		JStatement		stmt;
		TokenReference	sourceRef = buildTokenReference();
		
		
		label = LT(1);
		match(IDENT);
		match(COLON);
		stmt=jStatement();
		if ( inputState.guessing==0 ) {
			self = new JLabeledStatement(sourceRef, label.getText(), stmt, getStatementComment());
		}
		return self;
	}
	
	public final JExpressionStatement  jExpressionStatement(
		
	) throws ParserException, IOException {
		JExpressionStatement self = null;
		
		
		JExpression		expr;
		TokenReference	sourceRef = buildTokenReference();
		
		
		expr=jStatementExpression();
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JExpressionStatement(sourceRef, expr, getStatementComment());
		}
		return self;
	}
	
	public final JStatement  jSwitchStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JExpression		expr;
		Vector		body = VectorCache.request(VectorCache.SMALL);
		
		Vector		labels = Constants.VECTOR_EMPTY;
		Vector		stmts = Constants.VECTOR_EMPTY;
		
		JSwitchLabel		label;
		JStatement		stmt;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_switch);
		match(LPAREN);
		expr=jExpression();
		match(RPAREN);
		match(LCURLY);
		{
		_loop238:
		do {
			if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default)) {
				if ( inputState.guessing==0 ) {
					
					labels = new Vector();
						stmts  = new Vector();
					
				}
				{
				int _cnt235=0;
				_loop235:
				do {
					if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default) && (_tokenSet_20.member(LA(2)))) {
						label=jSwitchLabel();
						if ( inputState.guessing==0 ) {
							labels.addElement(label);
						}
					}
					else {
						if ( _cnt235>=1 ) { break _loop235; } else {throw new NoViableAltException(LT(1));}
					}
					
					_cnt235++;
				} while (true);
				}
				{
				_loop237:
				do {
					if ((_tokenSet_0.member(LA(1)))) {
						stmt=jBlockStatement();
						if ( inputState.guessing==0 ) {
							stmts.addElement(stmt);
						}
					}
					else {
						break _loop237;
					}
					
				} while (true);
				}
				if ( inputState.guessing==0 ) {
					body.addElement(new JSwitchGroup(sourceRef,
										 (JSwitchLabel[])at.dms.compiler.Utils.vectorToArray(labels, JSwitchLabel.class), 
										 (JStatement[])at.dms.compiler.Utils.vectorToArray(stmts, JStatement.class)));
				}
			}
			else {
				break _loop238;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = new JSwitchStatement(sourceRef,
							  expr, 
							  (JSwitchGroup[])at.dms.compiler.Utils.vectorToArray(body, JSwitchGroup.class),
							  getStatementComment());
			VectorCache.release(body);
			
		}
		return self;
	}
	
	public final JIfStatement  jIfStatement(
		
	) throws ParserException, IOException {
		JIfStatement self = null;
		
		
		JExpression		cond;
		JStatement		thenClause;
		JStatement		elseClause = null;
		TokenReference	sourceRef = buildTokenReference();
		int			count = 0;
		
		
		match(LITERAL_if);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		thenClause=jStatement();
		{
		_loop242:
		do {
			if ((LA(1)==LITERAL_else) && (_tokenSet_14.member(LA(2)))) {
				if ( inputState.guessing==0 ) {
					
					if (count++ > 0) {
					break;
					}
					
				}
				match(LITERAL_else);
				elseClause=jStatement();
			}
			else {
				break _loop242;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (! (thenClause instanceof JBlock)) {
				reportTrouble(new CWarning(sourceRef, "enclose-if-then-in-block", null));
			}
			if (elseClause != null && !(elseClause instanceof JBlock || elseClause instanceof JIfStatement)) {
				reportTrouble(new CWarning(sourceRef, "enclose-if-else-in-block", null));
			}
			self = new JIfStatement(sourceRef, cond, thenClause, elseClause, getStatementComment());
			
		}
		return self;
	}
	
	public final JWhileStatement  jWhileStatement(
		
	) throws ParserException, IOException {
		JWhileStatement self = null;
		
		
		JExpression		cond;
		JStatement		body;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_while);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		body=jStatement();
		if ( inputState.guessing==0 ) {
			
			if (!(body instanceof JBlock || body instanceof JEmptyStatement)) {
				reportTrouble(new CWarning(sourceRef, "enclose-loop-body-in-block", null));
			}
			self = new JWhileStatement(sourceRef, cond, body, getStatementComment());
			
		}
		return self;
	}
	
	public final JDoStatement  jDoStatement(
		
	) throws ParserException, IOException {
		JDoStatement self = null;
		
		
		JExpression		cond;
		JStatement		body;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_do);
		body=jStatement();
		match(LITERAL_while);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		match(SEMI);
		if ( inputState.guessing==0 ) {
			
			if (! (body instanceof JBlock)) {
				reportTrouble(new CWarning(sourceRef, "enclose-loop-body-in-block", null));
			}
			self = new JDoStatement(sourceRef, cond, body, getStatementComment());
			
		}
		return self;
	}
	
	public final JStatement  jForStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JStatement		init = null;
		JExpression		cond = null;
		JStatement		incr = null;
		JStatement		body = null;
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(LITERAL_for);
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_final:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case DEC:
		case INC:
		case LPAREN:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			init=jForInit();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			cond=jExpression();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case DEC:
		case INC:
		case LPAREN:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			incr=jStatementExpressionList();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		body=jStatement();
		if ( inputState.guessing==0 ) {
			
			if (!(body instanceof JBlock || body instanceof JEmptyStatement)) {
				reportTrouble(new CWarning(sourceRef, "enclose-loop-body-in-block", null));
			}
			self = new JForStatement(sourceRef, init, cond, incr, body, comments);
			
		}
		return self;
	}
	
	public final JBreakStatement  jBreakStatement(
		
	) throws ParserException, IOException {
		JBreakStatement self = null;
		
		Token  ident = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_break);
		{
		switch ( LA(1)) {
		case IDENT:
		{
			ident = LT(1);
			match(IDENT);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JBreakStatement(sourceRef, ident == null ? null : ident.getText(), getStatementComment());
		}
		return self;
	}
	
	public final JContinueStatement  jContinueStatement(
		
	) throws ParserException, IOException {
		JContinueStatement self = null;
		
		Token  ident = null;
		
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_continue);
		{
		switch ( LA(1)) {
		case IDENT:
		{
			ident = LT(1);
			match(IDENT);
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JContinueStatement(sourceRef, ident == null ? null : ident.getText(), getStatementComment());
		}
		return self;
	}
	
	public final JReturnStatement  jReturnStatement(
		
	) throws ParserException, IOException {
		JReturnStatement self = null;
		
		
		JExpression		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_return);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			expr=jExpression();
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new XReturnStatement(sourceRef, expr, getStatementComment());
		}
		return self;
	}
	
	public final JStatement  jThrowStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JExpression		expr;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_throw);
		expr=jExpression();
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JThrowStatement(sourceRef, expr, getStatementComment());
		}
		return self;
	}
	
	public final JSynchronizedStatement  jSynchronizedStatement(
		
	) throws ParserException, IOException {
		JSynchronizedStatement self = null;
		
		
		JExpression		cond;
		JStatement		body;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_synchronized);
		match(LPAREN);
		cond=jExpression();
		match(RPAREN);
		body=jBlock();
		if ( inputState.guessing==0 ) {
			self = new JSynchronizedStatement(sourceRef, cond, body, getStatementComment());
		}
		return self;
	}
	
	public final JStatement  jTryStatement(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JBlock		tryClause;
		Vector		catchClauses = VectorCache.request(VectorCache.SMALL);
		JBlock		finallyClause = null;
		JCatchClause		catcher = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_try);
		tryClause=jBlock();
		{
		_loop263:
		do {
			if ((LA(1)==LITERAL_catch)) {
				catcher=jCatchClause();
				if ( inputState.guessing==0 ) {
					catchClauses.addElement(catcher);
				}
			}
			else {
				break _loop263;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_finally:
		{
			match(LITERAL_finally);
			finallyClause=jBlock();
			break;
		}
		case LITERAL_boolean:
		case LITERAL_break:
		case LITERAL_byte:
		case LITERAL_case:
		case LITERAL_char:
		case LITERAL_class:
		case LITERAL_continue:
		case LITERAL_default:
		case LITERAL_do:
		case LITERAL_double:
		case LITERAL_else:
		case LITERAL_false:
		case LITERAL_final:
		case LITERAL_float:
		case LITERAL_for:
		case LITERAL_if:
		case LITERAL_int:
		case LITERAL_interface:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_return:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_switch:
		case LITERAL_synchronized:
		case LITERAL_this:
		case LITERAL_throw:
		case LITERAL_true:
		case LITERAL_try:
		case LITERAL_void:
		case LITERAL_while:
		case DEC:
		case INC:
		case LCURLY:
		case LPAREN:
		case RCURLY:
		case SEMI:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case ASSERT:
		case CURSOR_SQL:
		case DELETE_SQL:
		case EXECUTE_SQL:
		case FAIL:
		case PROTECTED_SQL:
		case UNPROTECTED_SQL:
		case UPDATE_SQL:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			if (catchClauses.size() > 0) {
				self = new JTryCatchStatement(sourceRef,
							      tryClause,
							      (JCatchClause[])at.dms.compiler.Utils.vectorToArray(catchClauses, JCatchClause.class),
							      finallyClause == null ? getStatementComment() : null);
				VectorCache.release(catchClauses);
			}
			if (finallyClause != null) {
				// If both catch and finally clauses are present,
				// the try-catch is embedded as try clause into a
				// try-finally statement.
				if (self != null) {
				  tryClause = new JBlock(sourceRef, new JStatement[] {self}, null);
				}
				self = new JTryFinallyStatement(sourceRef, tryClause, finallyClause, getStatementComment());
			}
			
			if (self == null) {
				// try without catch or finally: error
				reportTrouble(new PositionedError(sourceRef, "try-nocatch", null));
				self = tryClause;
			}
			
		}
		return self;
	}
	
	public final XAssertStatement  xAssertStatement(
		
	) throws ParserException, IOException {
		XAssertStatement self = null;
		
		
		JExpression		cond;
		JExpression		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(ASSERT);
		match(LPAREN);
		cond=jExpression();
		{
		switch ( LA(1)) {
		case COMMA:
		{
			match(COMMA);
			expr=jExpression();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new XAssertStatement(sourceRef, cond, expr, comments);
		}
		return self;
	}
	
	public final XFailStatement  xFailStatement(
		
	) throws ParserException, IOException {
		XFailStatement self = null;
		
		
		JExpression		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(FAIL);
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			expr=jExpression();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new XFailStatement(sourceRef, expr, comments);
		}
		return self;
	}
	
	public final XExecSqlStatement  xExecSqlStatement(
		
	) throws ParserException, IOException {
		XExecSqlStatement self = null;
		
		
		JExpression		conn = null;
		XSqlExpr		expr = null;
		JExpressionListStatement list = null;
		Vector		types = new Vector();
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(EXECUTE_SQL);
		{
		switch ( LA(1)) {
		case LBRACK:
		{
			conn=xOptionalContext();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			
			expr = new XSqlExpr(sourceRef, mgr.getSQLParser().xSelectIntoStatement(types));
			
		}
		list=jStatementExpressionList();
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			self = new XExecSqlStatement(sourceRef, 
							   conn, 
							   expr, 
							   (CType[])at.dms.compiler.Utils.vectorToArray(types, CType.class),
							   list, 
							   comments); 
			
		}
		return self;
	}
	
	public final XProtectedStatement  xProtectedStatement(
		
	) throws ParserException, IOException {
		XProtectedStatement self = null;
		
		
		JExpression		cont = null;
		JExpression		mess = null;
		JBlock		block;
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(PROTECTED_SQL);
		if ( inputState.guessing==0 ) {
			self = new XProtectedStatement(sourceRef, comments);
		}
		{
		switch ( LA(1)) {
		case LBRACK:
		{
			cont=xOptionalContext();
			break;
		}
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			mess=jExpression();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		block=jBlock();
		if ( inputState.guessing==0 ) {
			self.close(mess, cont, block);
		}
		return self;
	}
	
	public final XUnprotectedStatement  xUnprotectedStatement(
		
	) throws ParserException, IOException {
		XUnprotectedStatement self = null;
		
		
		JExpression		cont = null;
		JExpression		mess = null;
		JBlock		block;
		TokenReference	sourceRef = buildTokenReference();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(UNPROTECTED_SQL);
		if ( inputState.guessing==0 ) {
			self = new XUnprotectedStatement(sourceRef, comments);
		}
		{
		switch ( LA(1)) {
		case LBRACK:
		{
			cont=xOptionalContext();
			break;
		}
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			mess=jExpression();
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RPAREN);
		block=jBlock();
		if ( inputState.guessing==0 ) {
			self.close(mess, cont, block);
		}
		return self;
	}
	
	public final void jTypeDeclaration(
		CParseCompilationUnitContext context
	) throws ParserException, IOException {
		
		
		int			mods = 0;
		JTypeDeclaration	decl = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_abstract:
		case LITERAL_class:
		case LITERAL_final:
		case LITERAL_interface:
		case LITERAL_native:
		case LITERAL_private:
		case LITERAL_protected:
		case LITERAL_public:
		case LITERAL_static:
		case LITERAL_synchronized:
		case LITERAL_transient:
		case LITERAL_volatile:
		case CURSOR_SQL:
		{
			{
			mods=jModifiers();
			{
			switch ( LA(1)) {
			case LITERAL_class:
			{
				decl=jClassDeclaration(mods);
				break;
			}
			case LITERAL_interface:
			{
				decl=jInterfaceDeclaration(mods);
				break;
			}
			case CURSOR_SQL:
			{
				decl=xCursorDeclaration(mods);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( inputState.guessing==0 ) {
				context.addTypeDeclaration(decl);
			}
			}
			break;
		}
		case SEMI:
		{
			match(SEMI);
			if ( inputState.guessing==0 ) {
				reportTrouble(new CWarning(sourceRef, "stray-semicolon", null));
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
	}
	
	public final int  jModifiers(
		
	) throws ParserException, IOException {
		int self = 0;
		
		
		int		mod;
		
		
		{
		_loop143:
		do {
			if ((_tokenSet_21.member(LA(1)))) {
				mod=jModifier();
				if ( inputState.guessing==0 ) {
					
						// !!! warning/error if ((mod & self) != 0)
						self += mod;
					
				}
			}
			else {
				break _loop143;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final XExecSqlExpression  xExecSqlExpression(
		
	) throws ParserException, IOException {
		XExecSqlExpression self = null;
		
		
		JExpression		conn = null;
		JExpression		cursor = null;
		XSqlExpr		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case UPDATE_SQL:
		{
			match(UPDATE_SQL);
			break;
		}
		case DELETE_SQL:
		{
			match(DELETE_SQL);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LBRACK:
		{
			conn=xOptionalContext();
			break;
		}
		case LCURLY:
		case LPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			match(LPAREN);
			cursor=jExpression();
			match(RPAREN);
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			
			expr = new XSqlExpr(sourceRef, mgr.getSQLParser().xAnyStatement());
			
		}
		if ( inputState.guessing==0 ) {
			self = new XExecSqlExpression(sourceRef, conn, cursor, expr);
		}
		return self;
	}
	
	public final void xExplicitCursorBody(
		CParseClassContext context
	) throws ParserException, IOException {
		
		
		CType			type;
		JVariableDefinition	field;
		TokenReference	sourceRef = buildTokenReference();
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		match(LCURLY);
		{
		int _cnt117=0;
		_loop117:
		do {
			if ((_tokenSet_2.member(LA(1)))) {
				type=jType();
				field=jVariableDeclarator(XConstants.ACC_CURSOR | XConstants.ACC_PUBLIC, type);
				match(SEMI);
				if ( inputState.guessing==0 ) {
					context.addFieldDeclaration(new XCursorFieldDeclaration(sourceRef, field, javadoc, comments));
				}
			}
			else {
				if ( _cnt117>=1 ) { break _loop117; } else {throw new NoViableAltException(LT(1));}
			}
			
			_cnt117++;
		} while (true);
		}
		match(RCURLY);
	}
	
	public final XSelectStatement  xImplicitCursorBody(
		CParseClassContext context
	) throws ParserException, IOException {
		XSelectStatement sel = null;
		
		
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			
			sel = mgr.getSQLParser().xSelectStatement();
			
		}
		return sel;
	}
	
	public final JExpression  xOptionalContext(
		
	) throws ParserException, IOException {
		JExpression self;
		
		
		match(LBRACK);
		self=jExpression();
		match(RBRACK);
		return self;
	}
	
	public final JFormalParameter  jFormalParameter(
		int desc
	) throws ParserException, IOException {
		JFormalParameter self = null;
		
		Token  ident = null;
		
		boolean		isFinal = false;
		int			bounds = 0;
		CType			type;
		String		name = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_final:
		{
			match(LITERAL_final);
			if ( inputState.guessing==0 ) {
				isFinal = true;
			}
			break;
		}
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case IDENT:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		type=jType();
		{
		switch ( LA(1)) {
		case IDENT:
		{
			ident = LT(1);
			match(IDENT);
			if ( inputState.guessing==0 ) {
				name = ident.getText();
			}
			break;
		}
		case COMMA:
		case LBRACK:
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		{
		_loop114:
		do {
			if ((LA(1)==LBRACK)) {
				match(LBRACK);
				match(RBRACK);
				if ( inputState.guessing==0 ) {
					bounds += 1;
				}
			}
			else {
				break _loop114;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			if (bounds > 0) {
				reportTrouble(new CWarning(sourceRef, "old-style-array-bounds", null));
				type = new CArrayType(type, bounds);
			}
			
			self = new XFormalParameter(sourceRef, desc, type, name, isFinal);
			
		}
		return self;
	}
	
	public final JExpression  xExpressionInSql(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		self=jExpression();
		match(RPAREN);
		return self;
	}
	
	public final JExpressionListStatement  jStatementExpressionList(
		
	) throws ParserException, IOException {
		JExpressionListStatement self = null;
		
		
		JExpression		expr;
		Vector		v = VectorCache.request(VectorCache.SMALL);
		TokenReference	sourceRef = buildTokenReference();
		
		
		expr=jStatementExpression();
		if ( inputState.guessing==0 ) {
			v.addElement(expr);
		}
		{
		_loop254:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				expr=jStatementExpression();
				if ( inputState.guessing==0 ) {
					v.addElement(expr);
				}
			}
			else {
				break _loop254;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			self = new JExpressionListStatement(sourceRef, 
								  (JExpression[])at.dms.compiler.Utils.vectorToArray(v, JExpression.class), 
								  getStatementComment()); 
			VectorCache.release(v);
			
		}
		return self;
	}
	
	public final JCompilationUnit  jCompilationUnit() throws ParserException, IOException {
		JCompilationUnit self = null;
		
		
		TokenReference		sourceRef = buildTokenReference();
		JPackageName			pack = JPackageName.UNNAMED;
		CParseCompilationUnitContext	context = CParseCompilationUnitContext.getInstance();
		
		
		{
		switch ( LA(1)) {
		case LITERAL_package:
		{
			pack=jPackageDeclaration();
			break;
		}
		case EOF:
		case LITERAL_abstract:
		case LITERAL_class:
		case LITERAL_final:
		case LITERAL_import:
		case LITERAL_interface:
		case LITERAL_native:
		case LITERAL_private:
		case LITERAL_protected:
		case LITERAL_public:
		case LITERAL_static:
		case LITERAL_synchronized:
		case LITERAL_transient:
		case LITERAL_volatile:
		case SEMI:
		case CURSOR_SQL:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		if ( inputState.guessing==0 ) {
			context.setPackage(pack);
		}
		jDefaultImport(context);
		{
		_loop135:
		do {
			if ((LA(1)==LITERAL_import)) {
				jImportDeclaration(context);
			}
			else {
				break _loop135;
			}
			
		} while (true);
		}
		{
		_loop137:
		do {
			if ((_tokenSet_22.member(LA(1)))) {
				jTypeDeclaration(context);
			}
			else {
				break _loop137;
			}
			
		} while (true);
		}
		match(Token.EOF_TYPE);
		if ( inputState.guessing==0 ) {
			
			self = new JCompilationUnit(sourceRef, 
				                      pack,
						      context.getPackageImports(),
						      context.getClassImports(),
						      context.getTypeDeclarations());
			context.release();
			
		}
		return self;
	}
	
	public final JPackageName  jPackageDeclaration(
		
	) throws ParserException, IOException {
		JPackageName self = null;
		
		
		String	name = null;
		
		
		match(LITERAL_package);
		name=jName();
		match(SEMI);
		if ( inputState.guessing==0 ) {
			self = new JPackageName(buildTokenReference(), name, getStatementComment());
		}
		return self;
	}
	
	public final void jImportDeclaration(
		CParseCompilationUnitContext cunit
	) throws ParserException, IOException {
		
		
		String	name = null;
		boolean	star = false;
		
		
		match(LITERAL_import);
		name=jName();
		{
		switch ( LA(1)) {
		case DOT:
		{
			match(DOT);
			match(STAR);
			if ( inputState.guessing==0 ) {
				star = true;
			}
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(SEMI);
		if ( inputState.guessing==0 ) {
			
			if (star) {
				cunit.addPackageImport(new JPackageImport(buildTokenReference(), name, getStatementComment()));
			} else {
				cunit.addClassImport(new JClassImport(buildTokenReference(), name, getStatementComment()));
			}
			
		}
	}
	
	public final int  jModifier(
		
	) throws ParserException, IOException {
		int self = 0;
		
		
		switch ( LA(1)) {
		case LITERAL_public:
		{
			match(LITERAL_public);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PUBLIC;
			}
			break;
		}
		case LITERAL_protected:
		{
			match(LITERAL_protected);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PROTECTED;
			}
			break;
		}
		case LITERAL_private:
		{
			match(LITERAL_private);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_PRIVATE;
			}
			break;
		}
		case LITERAL_static:
		{
			match(LITERAL_static);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_STATIC;
			}
			break;
		}
		case LITERAL_abstract:
		{
			match(LITERAL_abstract);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_ABSTRACT;
			}
			break;
		}
		case LITERAL_final:
		{
			match(LITERAL_final);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_FINAL;
			}
			break;
		}
		case LITERAL_native:
		{
			match(LITERAL_native);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_NATIVE;
			}
			break;
		}
		case LITERAL_synchronized:
		{
			match(LITERAL_synchronized);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_SYNCHRONIZED;
			}
			break;
		}
		case LITERAL_transient:
		{
			match(LITERAL_transient);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_TRANSIENT;
			}
			break;
		}
		case LITERAL_volatile:
		{
			match(LITERAL_volatile);
			if ( inputState.guessing==0 ) {
				self = at.dms.kjc.Constants.ACC_VOLATILE;
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final void jClassBody(
		CParseClassContext context
	) throws ParserException, IOException {
		
		
		match(LCURLY);
		{
		_loop150:
		do {
			switch ( LA(1)) {
			case LITERAL_abstract:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_class:
			case LITERAL_double:
			case LITERAL_final:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_interface:
			case LITERAL_long:
			case LITERAL_native:
			case LITERAL_private:
			case LITERAL_protected:
			case LITERAL_public:
			case LITERAL_short:
			case LITERAL_static:
			case LITERAL_synchronized:
			case LITERAL_transient:
			case LITERAL_void:
			case LITERAL_volatile:
			case LCURLY:
			case IDENT:
			case LITERAL_date:
			case LITERAL_fixed:
			case LITERAL_month:
			case LITERAL_time:
			case CURSOR_SQL:
			{
				jClassBodyDeclaration(context);
				break;
			}
			case SEMI:
			{
				match(SEMI);
				if ( inputState.guessing==0 ) {
					reportTrouble(new CWarning(buildTokenReference(), "stray-semicolon", null));
				}
				break;
			}
			default:
			{
				break _loop150;
			}
			}
		} while (true);
		}
		match(RCURLY);
	}
	
	public final void jClassBodyDeclaration(
		CParseClassContext context
	) throws ParserException, IOException {
		
		
		int			mods = 0;
		JClassBlock		block = null;
		
		
		if ((_tokenSet_23.member(LA(1))) && (_tokenSet_24.member(LA(2)))) {
			mods=jModifiers();
			{
			if ((LA(1)==IDENT) && (LA(2)==LPAREN)) {
				jConstructorDeclaration(context, mods);
			}
			else if ((_tokenSet_2.member(LA(1))) && (_tokenSet_13.member(LA(2)))) {
				jTypeMemberDeclaration(context, mods);
			}
			else if ((_tokenSet_16.member(LA(1)))) {
				jInnerTypeDeclaration(context, mods);
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			
			}
		}
		else if ((LA(1)==LITERAL_static) && (LA(2)==LCURLY)) {
			match(LITERAL_static);
			block=jClassBlock();
			if ( inputState.guessing==0 ) {
				
				block.setStatic(true);
				context.addBlockInitializer(block); 
				
			}
		}
		else if ((LA(1)==LCURLY)) {
			block=jClassBlock();
			if ( inputState.guessing==0 ) {
				context.addBlockInitializer(block);
			}
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
	}
	
	public final void jConstructorDeclaration(
		CParseClassContext context, int mods
	) throws ParserException, IOException {
		
		Token  ident = null;
		
		JFormalParameter[]	parameters;
		CClassType[]		throwsList = CClassType.EMPTY;
		Vector		body = VectorCache.request(VectorCache.BIG);
		JStatement		stmt;
		TokenReference	sourceRef = buildTokenReference();
		JJavadocComment	javadoc = getJavadocComment();
		JavaStyleComment[]	comments = getStatementComment();
		
		
		ident = LT(1);
		match(IDENT);
		parameters=jFormalParameters(JLocalVariable.DES_PARAMETER);
		{
		switch ( LA(1)) {
		case LITERAL_throws:
		{
			match(LITERAL_throws);
			throwsList=jNameList();
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(LCURLY);
		{
		boolean synPredMatched173 = false;
		if (((LA(1)==LITERAL_super||LA(1)==LITERAL_this) && (LA(2)==LPAREN))) {
			int _m173 = mark();
			synPredMatched173 = true;
			inputState.guessing++;
			try {
				{
				jExplicitConstructorInvocation();
				}
			}
			catch (ParserException pe) {
				synPredMatched173 = false;
			}
			rewind(_m173);
			inputState.guessing--;
		}
		if ( synPredMatched173 ) {
			stmt=jExplicitConstructorInvocation();
			if ( inputState.guessing==0 ) {
				body.addElement(stmt);
			}
		}
		else if ((_tokenSet_25.member(LA(1))) && (_tokenSet_26.member(LA(2)))) {
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
		}
		{
		_loop175:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				stmt=jBlockStatement();
				if ( inputState.guessing==0 ) {
					body.addElement(stmt);
				}
			}
			else {
				break _loop175;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			context.addMethodDeclaration(new JConstructorDeclaration(sourceRef,
										       mods,
										       ident.getText(),
										       parameters,
										       throwsList,
										       new JConstructorBlock(sourceRef, 
													     (JStatement[])at.dms.compiler.Utils.vectorToArray(body, JStatement.class)),
										       javadoc,
										       comments));
			VectorCache.release(body);
			
		}
	}
	
	public final void jTypeMemberDeclaration(
		CParseClassContext context, int mods
	) throws ParserException, IOException {
		
		
		CType			type;
		
		
		type=jType();
		{
		if ((LA(1)==IDENT) && (LA(2)==COLON||LA(2)==LPAREN)) {
			jMethodDeclaration(context, mods, type);
		}
		else if ((LA(1)==IDENT) && (_tokenSet_27.member(LA(2)))) {
			jFieldDeclaration(context, mods, type);
		}
		else {
			throw new NoViableAltException(LT(1));
		}
		
		}
	}
	
	public final JClassBlock  jClassBlock(
		
	) throws ParserException, IOException {
		JClassBlock self = null;
		
		
		Vector		body = VectorCache.request(VectorCache.BIG);
		JStatement		stmt;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LCURLY);
		{
		_loop226:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				stmt=jBlockStatement();
				if ( inputState.guessing==0 ) {
					body.addElement(stmt);
				}
			}
			else {
				break _loop226;
			}
			
		} while (true);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = new JClassBlock(sourceRef, 
						     (JStatement[])at.dms.compiler.Utils.vectorToArray(body, JStatement.class)); 
			VectorCache.release(body);
			
		}
		return self;
	}
	
	public final void jInterfaceBody(
		CParseClassContext context
	) throws ParserException, IOException {
		
		
		match(LCURLY);
		{
		_loop160:
		do {
			switch ( LA(1)) {
			case LITERAL_abstract:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_class:
			case LITERAL_double:
			case LITERAL_final:
			case LITERAL_float:
			case LITERAL_int:
			case LITERAL_interface:
			case LITERAL_long:
			case LITERAL_native:
			case LITERAL_private:
			case LITERAL_protected:
			case LITERAL_public:
			case LITERAL_short:
			case LITERAL_static:
			case LITERAL_synchronized:
			case LITERAL_transient:
			case LITERAL_void:
			case LITERAL_volatile:
			case IDENT:
			case LITERAL_date:
			case LITERAL_fixed:
			case LITERAL_month:
			case LITERAL_time:
			case CURSOR_SQL:
			{
				jInterfaceBodyDeclaration(context);
				break;
			}
			case SEMI:
			{
				match(SEMI);
				if ( inputState.guessing==0 ) {
					reportTrouble(new CWarning(buildTokenReference(), "stray-semicolon", null));
				}
				break;
			}
			default:
			{
				break _loop160;
			}
			}
		} while (true);
		}
		match(RCURLY);
	}
	
	public final void jInterfaceBodyDeclaration(
		CParseClassContext context
	) throws ParserException, IOException {
		
		
		int			mods = 0;
		
		
		mods=jModifiers();
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_short:
		case LITERAL_void:
		case IDENT:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		{
			jTypeMemberDeclaration(context, mods);
			break;
		}
		case LITERAL_class:
		case LITERAL_interface:
		case CURSOR_SQL:
		{
			jInnerTypeDeclaration(context, mods);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
	}
	
	public final void jFieldDeclaration(
		CParseClassContext context, int mods, CType type
	) throws ParserException, IOException {
		
		
		JVariableDefinition	field;
		TokenReference	sourceRef = buildTokenReference();
		
		
		field=jVariableDeclarator(mods, type);
		if ( inputState.guessing==0 ) {
			context.addFieldDeclaration(new JFieldDeclaration(sourceRef, field, getJavadocComment(),
										getStatementComment()));
		}
		{
		_loop178:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				field=jVariableDeclarator(mods, type);
				if ( inputState.guessing==0 ) {
					context.addFieldDeclaration(new JFieldDeclaration(sourceRef, field, getJavadocComment(),
												  getStatementComment()));
				}
			}
			else {
				break _loop178;
			}
			
		} while (true);
		}
		match(SEMI);
	}
	
	public final JStatement  jExplicitConstructorInvocation(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		JExpression[]		args = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_this:
		{
			match(LITERAL_this);
			args=jArguments();
			match(SEMI);
			if ( inputState.guessing==0 ) {
				self = new JExplicitConstructorInvocation(sourceRef, null, "this", args, getStatementComment());
			}
			break;
		}
		case LITERAL_super:
		{
			match(LITERAL_super);
			args=jArguments();
			match(SEMI);
			if ( inputState.guessing==0 ) {
				self = new JExplicitConstructorInvocation(sourceRef, null, "super", args, getStatementComment());
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JArrayInitializer  jArrayInitializer(
		
	) throws ParserException, IOException {
		JArrayInitializer self = null;
		
		
		JExpression		expr = null;
		Vector		vect = VectorCache.request(VectorCache.SMALL);
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LCURLY);
		{
		switch ( LA(1)) {
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_double:
		case LITERAL_false:
		case LITERAL_float:
		case LITERAL_int:
		case LITERAL_long:
		case LITERAL_new:
		case LITERAL_null:
		case LITERAL_short:
		case LITERAL_super:
		case LITERAL_this:
		case LITERAL_true:
		case LITERAL_void:
		case BNOT:
		case DEC:
		case INC:
		case LCURLY:
		case LNOT:
		case LPAREN:
		case MINUS:
		case PLUS:
		case CHARACTER_LITERAL:
		case IDENT:
		case INTEGER_LITERAL:
		case REAL_LITERAL:
		case STRING_LITERAL:
		case LITERAL_date:
		case LITERAL_fixed:
		case LITERAL_month:
		case LITERAL_time:
		case DELETE_SQL:
		case UPDATE_SQL:
		{
			expr=jVariableInitializer();
			if ( inputState.guessing==0 ) {
				vect.addElement(expr);
			}
			{
			_loop193:
			do {
				if ((LA(1)==COMMA) && (_tokenSet_28.member(LA(2)))) {
					match(COMMA);
					expr=jVariableInitializer();
					if ( inputState.guessing==0 ) {
						vect.addElement(expr);
					}
				}
				else {
					break _loop193;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case COMMA:
			{
				match(COMMA);
				if ( inputState.guessing==0 ) {
					reportTrouble(new CWarning(sourceRef, "stray-comma", null));
				}
				break;
			}
			case RCURLY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			break;
		}
		case RCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			
			self = new JArrayInitializer(sourceRef, 
							   (JExpression[])at.dms.compiler.Utils.vectorToArray(vect, JExpression.class)); 
			VectorCache.release(vect);
			
		}
		return self;
	}
	
	public final JExpression  jConditionalOrExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		right;
		
		
		self=jConditionalAndExpression();
		{
		_loop201:
		do {
			if ((LA(1)==LOR)) {
				match(LOR);
				right=jConditionalAndExpression();
				if ( inputState.guessing==0 ) {
					self = new JConditionalOrExpression(self.getTokenReference(), self, right);
				}
			}
			else {
				break _loop201;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression  jConditionalAndExpression(
		
	) throws ParserException, IOException {
		JExpression self = null;
		
		
		JExpression		right;
		
		
		self=jInclusiveOrExpression();
		{
		_loop204:
		do {
			if ((LA(1)==LAND)) {
				match(LAND);
				right=jInclusiveOrExpression();
				if ( inputState.guessing==0 ) {
					self = new JConditionalAndExpression(self.getTokenReference(), self, right);
				}
			}
			else {
				break _loop204;
			}
			
		} while (true);
		}
		return self;
	}
	
	public final JExpression[]  jArgumentList(
		
	) throws ParserException, IOException {
		JExpression[] self = null;
		
		
		JExpression		expr;
		Vector		vect = VectorCache.request(VectorCache.SMALL);
		
		
		expr=jExpression();
		if ( inputState.guessing==0 ) {
			vect.addElement(expr);
		}
		{
		_loop214:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				expr=jExpression();
				if ( inputState.guessing==0 ) {
					vect.addElement(expr);
				}
			}
			else {
				break _loop214;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			
			self = (JExpression[])at.dms.compiler.Utils.vectorToArray(vect, JExpression.class);
			VectorCache.release(vect);
			
		}
		return self;
	}
	
	public final JSwitchLabel  jSwitchLabel(
		
	) throws ParserException, IOException {
		JSwitchLabel self = null;
		
		
		JExpression		expr = null;
		TokenReference	sourceRef = buildTokenReference();
		
		
		switch ( LA(1)) {
		case LITERAL_case:
		{
			match(LITERAL_case);
			expr=jExpression();
			match(COLON);
			if ( inputState.guessing==0 ) {
				self = new JSwitchLabel(sourceRef, expr);
			}
			break;
		}
		case LITERAL_default:
		{
			match(LITERAL_default);
			match(COLON);
			if ( inputState.guessing==0 ) {
				self = new JSwitchLabel(sourceRef, null);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
		return self;
	}
	
	public final JStatement  jForInit(
		
	) throws ParserException, IOException {
		JStatement self = null;
		
		
		if ((LA(1)==LITERAL_final)) {
			match(LITERAL_final);
			self=jLocalVariableDeclaration(at.dms.kjc.Constants.ACC_FINAL);
		}
		else {
			boolean synPredMatched251 = false;
			if (((_tokenSet_2.member(LA(1))) && (_tokenSet_13.member(LA(2))))) {
				int _m251 = mark();
				synPredMatched251 = true;
				inputState.guessing++;
				try {
					{
					jType();
					match(IDENT);
					}
				}
				catch (ParserException pe) {
					synPredMatched251 = false;
				}
				rewind(_m251);
				inputState.guessing--;
			}
			if ( synPredMatched251 ) {
				self=jLocalVariableDeclaration(0);
			}
			else if ((_tokenSet_18.member(LA(1))) && (_tokenSet_29.member(LA(2)))) {
				self=jStatementExpressionList();
			}
			else {
				throw new NoViableAltException(LT(1));
			}
			}
			return self;
		}
		
	public final JCatchClause  jCatchClause(
		
	) throws ParserException, IOException {
		JCatchClause self = null;
		
		
		JFormalParameter	param;
		JBlock		body;
		TokenReference	sourceRef = buildTokenReference();
		
		
		match(LITERAL_catch);
		match(LPAREN);
		param=jFormalParameter(JLocalVariable.DES_CATCH_PARAMETER);
		match(RPAREN);
		body=jBlock();
		if ( inputState.guessing==0 ) {
			self = new JCatchClause(sourceRef, param, body);
		}
		return self;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"abstract\"",
		"\"boolean\"",
		"\"break\"",
		"\"byte\"",
		"\"case\"",
		"\"catch\"",
		"\"char\"",
		"\"class\"",
		"\"const\"",
		"\"continue\"",
		"\"default\"",
		"\"do\"",
		"\"double\"",
		"\"else\"",
		"\"extends\"",
		"\"false\"",
		"\"final\"",
		"\"finally\"",
		"\"float\"",
		"\"for\"",
		"\"goto\"",
		"\"if\"",
		"\"implements\"",
		"\"import\"",
		"\"instanceof\"",
		"\"int\"",
		"\"interface\"",
		"\"long\"",
		"\"native\"",
		"\"new\"",
		"\"null\"",
		"\"package\"",
		"\"private\"",
		"\"protected\"",
		"\"public\"",
		"\"return\"",
		"\"short\"",
		"\"static\"",
		"\"super\"",
		"\"switch\"",
		"\"synchronized\"",
		"\"this\"",
		"\"throw\"",
		"\"throws\"",
		"\"transient\"",
		"\"true\"",
		"\"try\"",
		"\"void\"",
		"\"volatile\"",
		"\"while\"",
		"'='",
		"'&'",
		"'&='",
		"'~'",
		"'|'",
		"'|='",
		"'>>>'",
		"'>>>='",
		"'^'",
		"'^='",
		"':'",
		"','",
		"'--'",
		"'.'",
		"'=='",
		"'>='",
		"'>'",
		"'++'",
		"'&&'",
		"'['",
		"'{'",
		"'<='",
		"'!'",
		"'||'",
		"'('",
		"'<'",
		"'-'",
		"'-='",
		"'!='",
		"'%'",
		"'%='",
		"'+'",
		"'+='",
		"'?'",
		"']'",
		"'}'",
		"')'",
		"';'",
		"'<<'",
		"'/'",
		"'/='",
		"'<<='",
		"'>>'",
		"'>>='",
		"'*'",
		"'*='",
		"a character literal (inside simple quote)",
		"an identifier",
		"an integer literal",
		"a real literal",
		"a string literal (inside double quote)",
		"\"date\"",
		"\"fixed\"",
		"\"month\"",
		"\"time\"",
		"#assert",
		"#cursor",
		"#delete",
		"#execute",
		"#fail",
		"#protected",
		"#select",
		"#unprotected",
		"#update"
	};
	
	private static final long[] _tokenSet_0_data_ = { 13085867213696224L, 15762530110555268L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long[] _tokenSet_1_data_ = { 0L, 17717264384L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long[] _tokenSet_2_data_ = { 2252902013928608L, 33122787786752L, 0L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long[] _tokenSet_3_data_ = { 2855460156277920L, 9183052395724800L, 0L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long[] _tokenSet_4_data_ = { -15158938084768608L, 9183121115185151L, 0L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	private static final long[] _tokenSet_5_data_ = { 2252902013928608L, 32985348833280L, 0L, 0L };
	public static final BitSet _tokenSet_5 = new BitSet(_tokenSet_5_data_);
	private static final long[] _tokenSet_6_data_ = { 0L, 16904L, 0L, 0L };
	public static final BitSet _tokenSet_6 = new BitSet(_tokenSet_6_data_);
	private static final long[] _tokenSet_7_data_ = { 1152921504606846976L, 4563402752L, 0L, 0L };
	public static final BitSet _tokenSet_7 = new BitSet(_tokenSet_7_data_);
	private static final long[] _tokenSet_8_data_ = { 0L, 34912L, 0L, 0L };
	public static final BitSet _tokenSet_8 = new BitSet(_tokenSet_8_data_);
	private static final long[] _tokenSet_9_data_ = { -162129586316902400L, 68719471615L, 0L, 0L };
	public static final BitSet _tokenSet_9 = new BitSet(_tokenSet_9_data_);
	private static final long[] _tokenSet_10_data_ = { -140772068561422L, 15762598695796735L, 0L, 0L };
	public static final BitSet _tokenSet_10 = new BitSet(_tokenSet_10_data_);
	private static final long[] _tokenSet_11_data_ = { 146970648232133792L, 9183052414668932L, 0L, 0L };
	public static final BitSet _tokenSet_11 = new BitSet(_tokenSet_11_data_);
	private static final long[] _tokenSet_12_data_ = { 146970648232133792L, 9183052397891716L, 0L, 0L };
	public static final BitSet _tokenSet_12 = new BitSet(_tokenSet_12_data_);
	private static final long[] _tokenSet_13_data_ = { 0L, 137438953992L, 0L, 0L };
	public static final BitSet _tokenSet_13 = new BitSet(_tokenSet_13_data_);
	private static final long[] _tokenSet_14_data_ = { 13085866138903776L, 15692161366377604L, 0L, 0L };
	public static final BitSet _tokenSet_14 = new BitSet(_tokenSet_14_data_);
	private static final long[] _tokenSet_15_data_ = { -6093795227500679712L, 15762576322549389L, 0L, 0L };
	public static final BitSet _tokenSet_15 = new BitSet(_tokenSet_15_data_);
	private static final long[] _tokenSet_16_data_ = { 1073743872L, 70368744177664L, 0L, 0L };
	public static final BitSet _tokenSet_16 = new BitSet(_tokenSet_16_data_);
	private static final long[] _tokenSet_17_data_ = { 0L, 17920L, 0L, 0L };
	public static final BitSet _tokenSet_17 = new BitSet(_tokenSet_17_data_);
	private static final long[] _tokenSet_18_data_ = { 2855460156277920L, 9183052395724932L, 0L, 0L };
	public static final BitSet _tokenSet_18 = new BitSet(_tokenSet_18_data_);
	private static final long[] _tokenSet_19_data_ = { -6104025634558114656L, 9183098708383372L, 0L, 0L };
	public static final BitSet _tokenSet_19 = new BitSet(_tokenSet_19_data_);
	private static final long[] _tokenSet_20_data_ = { 146970648232133792L, 9183052397891717L, 0L, 0L };
	public static final BitSet _tokenSet_20 = new BitSet(_tokenSet_20_data_);
	private static final long[] _tokenSet_21_data_ = { 4805351145734160L, 0L };
	public static final BitSet _tokenSet_21 = new BitSet(_tokenSet_21_data_);
	private static final long[] _tokenSet_22_data_ = { 4805352219478032L, 70368878395392L, 0L, 0L };
	public static final BitSet _tokenSet_22 = new BitSet(_tokenSet_22_data_);
	private static final long[] _tokenSet_23_data_ = { 7058254233406640L, 103491531964416L, 0L, 0L };
	public static final BitSet _tokenSet_23 = new BitSet(_tokenSet_23_data_);
	private static final long[] _tokenSet_24_data_ = { 7058254233406640L, 103491531981320L, 0L, 0L };
	public static final BitSet _tokenSet_24 = new BitSet(_tokenSet_24_data_);
	private static final long[] _tokenSet_25_data_ = { 13085867213696224L, 15762530144109700L, 0L, 0L };
	public static final BitSet _tokenSet_25 = new BitSet(_tokenSet_25_data_);
	private static final long[] _tokenSet_26_data_ = { -6089007468542055184L, 15762576322549389L, 0L, 0L };
	public static final BitSet _tokenSet_26 = new BitSet(_tokenSet_26_data_);
	private static final long[] _tokenSet_27_data_ = { 18014398509481984L, 134218242L, 0L, 0L };
	public static final BitSet _tokenSet_27 = new BitSet(_tokenSet_27_data_);
	private static final long[] _tokenSet_28_data_ = { 146970648232133792L, 9183052397892740L, 0L, 0L };
	public static final BitSet _tokenSet_28 = new BitSet(_tokenSet_28_data_);
	private static final long[] _tokenSet_29_data_ = { -6104025634558114656L, 9183098708383374L, 0L, 0L };
	public static final BitSet _tokenSet_29 = new BitSet(_tokenSet_29_data_);
	
	}
