/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XJavaScanner.java,v 1.21 1999/10/08 11:19:12 vgp Exp $
 */

package at.dms.xkjc;

import antlr.Token;
import at.dms.compiler.Compiler;
import at.dms.compiler.InputBuffer;
import at.dms.compiler.PositionedError;

/**
 * This is an handwritten lexer available for speed reason
 */
public class XJavaScanner extends at.dms.kjc.JavaScanner {
  /**
   * Constructor for a file in a char[]
   */
  public XJavaScanner(Compiler compiler, InputBuffer buffer) {
    super(compiler, buffer);
  }

  // Tokens are: Identifiers, Keywords, Literals, Separators, Operators.
  protected Token getToken() throws PositionedError {
    switch (buffer.data[buffer.pos]) {
    case '#': // KOPI ESCAPE
      return getKopiEscape();
    default:
      return super.getToken();
    }
  }

  protected Token getKopiEscape() throws PositionedError {
    int		start = buffer.pos;

    // skip #
    buffer.pos++;

  _all:
    while (true) {
      switch (buffer.data[++buffer.pos]) {
      case 'a':  case 'b':  case 'c':  case 'd':
      case 'e':  case 'f':  case 'g':  case 'h':
      case 'i':  case 'j':  case 'k':  case 'l':
      case 'm':  case 'n':  case 'o':  case 'p':
      case 'q':  case 'r':  case 's':  case 't':
      case 'u':  case 'v':  case 'w':  case 'x':
      case 'y':  case 'z':
	break;
      default:
	break _all;
      }
    }

    Token	tok = lookupKeyword(buffer.data, start, buffer.pos - start);
    if (tok == null) {
      throw new PositionedError(getTokenReference(),
				"x-bad-keyword",
				new String(buffer.data, start, buffer.pos - start));
    }
    return tok;
  }

  protected /*!!!static*/ Token lookupKeyword(char[] data, int start, int length) {
    return XJavaKeywords.lookup(data, start, length);
  }
}
