/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XParseManager.java,v 1.19 1999/10/12 15:39:51 vgp Exp $
 */

package at.dms.xkjc;

import java.io.File;
import java.io.IOException;

import at.dms.kjc.ParseManager;
import at.dms.compiler.HandLexer;
import at.dms.kjc.CHandLexer;
import at.dms.compiler.Compiler;

/**
 * This class manage paser switching between Java and SQL
 */
public class XParseManager extends ParseManager {

  // ----------------------------------------------------------------------
  // CONSTRUCTOR
  // ----------------------------------------------------------------------

  /**
   * This class manage paser switching between Java and SQL
   */
  protected XParseManager(Compiler compiler, File file, String name)
    throws IOException
  {
    super(compiler, file, name);
  }

  /**
   * Factory
   */
  public static XParseManager getXParseManager(Compiler compiler,
					       File file,
					       String name)
    throws IOException
  {
    return new XParseManager(compiler, file, name);
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Returns the java lexer
   */
  public CHandLexer getXJavaLexer() {
    if (xJavaLexer == null) {
      xJavaLexer = new XJavaScanner(compiler, buffer);
    }

    return xJavaLexer;
  }

  /**
   * Returns the java parser
   */
  public XJavaParser getXJavaParser() {
    return new XJavaParser(compiler, this, getXJavaLexer(), buffer.file);
  }

  /**
   * Returns the SQL lexer
   */
  public HandLexer getSQLLexer() {
    if (xSQLLexer == null) {
      xSQLLexer = new XSQLScanner(compiler, buffer);
    }

    return xSQLLexer;
  }

  /**
   * Returns the SQL parser
   */
  public XSQLParser getSQLParser() {
    return new XSQLParser(compiler, this, getSQLLexer(), buffer.file);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  protected CHandLexer			xJavaLexer;
  protected HandLexer			xSQLLexer;
}
