/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XPrimitiveClassType.java,v 1.6 1999/09/09 10:43:45 vgp Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.CType;
import at.dms.kjc.CClassType;

/**
 * This class represents primitive class type
 */
public abstract class XPrimitiveClassType extends at.dms.kjc.CClassNameType {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Construct a class type
   * @param	qualifiedName	the class qualified name of the class
   */
  public XPrimitiveClassType(String qualifiedName) {
    super(qualifiedName);
  }

  static {
    instance = new at.dms.kjc.CType.MethodSignatureParser() {
	// USE THE OPTIMIZED WAYU !!! $$$
      /**
       * Parse a java type signature
       *  Description : Attempts to parse the provided string as if it started with
       *    the Java VM-standard signature for a type.
       */
      public CType parseSignature(String signature, int from, int to) {
	CType type = super.parseSignature(signature, from, to);

	if (type instanceof CClassType) {
	  if (((CClassType)type).getQualifiedName() == "at/dms/xtype/NotNullDate") {
	    return XStdType.PDate;
	  }
	  if (((CClassType)type).getQualifiedName() == "at/dms/xtype/NotNullFixed") {
	    return XStdType.PFixed;
	  }
	  if (((CClassType)type).getQualifiedName() == "at/dms/xtype/NotNullMonth") {
	    return XStdType.PMonth;
	  }
	  if (((CClassType)type).getQualifiedName() == "at/dms/xtype/NotNullTime") {
	    return XStdType.PTime;
	  }
	}

	return type;
      }
    };
  }

  /**
   * Check if a type is a class type
   * @return is it a subtype of ClassType ?
   */
  public boolean isPrimitive() {
    return true;
  }

  // ----------------------------------------------------------------------
  // ABSTRACT METHODS
  // ----------------------------------------------------------------------

  public abstract at.dms.kjc.CClassType getNotNullableClass();
}
