/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XShiftExpression.java,v 1.13 1999/10/08 11:19:13 vgp Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.JShiftExpression;
import at.dms.kjc.JExpression;
import at.dms.kjc.CExpressionContext;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;

/**
 * This class implements '+ - * /' specific operations
 * Plus operand may be String, numbers
 */
public class XShiftExpression extends JShiftExpression {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Construct a node in the parsing tree
   * This method is directly called by the parser
   * @param	where		the line of this node in the source code
   * @param	oper		the operator
   * @param	left		the left operand
   * @param	right		the right operand
   */
  public XShiftExpression(TokenReference where,
			  int oper,
			  JExpression left,
			  JExpression right) {
    super(where, oper, left, right);
  }

  // ----------------------------------------------------------------------
  // CODE CHECKING
  // ----------------------------------------------------------------------

  /**
   * Check expression and evaluate and alter context
   * @param	context		the actual context of analyse
   * @return	a pure java expression including promote node
   * @exception	PositionedError Error catched as soon as possible
   */
  public JExpression checkExpression(CExpressionContext context) throws PositionedError {
    PositionedError	typeError;

    try {
      return super.checkExpression(context);
    } catch (PositionedError e) {
      typeError = e;
    }
    return XUtils.fetchBinaryOverloadedOperator(oper,
						context,
						left,
						right,
						getTokenReference(),
						typeError);
  }
}

