/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: XTypedSqlExpr.java,v 1.13 1999/10/09 10:47:45 vgp Exp $
 */

package at.dms.xkjc;

import at.dms.kjc.CType;
import at.dms.kjc.JExpression;
import at.dms.sqlc.SelectElem;
import at.dms.sqlc.SqlPhylum;
import at.dms.sqlc.SqlContext;
import at.dms.sqlc.SqlVisitor;
import at.dms.compiler.PositionedError;
import at.dms.compiler.TokenReference;

/**
 * This class represents an SqlExpression
 */
public class XTypedSqlExpr extends SelectElem {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   */
  public XTypedSqlExpr(TokenReference ref, SqlPhylum expr, CType type, boolean first) {
    super(ref);
    this.expr = expr;
    this.type = type;
    this.first = first;
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  public SqlPhylum getSql() {
    return expr;
  }

  // --------------------------------------------------------------------
  // ACCEPT VISITORS
  // --------------------------------------------------------------------

  /**
   * Accepts a visitor.
   *
   * @param	visitor			the visitor
   */
  public void accept(SqlVisitor visitor) throws PositionedError {
    expr.accept(visitor);
  }

  // ----------------------------------------------------------------------
  // PRIVATE DATA MEMBERS
  // ----------------------------------------------------------------------

  private SqlPhylum		expr;
  private CType			type;
  private boolean		first;
}
