/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: DBOracleExceptionConverter.java,v 1.7 1999/08/26 20:21:33 graf Exp $
 */

package at.dms.xlib;

import java.sql.SQLException;

public class DBOracleExceptionConverter implements DBExceptionConverter {

  // ----------------------------------------------------------------------
  // CONSTRUCTORS
  // ----------------------------------------------------------------------

  /**
   * Constructor
   */
  public DBOracleExceptionConverter() {
    // add here some informations about driver as needed
  }

  // ----------------------------------------------------------------------
  // ACCESSORS
  // ----------------------------------------------------------------------

  /**
   * Transforms an SQLException into its corresponding kopi DBException
   *
   * @param	from		the SQLException
   * @return	the corresponding kopi DBException
   */
  public DBException convert(SQLException from) {
    switch (from.getErrorCode()) {
    case 60:	// ORA-00060
    case 104:	// ORA-00104
    case 4020:	// ORA-04020
      return new DBDeadLockException(from);

    case 1:	// ORA-00001
    case 2268:	// ORA-02268
    case 2270:	// ORA-02270
    case 2272:	// ORA-02272
    case 2273:	// ORA-02273
    case 2274:	// ORA-02274
    case 2275:  // ORA-02275
      return new DBConstraintException(from);

    default:
      return new DBUnspecifiedException(from);
    }
  }
}
