/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: NotNullDate.java,v 1.2 1999/08/25 18:04:34 graf Exp $
 */

package at.dms.xtype;

/**
 * This class represents kopi date types
 */
public final class NotNullDate extends Date {

  public NotNullDate(String m) {
    this(java.sql.Date.valueOf(m));
  }

  public NotNullDate(java.sql.Date date) {
    super(date);
  }

  public NotNullDate(long millis) {
    super(millis);
  }

  public NotNullDate(int year, int month, int day) {
    super(year, month, day);
  }

  /**
   * Today's date
   */
  public static NotNullDate now() {
    return new NotNullDate(System.currentTimeMillis());
  }

  public static NotNullDate castToNotNull(Date value) {
    return (NotNullDate)value;
  }
}
