/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: NotNullMonth.java,v 1.2 1999/08/25 18:04:34 graf Exp $
 */

package at.dms.xtype;

/**
 * This class represents kopi month types
 */
public final class NotNullMonth extends Month {

  /**
   * Constructs a Month from its String representation
   */
  public NotNullMonth(String m) {
    super(m);
  }

  /**
   * Constructs a Month with a year and a month in this year
   */
  public NotNullMonth(int year, int month) {
    super(year, month);
  }

  /**
   * Constructs a Month with the base date
   * DO NOT USE OUTSIDE OF THE LIBRARIE
   */
  public NotNullMonth(int scalar) {
    super(scalar);
  }

  /**
   * Constructs a Month from the time in millisc since 1904...
   */
  public NotNullMonth(long millis) {
    super(millis);
  }

  /**
   * Constructs a Month from a Date
   */
  public NotNullMonth(Date aDate) {
    super(aDate);
  }

  /**
   * Constructs a Month from a Date
   */
  public NotNullMonth(java.sql.Date aDate) {
    super(aDate);
  }

  public static NotNullMonth castToNotNull(Month value) {
    return (NotNullMonth)value;
  }
}
