/*
 * Copyright (C) 1990-99 DMS Decision Management Systems Ges.m.b.H.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * $Id: Type.java,v 1.3 1999/08/18 12:27:37 graf Exp $
 */

package at.dms.xtype;

/**
 * This class represents kopi month types
 */
public abstract class Type {

  /**
   * Compares two objects
   */
  public abstract boolean equals(Object other);

  /**
   * Parse the String arguments and return the corresponding value
   * THIS SHOULD BE DEFINED IN ALL SUBCLASSES BUT IT'S STATIC
   */
  //public static Month valueOf(String val) {
  //  throw new RuntimeException();
  //}

  /**
   * Format the object depending on the current language
   */
  public final String toString() {
    return toString(java.util.Locale.GERMAN); // !!!
  }

  /**
   * Format the object depending on the current language
   * @param	locale	the current language
   */
  public abstract String toString(java.util.Locale locale);

  /**
   * Represents the value in sql
   */
  public abstract String toSql();
}
